/*=============================================================================
*
*
=============================================================================*/

/*	Copyright(C) 1997-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define LOW8(x)			((x) & 0xFF)
#define HIGH8(x)		(((x) >> 8) & 0xFF)
#define N2INT(h,l)		((int)(((uchar)(h) << 4) + (uchar)(l)))
#define C2INT(h,l)		((int)(((uchar)(h) << 8) + (uchar)(l)))

#define NUL				'\0'

#define uchar			unsigned char
#define ushort			unsigned short

#define FAIL			0
#define SUCCESS			1

#define NO				0
#define YES				1


#define WM_MOUSEWHEEL95		(WM_USER+1)
#define WM_LBUTTONTRICLK	(WM_USER+2)
#define WM_US_EDIT_CLOSE	(WM_USER+3)
#define WM_CHANGE_TOP		(WM_USER+4)


#define REGISTORY_VER	90		/* ݒf[^̃o[W */

#define TIMER_EDITWAIT	1		/* GfB^I҂^C}[ID */


#define LEFT_OFFSET		8

#define TOOLWIN_HEIGHT	28		/* c[o[̍ */

#define EDITOR_OPT_LEN	20

#define	HISTORY_MAX		20		/* t@C̃qXg̍ő */
#define DEF_FMENU_ITEMS	5		/* Filej[ɂ鍀ڐ̏l */

#define ONELINE_MAXLEN	260		/* Ps̐܂Ԃ̍ől */


#define LINETBLMAX		1000	/* P̍s擪ʒuf[^e[uɃZbgłs */

#define ATTRDATAMAX		50		/* P̃Agr[gf[^e[uɃZbgłf[^̐ */

#define FINDSTR_LEN		80		/* ̒ */
#define FINDHIST_NUM	10		/* ̃qXǧ */

#define FOUNDDATAMAX	50		/* P̌ʃf[^e[uɃZbgłf[^ */

#define QUOTE_MAXLEN	20		/* p̍ő咷 */

#define ATTR_REGION		0x80000000
#define ATTR_UNDER		0x40000000
#define ATTR_BOLD		0x20000000


#define EXT_SET_NUM		10
#define EXT_NAME_LEN	40
#define EXT_EXT_LEN		500

#define BUFFER_MARGIN	3



#define OPT_SJIS		0x0001
#define OPT_JIS			0x0002
#define OPT_EUC			0x0004



#define CHAR_HAN_ALPHA	-1		/* pAt@xbg */
#define CHAR_ZEN_ALPHA	-2		/* SpAt@xbg */
#define CHAR_ZEN_HIRA	-3		/* SpЂ炪 */
#define CHAR_ZEN_KATA	-4		/* SpJ^Ji */
#define CHAR_ZEN_CHOU	-5		/* Sp */
#define CHAR_ZEN_KANJI	-6		/* Sp */
#define CHAR_ZEN_OTHER	-7		/* ̑̑Sp */

#define CRLF		"\015\012"
#define LFCR		"\012\015"
#define CR			(char)'\015'
#define LF			(char)'\012'
#define TAB			(char)'\011'
#define SPACE		(char)' '
#define ESC			(char)'\x01b'

/* R[hZbg */
#define CODE_AUTO	-1
#define CODE_SJIS	0
#define CODE_JIS	1
#define CODE_EUC	2
#define CODE_UNICODE	3
#define CODE_UTF8	4
#define CODE_UTF7	5
#define CODE_UNICODEBE	6
#define CODE_CODEMAX	7

#define READFROM_NONE	-1		/* ǂݍłȂ */
#define READFROM_FILE	0		/* t@Cǂݍ */
#define READFROM_CBOARD	1		/* Nbv{[hǂݍ */
#define READFROM_STDIN	2		/* W͂ǂݍ */

#define UI_WINDOWS		0		/* Windows@ */
#define UI_LESS			1		/* Less@ */
#define UI_DOS			2		/* DOS@ */
#define UI_WINDOWS2		3		/* Windows@ */

#define ID_NONE			0
#define ID_URL			1
#define ID_MAIL_ADDRESS	2


/*=====  =====*/

#define DIST_FORWARD	0
#define DIST_BACKWARD	1


/*===== WXg̃^Cv =====*/

#define REGTYPE_REG		0		/* WXg */
#define REGTYPE_INI		1		/* INIt@C */

#define REG_SECT_MAX	(16*1024)	/* WXĝPZNV̍őf[^TCY */


/*===== sԍ̃^Cv =====*/

#define LINENUM_WP		0		/* ܂Ԃ܂łPsƐ */
#define LINENUM_EDITOR	1		/* sR[h܂łPs𐔂 */


/*===== Agr[g =====*/

typedef struct {
	char *AttrPos;				/* C̊Jnʒu */
	int AttrLen;				/* C̒ */
	int AttrData;				/* Cf[^ */
} TEXTATTR;


/*===== Agr[gf[^e[u =====*/

typedef struct attrtbl {
	int AttrNum;				/* C̐ */
	TEXTATTR Attr[ATTRDATAMAX];	/* f[^ */
	struct attrtbl *Next;
} ATTRTBL;


/*===== s擪ʒuf[^ =====*/

typedef struct linetoptbl {
	int Lines;					/* s */
	char *LineTop[LINETBLMAX];	/* 擪ʒuf[^(LINETBLMAXs) */
	int LineNum[LINETBLMAX];	/* _sԍis܂łPsƂĐj */
	struct linetoptbl *Next;
} LINETOPTBL;


/*===== f[^ =====*/

typedef struct {
	char Str[FINDSTR_LEN+1];	/*  */
	int CapsFlg;				/* 啶/ʂ邩ǂ (YES/NO) */
	int Regexp;					/* K\ (YES/NO) */
} FINDDLGDATA;


/*===== ʃf[^ =====*/

typedef struct founddata {
	char *Pos;		/* ʒu */
	int Len;		/*  */
} FOUNDDATA;


/*===== ʃf[^e[u =====*/

typedef struct foundtbl {
	int StrNum;						/*  */
	FOUNDDATA Find[FOUNDDATAMAX];	/* ʒu */
	struct foundtbl *Next;
} FOUNDTBL;


/*===== t@CǗf[^ =====*/

typedef struct filemantbl {
	char Fname[MAX_PATH+1];			/* t@C */
	int ReadFrom;					/* t@Cǂݍݐ (READFROM_xxx) */
	int Kanji;						/* R[h (KANJI_xxx) */
	char *TextData;					/* eLXgf[^ */
	int TextSize;					/* eLXgf[^̃TCY */
	int TextLines;					/* \C */
	LINETOPTBL *LineData;			/* s擪ʒuf[^ */
	ATTRTBL *AttrData;				/* Agr[gf[^ */
	int DispTopLine;				/* ݂̕\擪s */
	int DispTopColumn;				/* ݂̕\擪 */
	int SbarStep;					/* XN[o[̈ړXebv (1`) */
	int FindStrLen;					/* ̒ (0=ĂȂ) */
	char FindStr[FINDSTR_LEN+1];	/*  */
	FOUNDTBL *FoundTbl;				/* ʃe[u */
	int RgnSelecting;				/* ͈͎w蒆tO (YES/NO) */
	char *RgnStartPos;				/* ͈͎wJnAhX */
	char *RgnEndPos;				/* ͈͎w薖AhX */
	struct filemantbl *Next;
} FILEMANTBL;


/*===== gqʐݒ =====*/

typedef struct extset {
	char Name[EXT_NAME_LEN+1];		/* O */
	char Exts[EXT_EXT_LEN+1];		/* gqi}`XgOj */
	int TabWidth;					/* ^u */
	int FoldPos;					/* ܂Ԃʒu */
	int LineSpace;					/* s */
	int CrMark;						/* s\ (YES/NO) */
	LOGFONT Font;					/* tHg */
	COLORREF TextColor;				/* F */
	COLORREF HighColor;				/* F */
	COLORREF BackColor;				/* wiF */
	COLORREF CtrlColor;				/* s/䕶F */
	COLORREF FindColor;				/* ̔wiF */
	int LineNumDisp;				/* sԍ̕\ (YES/NO) */
	int LineNumType;				/* sԍ̕\@ (LINENUM_xxx) */
	int FoldRight;					/* E[Ő܂Ԃ (YES/NO) */
} EXTSET;


/*===== WI{^̐ݒ =====*/

typedef struct {
	int ButID;			/* {^ID */
	int Value;			/* l */
} RADIOBUTTON;


/*===== R[hϊpPbg =====*/

typedef struct {
	char *Str;			/*  */
	int StrLen;			/* ̒ */
	int KanaCnv;		/* pJ^JiSpɕϊ邩ǂ (YES/NO) */
	char *Buf;			/* ϊ̕i[obt@ */
	int BufSize;		/* ϊ̕i[obt@̃TCY */
	int OutLen;			/* ϊ̃̕TCY */
	int KanjiMode;		/* [htO(YES/NO) (p[N) */
	int EscProc;		/* GXP[vV[PX (0`) (p[N) */
	char EscCode[2];	/* GXP[vV[PXۑp (p[N) */
	char KanjiFst;		/* R[hPoCgڕۑp (p[N) */
} CODECONVINFO;


/*===== GfB^I҂`FbNpf[^ =====*/

typedef struct editwait_struc {
	HANDLE hProc;					/* GfB^̃vZXnh */
	HWND hWnd;						/* I|̃bZ[W𑗂EChE */
	int EndMesg;					/* I|̃bZ[W */
	WPARAM wParam;					/* Iɑ郁bZ[WwParaml */
	LPARAM lParam;					/* Iɑ郁bZ[WlParaml */
	struct editwait_struc *Next;	/* ̃f[^ւ̃N */
} EDITWAIT;




/*===== main.c =====*/

HINSTANCE GetProgInst(void);
HWND GetMainHwnd(void);
char *AskHelpFilePath(void);
EXTSET *AskCurExtSet(void);
int AskCurExtSetNum(void);
void SetCurExtNum(void);
int AskFixedPitchFont(void);
void RingErrorBell(void);
void DispErrorBox(char *szFormat,...);

//by yhatley
void ProcessMessage(void);
int GetFileExtSetNum(FILEMANTBL *pFileTbl);
EXTSET *AskFileExtSet(int SetNum);

/*===== fileacc.c =====*/
char *GetLineTopFromAdrs(FILEMANTBL *Tbl, char *Text);
int GetLineNumFromAdrs(FILEMANTBL *Tbl, char *Text);
int AddFileData(FILEMANTBL **Anchor);
int RemoveFileData(FILEMANTBL **Anchor, int Num);
FILEMANTBL *AskFileData(FILEMANTBL **Anchor, int Num);
FILEMANTBL *AskCurFileTbl(void);
void OpenViewFromFile(char *Fname, int TopLine, int Kanji, int KeepSet);
void ReopenViewFromFile(int Kanji);
void OpenViewFromClipBoard(int TopLine);
void OpenViewFromStdin(int TopLine);
int MakeLineTopTbl(FILEMANTBL *Tbl);
int GetTabWidth(int TabWid, int Col);
int IsSjis(char ch);
char *GetLineTop(FILEMANTBL *Tbl, int Num);
int GetLineLen(FILEMANTBL *Tbl, int Num);
int GetLogicalLineNum(FILEMANTBL *Tbl, int Num);
int GetLineNumFromLogicalLineNum(FILEMANTBL *Tbl, int Num);
int AskWordTopAndBtm(FILEMANTBL *Tbl, char *Text, char **Top, char **Btm);
int AskPhysLineTopAndBtm(FILEMANTBL *Tbl, char *Text, char **Top, char **Btm);
int SearchText(FILEMANTBL *Tbl, int Num, uchar *Key, int Caps, int Regexp, int ScanDist);
void CancelSearchText(FILEMANTBL *Tbl);
int SearchNextFoundLine(FILEMANTBL *Tbl, int Num);
int SearchPrevFoundLine(FILEMANTBL *Tbl, int Num);
int AskSearched(FILEMANTBL *Tbl);
int AskCurPosFound(FILEMANTBL *Tbl, char *Text);
char *GetNextFoundPos(FILEMANTBL *Tbl, char *Text, int *mLen);
char *GetPrevFoundPos(FILEMANTBL *Tbl, char *Text, int *mLen);
int AskCurPosAttr(FILEMANTBL *Tbl, char *Text, int *Len, int *Attr);
char *GetNextAttrPos(FILEMANTBL *Tbl, char *Text, int *Len, int *Attr);

// by yhatley
void OpenFileOnBuffer(FILEMANTBL *FileTbl, char *Fname);

/*===== registory.c =====*/

void SaveRegistory(void);
int LoadRegistory(char *Hist);
void ClearRegistory(void);

/*===== misc.c =====*/

int InputDialogBox(int Res, HWND hWnd, char *Title, char *Buf, int Max, int *Check);
BOOL CALLBACK ExeEscDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void SetYenTail(char *Str);
void RemoveReturnCode(char *Str);
int AskMultiStrLen(char *Str);
int CountMultiStrNum(char *Mul);
int InsertStrToMultiStr(char *Str, char *Mul, int BufSize);
int DeleteStrFromMultiStr(char *Str, char *Mul);
int DeleteNumFromMultiStr(int Num, char *Mul);
int AskStrLenLFtoCRLF(char *Str, int Len, char *Quote);
void CopyStrLFtoCRLF(char *Buf, char *Str, int Len, char *Quote);
char *GetFileName(char *Path);
char *GetFileExt(char *Path);
void RemoveFileName(char *Path, char *Buf);
int SelectFileToOpen(HWND hWnd, char *Fname, char *Title, char *Filters);
int SelectFileToSave(HWND hWnd, char *Fname, char *Title, char *Filters);
HFONT SelectListFont(HWND hWnd, HFONT hFont, LOGFONT *lFont);
void SetRadioButtonByValue(HWND hDlg, int Value, const RADIOBUTTON *Buttons, int Num);
int AskRadioButtonValue(HWND hDlg, const RADIOBUTTON *Buttons, int Num);
void DoPrintf(char *szFormat, ...);
int max1(int n, int m);
int min1(int n, int m);
int IsURL( const char *pszLine, int nLineLen, int *pnMatchLen );
int IsMailAddress( const char* pszBuf, int nBufLen, int* pnAddressLenfth );
HCURSOR GetFingerCursor(void);

/*===== option.c =====*/

int SetOption(HWND hWnd);

/*===== codecnv.c =====*/

void InitCodeConvInfo(CODECONVINFO *cInfo);
int FlushRestData(CODECONVINFO *cInfo);
int ConvEUCtoSJIS(CODECONVINFO *cInfo);
int ConvJIStoSJIS(CODECONVINFO *cInfo);
int ConvUTF8toSJIS(CODECONVINFO *cInfo);
int ConvUnicodetoSJIS(CODECONVINFO *cInfo);
int DecodeUTF8toUnicode( const unsigned char* pData, int nUTF8Bytes, unsigned char* pDes );
int MemUnicodeToSJIS( char** ppBufSJIS, const char*pBuf, int nBufLen );
const char* MemCharNext( const char* pData, int nDataLen, const char* pDataCurrent );

//int CheckKanjiCode(char *Text, int Size, int Pref);
int CheckKanjiCode( const unsigned char* pBuf, int nBufLen );

BOOL _IS_SJIS_1(unsigned int ch);
BOOL _IS_SJIS_2(unsigned int ch);
int IsZenHiraOrKata( unsigned short usSrc );
int IsEUCKan1( unsigned char c );
int IsEUCKan2( unsigned char c );
int IsUnicodeBom( const unsigned char* pBuf, int nBufLen );
int IsBASE64Char( char cData );
int IsUTF8( const unsigned char* pData, int nDataLen );

int CheckKanjiCode_UNICODE( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUNICODECodeNum );
int CheckKanjiCode_UNICODEBE( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUNICODEBECodeNum );
int CheckKanjiCode_SJIS( const unsigned char* pBuf, int nBufLen, int*	pnMojiNum, int* pnSJISCodeNum );
int CheckKanjiCode_EUC( const unsigned char* pBuf, int nBufLen, int*	pnMojiNum, int* pnEUCCodeNum );
int CheckKanjiCode_JIS( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnJISCodeNum );
int CheckKanjiCode_UTF8( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUTF8CodeNum );
int CheckKanjiCode_UTF7( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUTF7CodeNum );

/*===== statuswin.c ===== */

int MakeStatusWindow(HWND hWnd);
HWND GetStatusWinHwnd(void);
int GetStatusWinHeight(void);
void ResizeStatusWin(void);
void DispKanjiCode(int Kanji);
void DispCurrentLineNum(int Pos, int Num);
void DispFileInfo(char *Fname);

/*===== toolmenu.c ===== */

int MakeToolBarWindow(HWND hWnd);
HWND GetToolBarHwnd(void);
HWND GetCurSetWinHwnd(void);
int GetToolBarHeight(void);
void ResizeToolBar(void);
void MakeButtonsHide(void);
void SetKanjiCodeMenu(int Kanji);
void SetCurSetWin(void);
void SetCurSetNumToCurSetWin(void);
void SetMenuAndAccel(int Type);
void RightButtonMenu(int Flag);
void AddFileToHistory(char *Fname);
void SetAllHistoryToMenu(char *Buf, int TopNum, int Max);
void RemoveAllHistoryFromMenu(void);
void GetAllHistoryFromMenu(char *Buf, int Max);
int GetFnameFromHistory(int MenuCmd, char *Buf);

/*===== viewwin.c ===== */

int MakeViewWindow(HWND hWnd);
void DeleteViewWindow(void);
HWND GetViewWinHwnd(void);
HWND GetNumWinHwnd(void);
void ResizeViewWindow(void);
void SetViewBackColor(COLORREF Col);
HBRUSH AskViewBackColor(void);
void SetFontSize(void);
void SetCellSize(void);
int AskCharCellHeight(void);
void SetWindowSize(void);
int AskRegSelected(void);
void SetScrollBar(void);
void SetDispTopWindowMatch(void);
int AskDispFindRev(void);
void DispMousePos(void);
void SetStrToFindHist(char *Str);  // yhatley

/*===== linenumwin.c =====*/

int MakeNumWindow(HWND hWnd);
void DeleteNumWindow(void);
HWND GetNumWinHwnd(void);
void ResizeNumWindow(void);
void ScrollUpDownNum(int Num);
void CalcLineNumWinWidth(void);
int AskNumWinWidth(void);

/*===== edit.c =====*/

void ExecEditor(FILEMANTBL *Tbl, HWND hWndPar, int EndMesg, WPARAM wParam, LPARAM lParam);
int AskEditWait(void);
int ExitAllEditor(int SendMsg);

/*===== wildcard.c =====*/

int CheckFname(char *str, char *regexp);

/*===== regexlib.c =====*/

int RegexInit(void);
void RegexFree(void);
int RegexCompile(char *Pat);
int RegexSearch(char *Top, char *Btm, char **mPos, int *mLen);

/*===== grep.c =====*/
HWND OpenGrepWindow(char *dir);
HWND GetGrepWindow(void);
void SetGrepWindowDefaultSize();


/*===== for BCC =====*/
#ifdef __BORLANDC__	
#define _RPT0(a,b) /**/
#define _RPT1(a,b,c) /**/
#endif
