/*=============================================================================
*
*								t@C̕ҏW
*
=============================================================================*/

/*	Copyright(C) 1996-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <windowsx.h>

#include "resource.h"
#include "common.h"


/*===== vg^Cv =====*/

static char *MakeCommandLine(char *Tool, char *Fname, char *Opt, int Jump);
static int SetEditWaitTable(HANDLE hProc, HWND hWnd, int EndMesg, WPARAM wParam, LPARAM lParam);
static void EraseEditWaitTable(EDITWAIT *Del);
static void CALLBACK EditWaitProc(HWND hWnd, UINT Mesg, UINT TimerID, DWORD Time);

/*===== OQ =====*/

/* ݒl */
extern char EditorName[MAX_PATH+1 - EDITOR_OPT_LEN];
extern char EditOptEUC[EDITOR_OPT_LEN+1];
extern char EditOptJIS[EDITOR_OPT_LEN+1];
extern char EditOptSJIS[EDITOR_OPT_LEN+1];
extern int EditSjisAlways;
extern int EditAndClose;
extern int EditAutoReLoad;

/*===== [Jȃ[N =====*/

static UINT EditTimer = 0;
static EDITWAIT *EwaitTop = NULL;


/*----- GfB^N --------------------------------------------------------
*
*	Parameter
*		FILEMANTBL *Tbl : t@CǗe[u
*		HWND hWndPar : eEChẼEChEnh
*		int EndMesg : ҏWIɐeEChEɑ郁bZ[W
*		WPARAM wParam : ҏWĨbZ[WwParaml
*		LPARAM lParam : ҏWĨbZ[WlParaml
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void ExecEditor(FILEMANTBL *Tbl, HWND hWndPar, int EndMesg, WPARAM wParam, LPARAM lParam)
{
	PROCESS_INFORMATION Info;
	STARTUPINFO Startup;
	char *ComLine;
	char Fname[MAX_PATH+1];
	char *Opt;
	char *Open;
	FILE *Strm;
	int Num;
	int Wait;
	int Sts;

	ComLine = NULL;
	Sts = FAIL;
	Open = Tbl->Fname;
	if((EditSjisAlways == YES) && (Tbl->Kanji != CODE_SJIS))
	{
		Open = NULL;
		if(SelectFileToSave(GetMainHwnd(), Fname, "SHIFT-JISR[hŕۑ", "") == TRUE)
		{
			if((Strm = fopen(Fname, "wt")) != NULL)
			{
				fwrite(Tbl->TextData, Tbl->TextSize, 1, Strm);
				fclose(Strm);
				Open = Fname;
			}
		}
	}

	if(Open != NULL)
	{
		if((Tbl->Kanji == CODE_SJIS) || (EditSjisAlways == YES))
			Opt = EditOptSJIS;
		else if(Tbl->Kanji == CODE_EUC)
			Opt = EditOptEUC;
		else
			Opt = EditOptJIS;

		Num = Tbl->DispTopLine + 1;
		if(AskCurExtSet()->LineNumType == LINENUM_EDITOR)
			Num = GetLogicalLineNum(Tbl, Tbl->DispTopLine) + 1;

		ComLine = MakeCommandLine(EditorName, Open, Opt, Num);
		if(ComLine != NULL)
		{
			memset(&Startup, NUL, sizeof(STARTUPINFO));
			Startup.cb = sizeof(STARTUPINFO);
			Startup.wShowWindow = SW_SHOW;
			if(CreateProcess(NULL, ComLine, NULL, NULL, FALSE, 0, NULL, NULL, &Startup, &Info) == TRUE)
			{
				Sts = SUCCESS;
				if(EditAndClose == YES)
					PostMessage(GetMainHwnd(), WM_CLOSE, 0, 0L);
				else if(EditAutoReLoad == YES)
				{
					Wait = AskEditWait();
					if(SetEditWaitTable(Info.hProcess, hWndPar, EndMesg, wParam, lParam) == SUCCESS)
					{
						if(Wait == NO)
							EditTimer = SetTimer(GetMainHwnd(), TIMER_EDITWAIT, 500, EditWaitProc);
					}
				}
			}

			if(Sts == FAIL)
				MessageBox(hWndPar, ComLine, "ҏWł܂", MB_ICONSTOP | MB_OK);

			free(ComLine);
		}
		else
			MessageBox(hWndPar, "GfB^Nł܂", "ҏWł܂", MB_ICONSTOP | MB_OK);
	}
	else
		MessageBox(hWndPar, "ҏWpt@C܂", "ҏWł܂", MB_ICONSTOP | MB_OK);

	return;
}


/*----- GfB^Np̃R}hC쐬 ----------------------------
*
*	Parameter
*		char *Tool :GfB^̐ݒ蕶
*		char *Fname : ҏWt@C
*		char *Opt : R[hwIvV
*		int Jump : Wvsԍ
*
*	Return Value
*		char *
*			NULL=쐬łȂ
*
*	Note
*		߂ꂽ͕KvȂȂfree()邱
*----------------------------------------------------------------------------*/

static char *MakeCommandLine(char *Tool, char *Fname, char *Opt, int Jump)
{
	char *Buf;
	char *Ret;

	Ret = NULL;

	Buf = malloc(strlen(Tool) + strlen(Fname) + strlen(Opt) + 10 + 2 + 1);
	if(Buf != NULL)
	{
		Ret = Buf;
		while(*Tool != NUL)
		{
			if(*Tool == '$')
			{
				Tool++;
				if(*Tool == NUL)
					break;
				if(*Tool == '$')
					*Buf++ = '$';
				else if(toupper(*Tool) == 'F')
				{
					if(strchr(Fname, ' ') != NULL)
						*Buf++ = 0x22;		/* _uNI[g */
					strcpy(Buf, Fname);
					Buf = strchr(Buf, NUL);
					if(strchr(Fname, ' ') != NULL)
						*Buf++ = 0x22;		/* _uNI[g */
				}
				else if(toupper(*Tool) == 'L')
				{
					sprintf(Buf, "%d", Jump);
					Buf = strchr(Buf, NUL);
				}
				else if(toupper(*Tool) == 'K')
				{
					strcpy(Buf, Opt);
					Buf = strchr(Buf, NUL);
				}
				Tool++;
			}
			else
				*Buf++ = *Tool++;
		}
		*Buf = NUL;
	}
	return(Ret);
}


/*----- I҂ɂȂĂ邩ǂԂ ------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int Xe[^X
*			YES/NO
*----------------------------------------------------------------------------*/

int AskEditWait(void)
{
	int Ret;

	Ret = NO;
	if(EwaitTop != NULL)
		Ret = YES;

	return(Ret);
}


/*----- SĂ̏I҂ --------------------------------------------------
*
*	Parameter
*		int SendMsg : GfB^IbZ[W𑗂邩ǂ (YES/NO)
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int ExitAllEditor(int SendMsg)
{
	if(EditTimer != 0)
		KillTimer(GetMainHwnd(), EditTimer);
	EditTimer = 0;

	while(EwaitTop != NULL)
	{
		if(SendMsg == YES)
			PostMessage(EwaitTop->hWnd, EwaitTop->EndMesg, EwaitTop->wParam, EwaitTop->lParam);
		EraseEditWaitTable(EwaitTop);
	}
	return(SUCCESS);
}


/*----- GfB^I҂f[^e[u쐬 ----------------------------------
*
*	Parameter
*		HANDLE hProc : vZXnh
*		HWND hWnd : IɃbZ[W𑗂EChEnh
*		int EndMesg : Iɑ郁bZ[W
*		WPARAM wParam : Iɑ郁bZ[WwParaml
*		LPARAM lParam : Iɑ郁bZ[WlParaml
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int SetEditWaitTable(HANDLE hProc, HWND hWnd, int EndMesg, WPARAM wParam, LPARAM lParam)
{
	EDITWAIT *Pos;
	EDITWAIT *Prev;
	int Ret;

	Ret = FAIL;
	if((Pos = malloc(sizeof(EDITWAIT))) != NULL)
	{
		if(EwaitTop == NULL)
			EwaitTop = Pos;
		else
		{
			Prev = EwaitTop;
			while(Prev->Next != NULL)
				Prev = Prev->Next;
			Prev->Next = Pos;
		}

		Pos->hProc = hProc;
		Pos->hWnd = hWnd;
		Pos->EndMesg = EndMesg;
		Pos->wParam = wParam;
		Pos->lParam = lParam;
		Pos->Next = NULL;
		Ret = SUCCESS;
	}
	return(Ret);
}


/*----- GfB^I҂f[^폜 ------------------------------------------
*
*	Parameter
*		EDITWAIT *Del : 폜GfB^I҂f[^
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void EraseEditWaitTable(EDITWAIT *Del)
{
	EDITWAIT *Pos;
	EDITWAIT *Prev;

	Prev = NULL;
	Pos = EwaitTop;
	while(Pos != NULL)
	{
		if(Pos == Del)
		{
			if(Prev == NULL)
				EwaitTop = Pos->Next;
			else
				Prev->Next = Pos->Next;
			free(Pos);
			break;
		}
		Prev = Pos;
		Pos = Pos->Next;
	}
	return;
}


/*----- GfB^I҂R[obN֐ --------------------------------------
*
*	Parameter
*		HWND hWnd : ^C}bZ[W̃EChEnh
*		UINT Mesg : WM_TIMERbZ[W
*		UINT TimerID : ^C}hc
*		DWORD Time : ݂̃VXe
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CALLBACK EditWaitProc(HWND hWnd, UINT Mesg, UINT TimerID, DWORD Time)
{
	EDITWAIT *Pos;
	DWORD RetVal;

	KillTimer(hWnd, EditTimer);
	EditTimer = 0;
	Pos = EwaitTop;
	while(Pos != NULL){
		GetExitCodeProcess(Pos->hProc, &RetVal);
		if(RetVal != STILL_ACTIVE){
			PostMessage(Pos->hWnd, Pos->EndMesg, Pos->wParam, Pos->lParam);
			EraseEditWaitTable(Pos);
			break;
		}
		Pos = Pos->Next;
	}

	if(AskEditWait() == YES)
		EditTimer = SetTimer(hWnd, TimerID, 500, EditWaitProc);

	return;
}


