/*=============================================================================
*						sԍ\\EChE
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static LRESULT CALLBACK NumWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static void RePaintNum(HWND hWnd);
static void DispLineNum(HWND hWnd, HDC hDC, int Top, int Btm);

/*===== [Jȃ[N =====*/

static const char NumClassStr[] = "ttPageNumClass";
static HWND hWndNum = NULL;

static int NumWinWidth;

/*===== OQ =====*/

extern HFONT hFontttPage;
extern int LineNum;


/*----- sԍEChE쐬 ------------------------------------------------
*
*	Parameter
*		HWND hWnd : eEChẼEChEnh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int MakeNumWindow(HWND hWnd)
{
	WNDCLASSEX wClass;
	RECT Rect;
	int Sts;

	Sts = FAIL;
	wClass.cbSize        = sizeof(WNDCLASSEX);
	wClass.style         = 0;
	wClass.lpfnWndProc   = NumWndProc;
	wClass.cbClsExtra    = 0;
	wClass.cbWndExtra    = 0;
	wClass.hInstance     = GetProgInst();
	wClass.hIcon         = NULL;
	wClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wClass.hbrBackground = NULL;
	wClass.lpszMenuName  = NULL;
	wClass.lpszClassName = NumClassStr;
	wClass.hIconSm       = NULL;
	RegisterClassEx(&wClass);

	GetClientRect(hWnd, &Rect);

	hWndNum = CreateWindow(NumClassStr, "",
				WS_CHILD | WS_BORDER,
				0, GetToolBarHeight(), AskNumWinWidth()+1, Rect.bottom - GetStatusWinHeight() - GetToolBarHeight() - GetSystemMetrics(SM_CYHSCROLL),
				hWnd, (HMENU)1500, GetProgInst(), NULL);

	if(hWndNum != NULL)
	{
		ShowWindow(hWndNum, SW_SHOW);
		Sts = SUCCESS;
	}

	return(Sts);
}


/*----- sԍEChE폜 ------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DeleteNumWindow(void)
{
	UnregisterClass(NumClassStr, GetProgInst());
	return;
}


/*----- sԍEChẼEChEnhԂ ----------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HWND EChEnh
*----------------------------------------------------------------------------*/

HWND GetNumWinHwnd(void)
{
	return(hWndNum);
}


/*----- sԍEChẼTCYύX̏ ------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*
*	Note
*		CEChEc[o[^Xe[^Xo[r[EChȄ
*		TCYύX邱
*----------------------------------------------------------------------------*/

void ResizeNumWindow(void)
{
	RECT Rect;

	GetClientRect(GetMainHwnd(), &Rect);
	SetWindowPos(hWndNum, NULL, 
		0, 
		GetToolBarHeight(), 
		AskNumWinWidth()+1, 
		Rect.bottom - GetStatusWinHeight() - GetToolBarHeight() - GetSystemMetrics(SM_CYHSCROLL),
		SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOMOVE);
	return;
}


/*----- sԍEChẼbZ[W --------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK NumWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_PAINT :
			RePaintNum(hWnd);
			break;

		default :
			return(DefWindowProc(hWnd, message, wParam, lParam));
	}
    return(0L);
}


/*----- WM_PAINT̏ --------------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void RePaintNum(HWND hWnd)
{
	PAINTSTRUCT ps;
	RECT Rect;

    BeginPaint(hWnd, (LPPAINTSTRUCT) &ps);

	GetClientRect(hWnd, &Rect);

	if(AskCurFileTbl() != NULL)
		DispLineNum(hWnd, ps.hdc, 0, (Rect.bottom - Rect.top + AskCharCellHeight() - 1) / AskCharCellHeight());
	else
		FillRect(ps.hdc, &Rect, AskViewBackColor());

    EndPaint(hWnd, (LPPAINTSTRUCT) &ps);
	return;
}


/*----- sԍ\ --------------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		HDC hDC : foCXReLXg
*			NULL=GetDCŋ߂
*		int Top : \擪sԍ
*		int Btm : \sԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DispLineNum(HWND hWnd, HDC hDC, int Top, int Btm)
{
	HDC InDC;
	HFONT hFontOld;
	int i;
	RECT Rect;
	FILEMANTBL *CurFile;
	char Tmp[30];
	int Num;
	int CellHeight;
	HBRUSH BackBrush;

	InDC = hDC;
	if(InDC == NULL)
		hDC = GetDC(hWnd);

	CurFile = AskCurFileTbl();
	CellHeight = AskCharCellHeight();
	BackBrush = AskViewBackColor();

	/* tHg */
	hFontOld = NULL;
	if(hFontttPage != NULL)
		hFontOld = SelectObject(hDC, hFontttPage);

	/* ̑ */
	GetClientRect(hWnd, &Rect);
	SetBkMode(hDC, OPAQUE);
	SetTextColor(hDC, AskCurExtSet()->TextColor);
	SetBkColor(hDC, AskCurExtSet()->BackColor);
	SetTextAlign(hDC, TA_RIGHT);

	/* sԍ\郋[v */
	Rect.top = Top * CellHeight;
	Rect.left = 0;
	for(i = Top; i < Btm; i++)
	{
		/* 炩ߏ */
		Rect.bottom = Rect.top + CellHeight;
		FillRect(hDC, &Rect, BackBrush);

		if((Num = GetLogicalLineNum(CurFile, CurFile->DispTopLine + i)) != -1)
		{
			if(AskCurExtSet()->LineNumType == LINENUM_WP)
				sprintf(Tmp, "%d", CurFile->DispTopLine + i + 1);
			else
				sprintf(Tmp, "%d", Num + 1);

			Rect.right -= LEFT_OFFSET;
			ExtTextOut(hDC, Rect.right, Rect.top, ETO_CLIPPED, &Rect, Tmp, strlen(Tmp), NULL);
			Rect.right += LEFT_OFFSET;
		}
		Rect.top += CellHeight;
	}

	if(hFontOld != NULL)
		SelectObject(hDC, hFontOld);

	if(InDC == NULL)
		ReleaseDC(hWnd, hDC);

	return;
}


/*----- ㉺XN[ --------------------------------------------------------
*
*	Parameter
*		inr Num : XN[s
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void ScrollUpDownNum(int Num)
{
	RECT Rect;
	RECT UpRect;
	HDC hDC;

	hDC = GetDC(hWndNum);
	GetClientRect(hWndNum, &Rect);
	ScrollDC(hDC, 0, Num * AskCharCellHeight(), &Rect, &Rect, NULL, &UpRect);
	ReleaseDC(hWndNum, hDC);

	RedrawWindow(hWndNum, &UpRect, NULL, RDW_UPDATENOW | RDW_INVALIDATE | RDW_NOINTERNALPAINT);

	return;
}


/*----- sԍEChẺvZ ------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*
*	Note
*		v|[VitHgł5Œ
*----------------------------------------------------------------------------*/

void CalcLineNumWinWidth(void)
{
	HFONT hFontOld;
	FILEMANTBL *CurFile;
	char Tmp[30];
	HDC hDC;
	int Columns;
	SIZE Size;
	int MaxCx;
	int i;

	hDC = GetDC(hWndNum);

	/* tHg */
	hFontOld = NULL;
	if(hFontttPage != NULL)
		hFontOld = SelectObject(hDC, hFontttPage);

	if(AskCurExtSet()->FoldRight == NO)
	{
		Columns = 4;
		CurFile = AskCurFileTbl();
		if(CurFile != NULL)
		{
			sprintf(Tmp, "%d", CurFile->TextLines);
			Columns = max(Columns, (int)strlen(Tmp));
		}
	}
	else
		Columns = 5;

	MaxCx = 0;
	for(i = 0; i <= 9; i++)
	{
		sprintf(Tmp, "%d", i);
		GetTextExtentPoint32(hDC, Tmp, 1, &Size);
		MaxCx = max(MaxCx, Size.cx);
	}
	NumWinWidth = Columns * MaxCx + LEFT_OFFSET * 2;

	if(hFontOld != NULL)
		SelectObject(hDC, hFontOld);

	ReleaseDC(hWndNum, hDC);

	return;
}


/*----- sԍEChẺԂ ----------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int isԍ\Ȃ0j
*----------------------------------------------------------------------------*/

int AskNumWinWidth(void)
{
	return(NumWinWidth * LineNum);
}


