/*=============================================================================
*							õC
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

/* Kazuya NOGUCHI ɂC܂݂܂B */

#define _WIN32_WINNT	0x400

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdarg.h>
#include <zmouse.h>
#include <shlobj.h>

#include <winnls32.h>

#include "common.h"
#include "regexp.h"
#include "resource.h"

/*===== vg^Cv =====*/

static int InitApp(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);
static void DeleteAllObject(void);
static LRESULT CALLBACK ttPageWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static void ExitProc(HWND hWnd);
static void AskWindowSize(void);
static void ResizeWindowProc(void);
static int AnalyzeComLine(char *Str, char *Fname, int *Opt, int *TopLine);
static char *GetToken(char *Str, char *Buf, int Flag);
static void SaveFileAs(FILEMANTBL *Tbl);
static BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);


/*===== [Jȃ[N ======*/

static const char ttPageClassStr[] = "ttPageClass";
static HINSTANCE hInstttPage;

static HWND hWndttPage = NULL;

static int SaveExit = YES;

static int WinNT;

static char HelpPath[MAX_PATH+1];

static UINT puiMsh_MsgMouseWheel;
static UINT puiMsh_MsgScrollLines;

/*===== O[oȃ[N ======*/

HACCEL Accel = NULL;
int ExtSetNum = 2;
int CurExtSet = 0;
HFONT hFontttPage = NULL;
int LineNum;

/* ݒl */
int WinPosX = CW_USEDEFAULT;
int WinPosY = 0;
int WinWidth = CW_USEDEFAULT;
int WinHeight = 0;
int Maximize = NO;

int SaveWinSize = YES;
int SaveWinPos = NO;
int ToolBar = YES;
int StatusBar = YES;
int RegType = REGTYPE_INI;
char QuoteStr[QUOTE_MAXLEN+1] = { ">" };

EXTSET ExtSetTbl[EXT_SET_NUM] = {
	{ "ʐݒ", "", 8, 80, 5, YES,
		{ -15, 0, FALSE, FALSE, FW_NORMAL, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_STRING_PRECIS, CLIP_STROKE_PRECIS, DRAFT_QUALITY, FIXED_PITCH, "FixedSys" },
		RGB(0,0,0), RGB(255,0,0), RGB(255,255,255), RGB(0,0,255), RGB(128,128,128),
		NO, LINENUM_WP, NO	},
	{ "C", "*.c\0*.cpp\0*.h\0*.mak\0*.rc\0", 4, 260, 0, YES,
		{ -15, 0, FALSE, FALSE, FW_NORMAL, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_STRING_PRECIS, CLIP_STROKE_PRECIS, DRAFT_QUALITY, FIXED_PITCH, "FixedSys" },
		RGB(0,0,0), RGB(255,0,0), RGB(255,255,255), RGB(0,0,255), RGB(128,128,128),
		NO, LINENUM_WP, NO	},
};

char EditorName[MAX_PATH+1 - EDITOR_OPT_LEN] = { "notepad $F" };
char EditOptEUC[EDITOR_OPT_LEN+1] = { "" };
char EditOptJIS[EDITOR_OPT_LEN+1] = { "" };
char EditOptSJIS[EDITOR_OPT_LEN+1] = { "" };
int EditSjisAlways = YES;
int EditAndClose = NO;
int EditAutoReLoad = NO;

int UItype = UI_WINDOWS;
int ErrBell = YES;
int FileHist = 5;

FINDDLGDATA FindData = { "", NO , NO};
char FindHist[FINDHIST_NUM*(FINDSTR_LEN+1)+1] = { "" };

int DispCaret = YES;
int MouseCopy = NO; // ǉ
int ClickableMap = NO; // ǉ
int HighlightURL = NO; // ǉ

int GrepWndPortrait = NO;

int SmoothLine = NO;
int SmoothPage = NO;
int SmoothRate = 15;


/*----- C[` --------------------------------------------------------
*
*	Parameter
*		HINSTANCE hInstance : ̃AvP[V̂̃CX^X̃nh
*		HINSTANCE hPrevInstance : ̃AvP[V̒ÕCX^X̃nh
*		LPSTR lpszCmdLine : AvP[VNƂ̃R}hCO|C^
*		int cmdShow : ŏɕ\EChĚ`B
*
*	Return Value
*		int Ō̃bZ[WwParam
*----------------------------------------------------------------------------*/

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG Msg;
	int Ret;

	Ret = FALSE;
	hWndttPage = NULL;
	hInstttPage = hInstance;
	if(InitApp(hInstance, hPrevInstance, lpszCmdLine, cmdShow) == SUCCESS)
	{
		while(GetMessage(&Msg, NULL, 0, 0))
		{
		        // by yhatley
		        if(GetGrepWindow() && IsWindowVisible(GetGrepWindow())
				   && IsDialogMessage(GetGrepWindow(), &Msg)) {
			    /* DialogProcŏꂽ */
			}
			else if(TranslateAccelerator(hWndttPage, Accel, &Msg) == 0)
			{
				TranslateMessage(&Msg);
				DispatchMessage(&Msg);
			}
		}
		Ret = Msg.wParam;
	}
	UnregisterClass(ttPageClassStr, hInstttPage);
	return(Ret);
}


/*----- AvP[V̏ ----------------------------------------------
*
*	Parameter
*		HINSTANCE hInstance : ̃AvP[V̂̃CX^X̃nh
*		HINSTANCE hPrevInstance : ̃AvP[V̒ÕCX^X̃nh
*		LPSTR lpszCmdLine : AvP[VNƂ̃R}hCO|C^
*		int cmdShow : ŏɕ\EChĚ`B
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int InitApp(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	int Sts;
	WNDCLASSEX wClass;
	char Fname[MAX_PATH+1];
	int Opt;
	char *Hist;
	int TopLine;
	int Kanji;

	Sts = FAIL;

	WinNT = YES;
	if(GetVersion() & 0x80000000)
		WinNT = NO;

	if((Hist = malloc((MAX_PATH+1)*HISTORY_MAX+1)) != NULL)
	{
		LoadRegistory(Hist);
		if(SaveWinPos == NO)
		{
			WinPosX = CW_USEDEFAULT;
			WinPosY = 0;
		}
		if(SaveWinSize == NO)
		{
			WinWidth = CW_USEDEFAULT;
			WinHeight = 0;
			Maximize = NO;
		}
		SetViewBackColor(AskCurExtSet()->BackColor);
		LineNum = AskCurExtSet()->LineNumDisp;

//		AllocConsole();

		wClass.cbSize        = sizeof(WNDCLASSEX);
		wClass.style         = 0;
		wClass.lpfnWndProc   = ttPageWndProc;
		wClass.cbClsExtra    = 0;
		wClass.cbWndExtra    = 0;
		wClass.hInstance     = hInstance;
		wClass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(ttpage));
		wClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
		wClass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
		wClass.lpszMenuName  = NULL;
		wClass.lpszClassName = ttPageClassStr;
		wClass.hIconSm       = NULL;
		RegisterClassEx(&wClass);

		if(WinNT == NO)
		{
			puiMsh_MsgMouseWheel = RegisterWindowMessage(MSH_MOUSEWHEEL);
			puiMsh_MsgScrollLines = RegisterWindowMessage(MSH_SCROLL_LINES);
		}

		hWndttPage = CreateWindow(ttPageClassStr, "ttPage",
					WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
					WinPosX, WinPosY, WinWidth, WinHeight,
					HWND_DESKTOP, 0, hInstance, NULL);
		if(hWndttPage != NULL)
		{
			CoInitialize(NULL);
			SetMenuAndAccel(UItype);

			if(ToolBar == YES)
				MakeToolBarWindow(hWndttPage);
			if(StatusBar == YES)
				MakeStatusWindow(hWndttPage);

			MakeNumWindow(hWndttPage);
			MakeViewWindow(hWndttPage);

			GetModuleFileName(NULL, HelpPath, MAX_PATH);
			strcpy(GetFileName(HelpPath), "ttpage.hlp");

			SetAllHistoryToMenu(Hist, 0, FileHist);

			SetFontSize();

			if((cmdShow != SW_MINIMIZE) && (cmdShow != SW_SHOWMINIMIZED) && (cmdShow != SW_SHOWMINNOACTIVE) &&
			   (Maximize == YES))
				cmdShow = SW_MAXIMIZE;

			ShowWindow(hWndttPage, cmdShow);
			WINNLSEnableIME(NULL, FALSE);		/* IME OFF */
			MakeButtonsHide();

			if(AnalyzeComLine(lpszCmdLine, Fname, &Opt, &TopLine) == SUCCESS)
			{
				if(strlen(Fname) != 0)
				{
					if(PathIsDirectory(Fname)) {
						OpenGrepWindow(Fname);
					}
					else {
						if(Opt & OPT_SJIS)
							Kanji = CODE_SJIS;
						else if(Opt & OPT_JIS)
							Kanji = CODE_JIS;
						else if(Opt & OPT_EUC)
							Kanji = CODE_EUC;
						else
							Kanji = CODE_AUTO;
						OpenViewFromFile(Fname, TopLine, Kanji, NO);
					}
				}
				else
					OpenViewFromStdin(TopLine);

				MakeButtonsHide();
				Sts = SUCCESS;
			}
		}
		free(Hist);
	}

	if(Sts == FAIL)
		DeleteAllObject();

	return(Sts);
}


/*----- SẴIuWFNg폜 ----------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DeleteAllObject(void)
{
	if(hWndttPage != NULL)
		DestroyWindow(hWndttPage);
	DeleteNumWindow();
	DeleteViewWindow();
	return;
}


/*----- vÕCX^XԂ ----------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HINSTANCE CX^X
*----------------------------------------------------------------------------*/

HINSTANCE GetProgInst(void)
{
	return(hInstttPage);
}


/*----- CEChẼEChEnhԂ ----------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HWND EChEnh
*----------------------------------------------------------------------------*/

HWND GetMainHwnd(void)
{
	return(hWndttPage);
}


/*----- wvt@C̃pXԂ ------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		char *pX
*----------------------------------------------------------------------------*/

char *AskHelpFilePath(void)
{
	return(HelpPath);
}


/*----- CEChẼbZ[W --------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK ttPageWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char Fname[MAX_PATH+1];
	int TmpTabWidth;
	int TmpFoldPos;
	FILEMANTBL *CurFile;
	LPTOOLTIPTEXT lpttt;
	HWND hdlMsWheel;
	int WheelScroll;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
	char Buf[MAX_PATH+11];
	char *sFname ;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end

	CurFile = AskCurFileTbl();

	if((WinNT == NO) && (message == puiMsh_MsgMouseWheel))
		message = WM_MOUSEWHEEL95;

	switch (message){
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
	case WM_ACTIVATE :
		if( !CurFile )
			break ;
		if(CurFile->ReadFrom != READFROM_FILE)
			break ;				

		switch(LOWORD(wParam)){
		case WA_INACTIVE :
			sFname = _mbsrchr(CurFile->Fname,'\\') ;
			sFname = sFname ? sFname+1 : CurFile->Fname ;
			break ;
		default :
			sFname = CurFile->Fname ;
			break ;
		}
		sprintf( Buf, "%s - ttPage", sFname ) ;
		SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)Buf);
		break ;
//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end

	case WM_COMMAND :
		switch(LOWORD(wParam)){
		case MENU_GREP: { // by yhatley
			char folder[MAX_PATH + 1] = "";
			FILEMANTBL *CurFile = AskCurFileTbl();
			if(CurFile != NULL) {
				strcpy(folder, CurFile->Fname);
				RemoveFileName(folder, folder);
			}
		    OpenGrepWindow(folder);
		    break;
		}
		case MENU_OPEN :
			WINNLSEnableIME(NULL, TRUE);	/* IME ON */
			if(SelectFileToOpen(hWnd, Fname, "J", "SẴt@C\0*\0") == TRUE)
				OpenViewFromFile(Fname, 0, CODE_AUTO, NO);
			WINNLSEnableIME(NULL, FALSE);	/* IME OFF */
			MakeButtonsHide();
			break;

		case MENU_SJIS :
			if(CurFile->Kanji != CODE_SJIS)
				ReopenViewFromFile(CODE_SJIS);
			break;

		case MENU_JIS :
			if(CurFile->Kanji != CODE_JIS)
				ReopenViewFromFile(CODE_JIS);
			break;

		case MENU_EUC :
			if(CurFile->Kanji != CODE_EUC)
				ReopenViewFromFile(CODE_EUC);
			break;

		case MENU_RELOAD :
//			OpenViewFromFile(Fname, 0, CODE_AUTO, NO);
//			MakeButtonsHide();
			ReopenViewFromFile(CODE_SJIS);
			break;

		case MENU_HIST_1 :
		case MENU_HIST_2 :
		case MENU_HIST_3 :
		case MENU_HIST_4 :
		case MENU_HIST_5 :
		case MENU_HIST_6 :
		case MENU_HIST_7 :
		case MENU_HIST_8 :
		case MENU_HIST_9 :
		case MENU_HIST_10 :
		case MENU_HIST_11 :
		case MENU_HIST_12 :
		case MENU_HIST_13 :
		case MENU_HIST_14 :
		case MENU_HIST_15 :
		case MENU_HIST_16 :
		case MENU_HIST_17 :
		case MENU_HIST_18 :
		case MENU_HIST_19 :
		case MENU_HIST_20 :
			if(GetFnameFromHistory(LOWORD(wParam), Fname) == SUCCESS)
				OpenViewFromFile(Fname, 0, CODE_AUTO, NO);
			MakeButtonsHide();
			break;

		case MENU_SAVEAS :
			WINNLSEnableIME(NULL, TRUE);	/* IME ON */
			SaveFileAs(CurFile);
			WINNLSEnableIME(NULL, FALSE);	/* IME OFF */
			break;

		case MENU_PASTE :
			if(DialogBox(hInstttPage, MAKEINTRESOURCE(paste_dlg), hWnd, ExeEscDialogProc) == YES)
			{
				OpenViewFromClipBoard(0);
				MakeButtonsHide();
			}
			break;

		case MENU_REDRAW :
			InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
			InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
			if(CurFile != NULL)
				SetScrollBar();
			break;

		case MENU_DISPSET :
			TmpTabWidth = AskCurExtSet()->TabWidth;
			TmpFoldPos = AskCurExtSet()->FoldPos;
			WINNLSEnableIME(NULL, TRUE);	/* IME ON */
			if(SetOption(hWnd) == YES)
			{
				SetMenuAndAccel(UItype);
				SetCurSetWin();
				if(CurFile != NULL)
				{
					SetCurExtNum();
					LineNum = AskCurExtSet()->LineNumDisp;
					SetViewBackColor(AskCurExtSet()->BackColor);
					SetFontSize();
					SetCellSize();
					/* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
					if(AskCurExtSet()->FoldRight == NO)
					{
						if((AskCurExtSet()->TabWidth != TmpTabWidth) ||
						   (AskCurExtSet()->FoldPos != TmpFoldPos))
						{
							MakeLineTopTbl(CurFile);
							if(CurFile->DispTopLine > CurFile->TextLines-1)
								CurFile->DispTopLine = CurFile->TextLines-1;
						}
					}
					CalcLineNumWinWidth();
					ResizeNumWindow();
					ResizeViewWindow();
					SetWindowSize();
					SetScrollBar();
					DispCurrentLineNum(1, CurFile->DispTopLine);
					DispMousePos();
				}
				InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
				InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
			}
			WINNLSEnableIME(NULL, FALSE);	/* IME OFF */
			break;

		case MENU_EDITOR :
			if(CurFile != NULL)
				ExecEditor(CurFile, hWnd, WM_US_EDIT_CLOSE, wParam, lParam);
			break;

		case MENU_EXIT :
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
			break;

		case MENU_HELP :
			WinHelp(hWnd, HelpPath, HELP_FINDER, 0);
			break;

		case MENU_QA :
			WinHelp(hWnd, HelpPath, HELP_CONTEXT, 8);
			break;

		case MENU_ABOUT :
			DialogBox(hInstttPage, MAKEINTRESOURCE(about_dlg), hWnd, AboutDialogProc);
			break;

		case MENU_REGINIT :
			if(DialogBox(hInstttPage, MAKEINTRESOURCE(reginit_dlg), hWnd, ExeEscDialogProc) == YES)
			{
				ClearRegistory();
				SaveExit = NO;
				PostMessage(hWnd, WM_CLOSE, 0, 0L);
			}
			break;

		case WIN_SETNAME :
			TmpTabWidth = AskCurExtSet()->TabWidth;
			TmpFoldPos = AskCurExtSet()->FoldPos;
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				if(CurFile != NULL)
				{
					CurExtSet = SendMessage(GetCurSetWinHwnd(), CB_GETCURSEL, 0, 0);
					LineNum = AskCurExtSet()->LineNumDisp;
					SetViewBackColor(AskCurExtSet()->BackColor);
					SetFontSize();
					SetCellSize();
					/* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
					if(AskCurExtSet()->FoldRight == NO)
					{
						if((AskCurExtSet()->TabWidth != TmpTabWidth) ||
						   (AskCurExtSet()->FoldPos != TmpFoldPos))
						{
							MakeLineTopTbl(CurFile);
							if(CurFile->DispTopLine > CurFile->TextLines-1)
								CurFile->DispTopLine = CurFile->TextLines-1;
						}
					}
					CalcLineNumWinWidth();
					ResizeNumWindow();
					ResizeViewWindow();
					SetWindowSize();
					SetScrollBar();
					DispCurrentLineNum(1, CurFile->DispTopLine);
					DispMousePos();
				}
				InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
				InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
			}
			break;

		case MENU_FIND :
			WINNLSEnableIME(NULL, TRUE);	/* IME ON */
			/* break͂Ȃ */
		case MENU_NEXTLINE :
		case MENU_PREVLINE :
		case MENU_NEXT5LINE :
		case MENU_PREV5LINE :
		case MENU_NEXTPAGE :
		case MENU_PREVPAGE :
		case MENU_FILEBTM :
		case MENU_FILETOP :
		case MENU_RIGHT :
		case MENU_LEFT :
		case MENU_RIGHT5 :
		case MENU_LEFT5 :
		case MENU_FINDBACKWD :
		case MENU_FINDNEXT :
		case MENU_FINDPREV :
		case MENU_FINDDISP :
		case MENU_SELALL :
		case MENU_COPY :
		case MENU_APPENDCOPY :
		case MENU_QUOTECOPY :
		case MENU_GOTO :
		case MENU_OPEN_URL :
			SendMessage(GetViewWinHwnd(), WM_COMMAND, wParam, lParam);
			WINNLSEnableIME(NULL, FALSE);	/* IME ON */
			break;

		case MENU_LINENUM :
			if(CurFile != NULL)
			{
				LineNum ^= YES;
				ResizeNumWindow();
				ResizeViewWindow();
				SetWindowSize();
				SetScrollBar();
			}
			break;
		}
		break;

	case WM_US_EDIT_CLOSE :
		ReopenViewFromFile(CODE_AUTO);
		break;

	case WM_NOTIFY :
		switch(((LPNMHDR)lParam)->code){
		/* c[`bvRg[bZ[W̏ */
		case TTN_NEEDTEXT:
			lpttt = (LPTOOLTIPTEXT)lParam;
			lpttt->hinst = hInstttPage;
			switch(lpttt->hdr.idFrom){
			case MENU_OPEN:		lpttt->lpszText = "J"; break;
			case MENU_SAVEAS:	lpttt->lpszText = "Otĕۑ";	break;
			case MENU_COPY:		lpttt->lpszText = ""; break;
			case MENU_PASTE:	lpttt->lpszText = "y[Xg"; break;
			case MENU_FIND:		lpttt->lpszText = ""; break;
			case MENU_FINDNEXT:	lpttt->lpszText = ""; break;
			case MENU_FINDPREV:	lpttt->lpszText = "O"; break;
			case MENU_FINDDISP:	lpttt->lpszText = "ʂ\"; break;
			case MENU_EDITOR:	lpttt->lpszText = "GfB^ŊJ"; break;
			}
			break;
		}
		break;

	case WM_SIZE :
		if((wParam == SIZE_RESTORED) || (wParam == SIZE_MAXIMIZED)){
			ResizeWindowProc();
			if(CurFile != NULL)
			{
				SetWindowSize();
				SetScrollBar();
				SetDispTopWindowMatch();
			}
		}
		else
			return(DefWindowProc(hWnd, message, wParam, lParam));
		break;

	case WM_MOUSEWHEEL95 :
		hdlMsWheel = FindWindow(MSH_WHEELMODULE_CLASS, MSH_WHEELMODULE_TITLE);

		WheelScroll = 3;
		if(puiMsh_MsgScrollLines != 0)
			WheelScroll = (int)SendMessage(hdlMsWheel, puiMsh_MsgScrollLines, 0, 0);

		if((short)LOWORD(wParam) < 0)
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_NEXT_N_LINE, 0), WheelScroll);
		else if((short)LOWORD(wParam) > 0)
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_PREV_N_LINE, 0), WheelScroll);
		break;

	case WM_MOUSEWHEEL :
		if(SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, &WheelScroll, 0) == 0)
			WheelScroll = 3;

		if((short)HIWORD(wParam) < 0)
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_NEXT_N_LINE, 0), WheelScroll);
		else if((short)HIWORD(wParam) > 0)
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_PREV_N_LINE, 0), WheelScroll);
		break;

//	case WM_MOVING :
//		WinPosX = ((RECT *)lParam)->left;
//		WinPosY = ((RECT *)lParam)->top;
//		return(DefWindowProc(hWnd, message, wParam, lParam));

	case WM_WINDOWPOSCHANGED :
		if((IsZoomed(hWnd) == FALSE) && (IsIconic(hWnd) == FALSE))
		{
			WinPosX = ((WINDOWPOS *)lParam)->x;
			WinPosY = ((WINDOWPOS *)lParam)->y;
		}
		return(DefWindowProc(hWnd, message, wParam, lParam));

	case WM_DESTROY :
		PostQuitMessage(0);
		break;

	case WM_QUERYENDSESSION :
		ExitProc(hWnd);
		return(TRUE);

	case WM_CLOSE :
		ExitProc(hWnd);
		break;

	default :
		return(DefWindowProc(hWnd, message, wParam, lParam));
	}
    return(0L);
}


/*----- vOȈ ------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ExitProc(HWND hWnd)
{
	AskWindowSize();
	if(SaveExit == YES)
		SaveRegistory();
	if(GetGrepWindow())
		DestroyWindow(GetGrepWindow());
	CoUninitialize();
	DeleteAllObject();
	WinHelp(hWnd, HelpPath, HELP_QUIT, 0);
	return;
}


/*----- EChẼTCY擾 ------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void AskWindowSize(void)
{
	WINDOWPLACEMENT WinPlace;

	WinPlace.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(hWndttPage, &WinPlace);
	WinWidth = WinPlace.rcNormalPosition.right - WinPlace.rcNormalPosition.left;
	WinHeight = WinPlace.rcNormalPosition.bottom - WinPlace.rcNormalPosition.top;

	Maximize = NO;
	if(WinPlace.showCmd == SW_SHOWMAXIMIZED)
		Maximize = YES;

	return;
}


/*----- EChẼTCYύX̏ ------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ResizeWindowProc(void)
{
	ResizeStatusWin();
	ResizeToolBar();
	ResizeNumWindow();
	ResizeViewWindow();
	return;
}


/*----- R}hC --------------------------------------------------
*
*	Parameter
*		char *Str : R}hC
*		char *Fname : t@C
*		int *Opt : IvV
*		int *TopLine : \擪s
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*
*	Note
*		-j --jump
*		-e --jumpend
*		-h --help
*----------------------------------------------------------------------------*/

static int AnalyzeComLine(char *Str, char *Fname, int *Opt, int *TopLine)
{
	int Sts;
	char Tmp[MAX_PATH+1];

	strcpy(Fname, "");
	*Opt = 0;
	*TopLine = 0;

	Sts = SUCCESS;
	while((Str = GetToken(Str, Tmp, YES)) != NULL)
	{
		if(Tmp[0] == '-')
		{
			_mbslwr(Tmp);
			if((strcmp(&Tmp[1], "j") == 0) || (strcmp(&Tmp[1], "-jump") == 0))
			{
				if(((Str = GetToken(Str, Tmp, NO)) != NULL) && (isdigit(*Tmp)))
					*TopLine = atoi(Tmp)-1;
				else
				{
					DispErrorBox("sԍw肳Ă܂.");
					Sts = FAIL;
					break;
				}
			}
			else if((strcmp(&Tmp[1], "e") == 0) || (strcmp(&Tmp[1], "-jumpend") == 0))
				*TopLine = -1;
			else if((strcmp(&Tmp[1], "h") == 0) || (strcmp(&Tmp[1], "-help") == 0))
				WinHelp(GetMainHwnd(), HelpPath, HELP_CONTEXT, 5);
			else if(strcmp(&Tmp[1], "-sjis") == 0)
				*Opt |= OPT_SJIS;
			else if(strcmp(&Tmp[1], "-jis") == 0)
				*Opt |= OPT_JIS;
			else if(strcmp(&Tmp[1], "-euc") == 0)
				*Opt |= OPT_EUC;
			else
			{
				DispErrorBox("IvVԈĂ܂. (%s)", Tmp);
				Sts = FAIL;
				break;
			}
		}
		else
		{
			if(strlen(Fname) == 0)
				strcpy(Fname, Tmp);
			else
			{
				DispErrorBox("pX̎w肪܂. (%s)", Tmp);
				Sts = FAIL;
				break;
			}
		}
	}
	return(Sts);
}


/*----- g[NԂ --------------------------------------------------------
*
*	Parameter
*		char *Str : 
*		char *Buf : Ԃobt@
*		int Flag : Xy[X܂ޖO邩ǂ (YES/NO)
*
*	Return Value
*		char *Ԃg[N̖
*			NULL=I
*----------------------------------------------------------------------------*/

static char *GetToken(char *Str, char *Buf, int Flag)
{
	int InQuote;
	char *Btm;
	char *StrTop;
//	char *BufTop;

	while(*Str != NUL)
	{
		if((*Str != ' ') && (*Str != '\t'))
			break;
		Str++;
	}

	if(*Str != NUL)
	{
		if(*Str == '-')		/* IvV̓Xy[X͊܂܂Ȃ */
			Flag = NO;

//		BufTop = Buf;
		StrTop = Str;
		InQuote = 0;
		while(*Str != NUL)
		{
			if(*Str == 0x22)
				InQuote = !InQuote;
			else
			{
				if(Flag == YES)
				{
					if((*Str == '-') && (InQuote == 0))
					{
						if((Str == StrTop) || (*(Str-1) == ' '))
							break;
					}
					if((InQuote == 0) &&
					   ((*Str == ' ') || (*Str == '\t')))
					{
						*Buf++ = *Str;
					}
					else
					{
						*Buf++ = *Str;
						Btm = Buf;
					}
				}
				else
				{
					if((InQuote == 0) &&
					   ((*Str == ' ') || (*Str == '\t')))
					{
						break;
					}
					*Buf++ = *Str;
					Btm = Buf;
				}
			}
			Str++;
		}
		*Btm = NUL;

//		DoPrintf("TOKEN >%s<\n", BufTop);
	}
	else
		Str = NULL;

	return(Str);
}


/*----- w̃t@Cɑ΂gqʐݒԍԂ --------------------------
*                                                 by yhatley
*	Parameter
*		FILEMANTBL *pFileTbl : t@Ce[u
*
*	Return Value
*	        int gqʐݒԍ
*----------------------------------------------------------------------------*/
int GetFileExtSetNum(FILEMANTBL *pFileTbl)
{
	int i;
	char *Pos;
	char *Ext;

	Ext = pFileTbl->Fname;
	for(i = ExtSetNum-1; i > 0; i--)
	{
		Pos = ExtSetTbl[i].Exts;
		while(*Pos != NUL)
		{
			if(CheckFname(Ext, Pos) == SUCCESS)
			{
				return i;
			}
			Pos += strlen(Pos) + 1;
		}
	}
        return 0;
}

/*----- gqʐݒԍۂ̃f[^Ԃ --------------------------------
*
*	Parameter
*	        int SetNum : ݒԍ
*
*	Return Value
*		EXTSET *gqʐݒ
*----------------------------------------------------------------------------*/

EXTSET *AskFileExtSet(int SetNum)
{
	return(&ExtSetTbl[SetNum]);
}

/*----- ݂̃t@Cɑ΂gqʐݒf[^ݒ肷 --------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetCurExtNum(void)
{
	int i;
	char *Pos;
	char *Ext;

	Ext = GetFileName(AskCurFileTbl()->Fname);
	CurExtSet = 0;
	for(i = ExtSetNum-1; i > 0; i--)
	{
		Pos = ExtSetTbl[i].Exts;
		while(*Pos != NUL)
		{
			if(CheckFname(Ext, Pos) == SUCCESS)
			{
				CurExtSet = i;
				break;
			}
			Pos += strlen(Pos) + 1;
		}
		if(CurExtSet != 0)
			break;
	}
	SetCurSetNumToCurSetWin();
	return;
}


/*----- ݂̊gqʐݒ̃f[^Ԃ --------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		EXTSET *gqʐݒ
*----------------------------------------------------------------------------*/

EXTSET *AskCurExtSet(void)
{
	return(&ExtSetTbl[CurExtSet]);
}


/*----- ݂̊gqʐݒԍԂ ------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int gqʐݒԍ
*----------------------------------------------------------------------------*/

int AskCurExtSetNum(void)
{
	return(CurExtSet);
}


/*----- ݂̃tHgŒ蕝tHgǂԂ --------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int Œ蕝tHgǂ
*			YES/NO
*----------------------------------------------------------------------------*/

int AskFixedPitchFont(void)
{
	int Sts;

	Sts = YES;
	if((AskCurExtSet()->Font.lfPitchAndFamily & 0x03) == VARIABLE_PITCH)
		Sts = NO;

	return(Sts);
}


/*----- t@Cۑ --------------------------------------------------------
*
*	Parameter
*		FILEMANTBL *Tbl : t@CǗe[u
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void SaveFileAs(FILEMANTBL *Tbl)
{
	char Fname[MAX_PATH+1];
	FILE *Strm;

	if(SelectFileToSave(hWndttPage, Fname, "Otĕۑ(SHIFT-JISR[h)", "") == TRUE)
	{
		if((Strm = fopen(Fname, "wt")) != NULL)
		{
			fwrite(Tbl->TextData, Tbl->TextSize, 1, Strm);
			fclose(Strm);
		}
	}
	return;
}


/*----- G[̃x炷 --------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void RingErrorBell(void)
{
	if(ErrBell == YES)
		MessageBeep(-1);
	return;
}






/*----- G[bZ[W{bNX\ ------------------------------------
*
*	Parameter
*		char *szFormat ... : tH[}bg
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DispErrorBox(char *szFormat,...)
{
	va_list vaArgs;
	static char szBuf[256];

	va_start(vaArgs,szFormat);
	if(vsprintf(szBuf,szFormat,vaArgs)!=EOF)
		MessageBox(NULL, szBuf, "ttPage", MB_OK);
	va_end(vaArgs);
}









/*----- uttPageɂāv_CAŐʃR[obN֐ --------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		UINT message : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		BOOL TRUE/FALSE
*----------------------------------------------------------------------------*/

static BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	char Regexp[80];

	switch (message)
	{
		case WM_INITDIALOG :
			RegexGetVer(Regexp, 80);
			SendDlgItemMessage(hDlg, ABOUT_REGEXP, WM_SETTEXT, 0, (LPARAM)Regexp);
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


// by yhatley
void ProcessMessage(void)
{
    MSG Msg;
    if(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE)) {
		if(GetGrepWindow() == GetActiveWindow()){
			TranslateMessage(&Msg);
			DispatchMessage(&Msg);
			
		}
		else if(TranslateAccelerator(hWndttPage, Accel, &Msg) == 0) {
				TranslateMessage(&Msg);
				DispatchMessage(&Msg);
			}
    }
}
