/*=============================================================================
*							̑̔ėpTu[`
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <mbstring.h>
#include <windowsx.h>
#include <commctrl.h>

#include "common.h"
#include "resource.h"


/*===== ̓_CAOf[^̃XgN` =====*/

typedef struct {
	char Title[80];			/* _CAÕ^Cg */
	char Str[MAX_PATH+1];	/* ftHg^͂ꂽ(Output) */
	int MaxLen;				/* ̍Œ */
	int Check;
} DIALOGDATA;

/*===== vg^Cv =====*/

static BOOL CALLBACK InputDialogCallBack(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);

/*===== [Jȃ[N =====*/

DIALOGDATA *DialogData;		/* ̓_CAOf[^ */



/*----- ̓_CAO\ --------------------------------------------------
*
*	Parameter
*		int Res : _CAO{bNXID
*		HWND hWnd : eEChẼEChEnh
*		char *Title : EChE^Cg (NULL=ݒ肵Ȃ)
*		char *Buf : GfBbg{bNX̏^͕Ԃobt@
*		int Max : obt@̃TCY (MAX_PATH+1ȉł邱)
*		int *Check : `FbN{bNX̏l^lԂ[N
*
*	Return Value
*		int Xe[^X (YES/NO=)
*----------------------------------------------------------------------------*/

int InputDialogBox(int Res, HWND hWnd, char *Title, char *Buf, int Max, int *Check)
{
	int Ret;
	DIALOGDATA dData;

	dData.MaxLen = Max;
	memset(dData.Str, NUL, MAX_PATH+1);
	strncpy(dData.Str, Buf, MAX_PATH);
	strcpy(dData.Title, "");
	if(Title != NULL)
		strcpy(dData.Title, Title);
	dData.Check = *Check;
	DialogData = &dData;

	Ret = DialogBox(GetProgInst(), MAKEINTRESOURCE(Res), hWnd, InputDialogCallBack);

	if(Ret == YES)
	{
		memset(Buf, NUL, Max);
		strncpy(Buf, dData.Str, Max-1);
		*Check = dData.Check;
	}
	return(Ret);
}


/*----- ̓_CAÕR[obN ------------------------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		UINT message : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		BOOL TRUE/FALSE
*----------------------------------------------------------------------------*/

static BOOL CALLBACK InputDialogCallBack(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch (iMessage)
	{
		case WM_INITDIALOG :
			if(strlen(DialogData->Title) != 0)
				SendMessage(hDlg, WM_SETTEXT, 0, (LPARAM)DialogData->Title);
			SendDlgItemMessage(hDlg, INP_TEXT, EM_LIMITTEXT, DialogData->MaxLen-1, 0);
			SendDlgItemMessage(hDlg, INP_TEXT, WM_SETTEXT, 0, (LPARAM)DialogData->Str);
			SendDlgItemMessage(hDlg, INP_CHECK1, BM_SETCHECK, DialogData->Check, 0);
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					SendDlgItemMessage(hDlg, INP_TEXT, WM_GETTEXT, DialogData->MaxLen, (LPARAM)DialogData->Str);
					DialogData->Check = SendDlgItemMessage(hDlg, INP_CHECK1, BM_GETCHECK, 0, 0);
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
            return(TRUE);
	}
	return(FALSE);
}

/*----- msnƁmñ_CAŐʃR[obN֐ --------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		UINT message : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		BOOL TRUE/FALSE
*----------------------------------------------------------------------------*/
BOOL CALLBACK ExeEscDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG :
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


/*----- ̍Ō "\" t -------------------------------------------
*
*	Parameter
*		char *Str : 
*
*	Return Value
*		Ȃ
*
*	Note
*		IWi̕ char *Str ύX܂B
*----------------------------------------------------------------------------*/

void SetYenTail(char *Str)
{
	if(_mbscmp(_mbsninc(Str, _mbslen(Str) - 1), "\\") != 0)
		strcat(Str, "\\");

	return;;
}


/*----- 񂩂sR[h菜 ----------------------------------------
*
*	Parameter
*		char *Str : 
*
*	Return Value
*		Ȃ
*
*	Note
*		IWi̕ char *Str ύX܂B
*----------------------------------------------------------------------------*/

void RemoveReturnCode(char *Str)
{
	char *Pos;

	if((Pos = _mbschr(Str, 0x0D)) != NULL)
		*Pos = NUL;

	if((Pos = _mbschr(Str, 0x0A)) != NULL)
		*Pos = NUL;
	return;
}


/*----- AC̒߂ --------------------------------------------
*
*	Parameter
*		char *Mul : AC (NULQ)
*
*	Return Value
*		int 
*
*	Note
*		I[2NUL̂̍Ō͐̕Ȃ
*			AskMultiStrLen("") = 0
*			AskMultiStrLen("abc\0xyz\0") = 8
*			AskMultiStrLen("abc") = I[QNULłȂ̂ŋ߂Ȃ
*----------------------------------------------------------------------------*/

int AskMultiStrLen(char *Mul)
{
	int Len;
	int Tmp;

	Len = 0;
	while(*Mul != NUL)
	{
		Tmp = strlen(Mul) + 1;
		Mul += Tmp;
		Len += Tmp;
	}
	return(Len);
}


/*----- AC̒̐̕𐔂 ----------------------------------
*
*	Parameter
*		char *Mul : AC (NULQ)
*
*	Return Value
*		int ̐
*----------------------------------------------------------------------------*/

int CountMultiStrNum(char *Mul)
{
	int Ret;

	Ret = 0;
	if(*Mul != NUL)
	{
		while(*Mul != NUL)
		{
			Ret++;
			Mul += strlen(Mul) + 1;
		}
	}
	return(Ret);
}


/*----- AC̐擪ɕ} ----------------------------------
*
*	Parameter
*		char *Str : 
*		char *Mul : AC (NULQ)
*		int BufSize : ACi[obt@̃TCY
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int InsertStrToMultiStr(char *Str, char *Mul, int BufSize)
{
	int MulLen;
	int StrLen;
	int Sts;

	Sts = FAIL;
	MulLen = AskMultiStrLen(Mul);
	StrLen = strlen(Str);
	if(MulLen + StrLen + 1 <= BufSize)
	{
		memmove(Mul+StrLen+1, Mul, MulLen+1);
		strcpy(Mul, Str);
		Sts = SUCCESS;
	}
	return(Sts);
}


/*----- AC̒̎w̕폜 ------------------------------
*
*	Parameter
*		char *Str : 
*		char *Mul : AC (NULQ)
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int DeleteStrFromMultiStr(char *Str, char *Mul)
{
	int Sts;
	char *Pos;

	Sts = FAIL;

	Pos = Mul;
	while(*Pos != NUL)
	{
		if(strcmp(Pos, Str) == 0)
		{
			Mul = strchr(Pos, '\0') + 1;
			memmove(Pos, Mul, AskMultiStrLen(Mul)+1);
			Sts = SUCCESS;
			break;
		}
		Pos += strlen(Pos) + 1;
	}
	return(Sts);
}


/*----- AC̒̎wԍ̕폜 --------------------------
*
*	Parameter
*		int Num : ԍ
*		char *Mul : AC (NULQ)
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int DeleteNumFromMultiStr(int Num, char *Mul)
{
	int Sts;
	char *Pos;

	Sts = FAIL;

	Pos = Mul;
	while(*Pos != NUL)
	{
		if(Num == 0)
		{
			Mul = strchr(Pos, '\0') + 1;
			memmove(Pos, Mul, AskMultiStrLen(Mul)+1);
			Sts = SUCCESS;
			break;
		}
		Pos += strlen(Pos) + 1;
		Num--;
	}
	return(Sts);
}


/*----- sR[hLFCR-LFɕϊꍇ̒̕߂ --------------
*
*	Parameter
*		char *Str : 
*		int Len : ̒iNUL͖j
*		char *Quote : p
*
*	Return Value
*		int 
*
*	Note
*		sɈptĐ
*----------------------------------------------------------------------------*/

int AskStrLenLFtoCRLF(char *Str, int Len, char *Quote)
{
	int Ret;
	int Top;
	int QuoteLen;

	QuoteLen = strlen(Quote);
	Top = YES;
	Ret = 0;
	for(; Len > 0; Len--)
	{
		if(Top == YES)
			Ret += QuoteLen;
		Top = NO;

		if(*Str == '\n')
		{
			Ret++;
			Top = YES;
		}
		Ret++;
		Str++;
	}
	return(Ret);
}


/*----- sR[hLFCR-LFɕϊĕRs[ ----------------------
*
*	Parameter
*		char *Buf : Rs[
*		char *Str : 
*		int Len : ̒iNUL͖j
*		char *Quote : p
*
*	Return Value
*		Ȃ
*
*	Note
*		sɈpt
*----------------------------------------------------------------------------*/

void CopyStrLFtoCRLF(char *Buf, char *Str, int Len, char *Quote)
{
	int Top;
	int QuoteLen;

	QuoteLen = strlen(Quote);
	Top = YES;
	for(; Len > 0; Len--)
	{
		if(Top == YES)
		{
			strcpy(Buf, Quote);
			Buf += QuoteLen;
		}
		Top = NO;

		if(*Str == '\n')
		{
			*Buf++ = '\r';
			Top = YES;
		}
		*Buf++ = *Str++;
	}
	return;
}


/*----- pX̒̃t@C̐擪Ԃ ------------------------------------
*
*	Parameter
*		char *Path : pX
*
*	Return Value
*		char *t@C̐擪
*
*	Note
*		fBNg̋؂L "\"  "/" ̗L
*----------------------------------------------------------------------------*/

char *GetFileName(char *Path)
{
	char *Pos;

	if((Pos = _mbschr(Path, ':')) != NULL)
		Path = Pos + 1;

	if((Pos = _mbsrchr(Path, '\\')) != NULL)
		Path = Pos + 1;

	if((Pos = _mbsrchr(Path, '/')) != NULL)
		Path = Pos + 1;

	return(Path);
}


/*----- pX̒̊gq̐擪Ԃ ----------------------------------------
*
*	Parameter
*		char *Path : pX
*
*	Return Value
*		char *gq̐擪
*----------------------------------------------------------------------------*/

char *GetFileExt(char *Path)
{
	char *Ret;

	Ret = _mbschr(Path, NUL);
	if((_mbscmp(Path, ".") != 0) &&
	   (_mbscmp(Path, "..") != 0))
	{
		while((Path = _mbschr(Path, '.')) != NULL)
		{
			Path++;
			Ret = Path;
		}
	}
	return(Ret);
}


/*----- pXt@C菜 ----------------------------------------
*
*	Parameter
*		char *Path : pX
*		char *Buf : t@CpX̃Rs[
*
*	Return Value
*		Ȃ
*
*	Note
*		fBNg̋؂L "\"  "/" ̗L
*----------------------------------------------------------------------------*/

void RemoveFileName(char *Path, char *Buf)
{
	char *Pos;

	strcpy(Buf, Path);

	if((Pos = _mbsrchr(Buf, '/')) != NULL)
		*Pos = NUL;
	else if((Pos = _mbsrchr(Buf, '\\')) != NULL)
	{
		if((Pos == Buf) || 
		   ((Pos != Buf) && (*(Pos - 1) != ':')))
			*Pos = NUL;
	}
	return;
}


/*----- t@CIiuJvpj---------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		char *Fname : t@CԂobt@
*		char *Title : ^Cg
*		char *Filters : tB^[
*
*	Return Value
*		int Xe[^X
*			TRUE/FALSE=
*----------------------------------------------------------------------------*/

int SelectFileToOpen(HWND hWnd, char *Fname, char *Title, char *Filters)
{
	OPENFILENAME OpenFile;
	char Tmp[MAX_PATH+1];
	int Sts;

	strcpy(Tmp, "");
	OpenFile.lStructSize = sizeof(OPENFILENAME);
	OpenFile.hwndOwner = hWnd;
	OpenFile.hInstance = 0;
	OpenFile.lpstrFilter = Filters;
	OpenFile.lpstrCustomFilter = NULL;
	OpenFile.nFilterIndex = 1;
	OpenFile.lpstrFile = Tmp;
	OpenFile.nMaxFile = MAX_PATH;
	OpenFile.lpstrFileTitle = NULL;
	OpenFile.nMaxFileTitle = 0;
	OpenFile.lpstrInitialDir = NULL;
	OpenFile.lpstrTitle = Title;
	OpenFile.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	OpenFile.nFileOffset = 0;
	OpenFile.nFileExtension = 0;
	OpenFile.lpstrDefExt = 0;
	OpenFile.lCustData = 0;
	OpenFile.lpfnHook = NULL;
	OpenFile.lpTemplateName = NULL;

	if((Sts = GetOpenFileName(&OpenFile)) == TRUE)
		strcpy(Fname,Tmp);

	return(Sts);
}


/*----- t@CIiuۑvpj---------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		char *Fname : t@CԂobt@
*		char *Title : ^Cg
*		char *Filters : tB^[
*
*	Return Value
*		int Xe[^X
*			TRUE/FALSE=
*----------------------------------------------------------------------------*/

int SelectFileToSave(HWND hWnd, char *Fname, char *Title, char *Filters)
{
	OPENFILENAME OpenFile;
	char Tmp[MAX_PATH+1];
	int Sts;

	strcpy(Tmp, "");
	OpenFile.lStructSize = sizeof(OPENFILENAME);
	OpenFile.hwndOwner = hWnd;
	OpenFile.hInstance = 0;
	OpenFile.lpstrFilter = Filters;
	OpenFile.lpstrCustomFilter = NULL;
	OpenFile.nFilterIndex = 1;
	OpenFile.lpstrFile = Tmp;
	OpenFile.nMaxFile = MAX_PATH;
	OpenFile.lpstrFileTitle = NULL;
	OpenFile.nMaxFileTitle = 0;
	OpenFile.lpstrInitialDir = NULL;
	OpenFile.lpstrTitle = Title;
	OpenFile.Flags = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	OpenFile.nFileOffset = 0;
	OpenFile.nFileExtension = 0;
	OpenFile.lpstrDefExt = 0;
	OpenFile.lCustData = 0;
	OpenFile.lpfnHook = NULL;
	OpenFile.lpTemplateName = NULL;

	if((Sts = GetSaveFileName(&OpenFile)) == TRUE)
		strcpy(Fname,Tmp);

	return(Sts);
}


/*----- lɊ֘AtꂽWI{^`FbN --------------------------
*
*	Parameter
*		HWND hDlg : _CAO{bNX̃EChEnh
*		int Value : l
*		const RADIOBUTTON *Buttons : WI{^ƒl̊֘Ate[u
*		int Num : {^̐
*
*	Return Value
*		Ȃ
*
*	Note
*		lɊ֘Atꂽ{^́Ae[u̍ŏɓo^Ă{^
*		`FbN
*----------------------------------------------------------------------------*/

void SetRadioButtonByValue(HWND hDlg, int Value, const RADIOBUTTON *Buttons, int Num)
{
	int i;
	int Def;
	int Found;

	Found = NO;
	Def = Buttons->ButID;
	for(i = 0; i < Num; i++)
	{
		if(Value == Buttons->Value)
		{
			SendDlgItemMessage(hDlg, Buttons->ButID, BM_SETCHECK, 1, 0);
			/* WI{^ύXɑ̍ڂ̃nChȂǂsȂ	*/
			/* ̂ŁÂ߂ WM_COMMAND 𑗂 						*/
			SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(Buttons->ButID, 0), 0);
			Found = YES;
		}
		else
			SendDlgItemMessage(hDlg, Buttons->ButID, BM_SETCHECK, 0, 0);
		Buttons++;
	}

	if(Found == NO)
	{
		SendDlgItemMessage(hDlg, Def, BM_SETCHECK, 1, 0);
		SendMessage(hDlg, WM_COMMAND, MAKEWPARAM(Def, 0), 0);
	}
	return;
}


/*----- `FbNĂ{^Ɋ֘AtꂽlԂ ----------------------
*
*	Parameter
*		HWND hDlg : _CAO{bNX̃EChEnh
*		const RADIOBUTTON *Buttons : WI{^ƒl̊֘Ate[u
*		int Num : {^̐
*
*	Return Value
*		int l
*
*	Note
*		ǂ̃{^`FbNĂȂ́Ae[u̍ŏɓo^Ă{
*		^̒lԂ
*----------------------------------------------------------------------------*/

int AskRadioButtonValue(HWND hDlg, const RADIOBUTTON *Buttons, int Num)
{
	int i;
	int Ret;

	Ret = Buttons->Value;
	for(i = 0; i < Num; i++)
	{
		if(SendDlgItemMessage(hDlg, Buttons->ButID, BM_GETCHECK, 0, 0) == 1)
		{
			Ret = Buttons->Value;
			break;
		}
		Buttons++;
	}
	return(Ret);
}


/*----- fobOR\[ɃbZ[W\ ------------------------------
*
*	Parameter
*		char *szFormat : tH[}bg
*		... : p[^
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DoPrintf(char *szFormat, ...)
{
	va_list vaArgs;
	static char szBuf[256];
	DWORD Tmp;

	va_start(vaArgs,szFormat);
	if(vsprintf(szBuf,szFormat,vaArgs)!=EOF)
	{
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), szBuf, strlen(szBuf), &Tmp, NULL);
	}
	va_end(vaArgs);
}



int max1(int n, int m)
{
	if(n > m)
		return(n);
	else
		return(m);
}



int min1(int n, int m)
{
	if(n < m)
		return(n);
	else
		return(m);
}

// from Uranus
int IsURL( const char *pszLine, int nLineLen, int *pnMatchLen )
{
	struct _url_table_t {
		char	name[12];
		int		length;
		BOOL	is_mail;
	};
	static const struct _url_table_t	url_table[] = {
		/* At@xbg */
		"file://",		7,	FALSE, /* 1 */
		"ftp://",		6,	FALSE, /* 2 */
		"gopher://",	9,	FALSE, /* 3 */
		"http://",		7,	FALSE, /* 4 */
		"https://",		8,	FALSE, /* 5 */
//		"mailto:",		7,	TRUE,  /* 6 */
		"news:",		5,	FALSE, /* 7 */
		"nntp://",		7,	FALSE, /* 8 */
		"prospero://",	11,	FALSE, /* 9 */
		"telnet://",	9,	FALSE, /* 10 */
		"mmp://",		6,	FALSE, /* 11 */
		"ttps://",		7,	FALSE, /* 5+2 */
		"wais://",		7,	FALSE, /* 12 */
		"{",			0,	FALSE  /* 13 */  /* '{' is 'z'+1 : terminate */
	};

/* e[u̕ێ琫߂邽߂̒` */
	const char urF = 1;
	const char urG = 3;
	const char urH = 4;
	const char urM = 6;
	const char urN = 7;
	const char urP = 9;
	const char urT = 10;
	const char urW = 13;

	static const char	url_char[] = {
	  /* +0  +1  +2  +3  +4  +5  +6  +7  +8  +9  +A  +B  +C  +D  +E  +F */
		  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	/* +00: */
		  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,	/* +10: */
		  0, -1,  0, -1, -1, -1, -1,  0,  0,  0,  0, -1, -1, -1, -1, -1,	/* +20: " !"#$%&'()*+,-./" */
		 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  0, -1,  0, -1,	/* +30: "0123456789:;<=>?" */
		 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	/* +40: "@ABCDEFGHIJKLMNO" */
		 -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  0, -1,  0,  0, -1,	/* +50: "PQRSTUVWXYZ[\]^_" */
		  0, -1, -1, -1, -1, -1,  1,  3,  4, -1, -1, -1, -1,  6,  7, -1,	/* +60: "`abcdefghijklmno" */
		 -1, -1, -1, -1, 10, -1, -1, 13, -1, -1, -1,  0,  0,  0, -1,  0,	/* +70: "pqrstuvwxyz{|}~ " */
//		  0, -1, -1, -1, -1, -1,urF,urG,urH, -1, -1, -1, -1,urM,urN, -1,	/* +60: "`abcdefghijklmno" */
//		 -1, -1, -1, -1,urT, -1, -1,urW, -1, -1, -1,  0,  0,  0, -1,  0,	/* +70: "pqrstuvwxyz{|}~ " */
//		urP, -1, -1, -1,urT, -1, -1,urW, -1, -1, -1,  0,  0,  0, -1,  0,	/* +70: "pqrstuvwxyz{|}~ " */
		/* 128oCg]ɂif2ӏ폜ł */
		/* 0    : not url char
		 * -1   : url char
		 * other: url head char --> url_table array number + 1
		 */
	};

	const unsigned char	*p = (const unsigned char*)pszLine;
	const struct _url_table_t	*urlp;
	int	i;

	if( *p & 0x80 ) return FALSE;	/* 2oCg */
	if( 0 < url_char[*p] ){	/* URLJn */
		for(urlp = &url_table[url_char[*p]-1]; urlp->name[0] == *p; urlp++){	/* URLe[uT */
			if( (urlp->length <= nLineLen) && (memcmp(urlp->name, pszLine, urlp->length) == 0) ){	/* URLwb_͈v */
				p += urlp->length;	/* URLwb_XLbv */
				if( urlp->is_mail ){	/* [p̉͂ */
					if( IsMailAddress((const char*)p, nLineLen - urlp->length, pnMatchLen) ){
						*pnMatchLen = *pnMatchLen + urlp->length;
						return ID_MAIL_ADDRESS;
					}
					return ID_NONE;
				}
				for(i = urlp->length; i < nLineLen; i++, p++){	/* ʏ̉͂ */
					if( (*p & 0x80) || (!(url_char[*p])) ) break;	/* I[ɒB */
				}
				if( i == urlp->length ) return ID_NONE;	/* URLwb_ */
				*pnMatchLen = i;
				return ID_URL;
			}
		}
	}
	return IsMailAddress(pszLine, nLineLen, pnMatchLen);
}

/* ݈ʒu[AhXȂ΁ANULLȊOƁA̒Ԃ */
int IsMailAddress( const char* pszBuf, int nBufLen, int* pnAddressLenfth )
{
	int		j;
	int		nDotCount;
	int		nBgn;

	j = 0;
	if( (pszBuf[j] >= 'a' && pszBuf[j] <= 'z') || (pszBuf[j] >= 'A' && pszBuf[j] <= 'Z') || (pszBuf[j] >= '0' && pszBuf[j] <= '9')){
		j++;
	}else{
		return ID_NONE;
	}
	while( j < nBufLen - 2
		&& ( (pszBuf[j] >= 'a' && pszBuf[j] <= 'z') || (pszBuf[j] >= 'A' && pszBuf[j] <= 'Z')
		|| (pszBuf[j] >= '0' && pszBuf[j] <= '9') || (pszBuf[j] == '.')
		|| (pszBuf[j] == '-') || (pszBuf[j] == '_')) ){
		j++;
	}
	if( j == 0 || j >= nBufLen - 2  ){
		return ID_NONE;
	}
	if( '@' != pszBuf[j] ) return ID_NONE;
	j++;
	nDotCount = 0;

	while( 1 ){
		nBgn = j;
		while( j < nBufLen && (
			(pszBuf[j] >= 'a' && pszBuf[j] <= 'z')
			|| (pszBuf[j] >= 'A' && pszBuf[j] <= 'Z') || (pszBuf[j] >= '0' && pszBuf[j] <= '9')
			|| (pszBuf[j] == '-') || (pszBuf[j] == '_')) ){
			j++;
		}
		if( 0 == j - nBgn )	return FALSE;
		if( '.' != pszBuf[j] ){
			if( 0 == nDotCount ){
				return FALSE;
			}else{
				break;
			}
		}else{
			nDotCount++;
			j++;
		}
	}
	if( NULL != pnAddressLenfth ){
		*pnAddressLenfth = j;
	}
	return ID_MAIL_ADDRESS;
}

/*w^J[\̃[h*/
HCURSOR GetFingerCursor(void)
{
	HINSTANCE	hInstHelp;
	HCURSOR		hCursor;
	char		WinDir[MAX_PATH];

	GetWindowsDirectory(WinDir,MAX_PATH-12);
	lstrcat(WinDir,"\\winhlp32.exe");
	hInstHelp = LoadLibrary(WinDir);
	if(!hInstHelp){
		hCursor = LoadCursor(NULL,IDC_ARROW);
	} else {
		hCursor = CopyCursor(LoadCursor(hInstHelp,MAKEINTRESOURCE(106)));
		FreeLibrary(hInstHelp);
	}
	return hCursor;
}



/*----- pXfBNgǂԂ  ------------------------------------
*
*	Parameter
*		char *path: pX
*
*	Return Value
*		fBNgȂ TRUE
*----------------------------------------------------------------------------*/
BOOL PathIsDirectory(char *path)
{
    WIN32_FIND_DATA FileData;
    HANDLE hFind;

    if(strlen(path) == 3 && isalpha(path[0]) && path[1] == ':' && path[2] == '\\')
	return TRUE;

    // Ō '\\' 菜
    if(_mbsrchr(path, '\\') == (path + strlen(path) - 1))
	path[ strlen(path) - 1 ] = '\0';

    hFind = FindFirstFile(path, &FileData);

    if(hFind == INVALID_HANDLE_VALUE)
	return FALSE;

    FindClose(hFind);

    if(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
	return TRUE;
    else
	return FALSE;
}
