/*=============================================================================
*								IvVݒ
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static LRESULT CALLBACK ExtSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static void SetExtSetToDialog(HWND hDlg, EXTSET *Tbl, int Num);
static void GetExtSetFromDialog(HWND hDlg, EXTSET *Tbl, int Num);
static void SetExtSetHide(HWND hDlg, int Num);
static LRESULT CALLBACK DispSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK KeySettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK ToolSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static LRESULT CALLBACK MiscSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
static int SelectColor(HWND hWnd, COLORREF *Col, EXTSET *Tbl, int Num);
static int SerDefinedColor(int Num, COLORREF *Tbl, COLORREF Color);
static void DrawColorButton(DRAWITEMSTRUCT *dItem, COLORREF Col);
static int GetDecimalText(HWND hDlg, int Ctrl);
static void SetDecimalText(HWND hDlg, int Ctrl, int Num);
static void CheckRange2(int *Cur, int Max, int Min);

/*===== [Jȃ[N ======*/

static int Apply;

static const RADIOBUTTON LineNumButton[] = {
	{ EXT_WPTYPE, LINENUM_WP },
	{ EXT_EDITORTYPE, LINENUM_EDITOR }
};
#define LINENUMBUTTONS	(sizeof(LineNumButton)/sizeof(RADIOBUTTON))

static COLORREF TmpTextColor;
static COLORREF TmpHighColor;
static COLORREF TmpBackColor;
static COLORREF TmpCtrlColor;
static COLORREF TmpFindColor;
static LOGFONT TmpLogFont;

/*===== OQ =====*/

/* ݒl */
extern int SaveWinSize;
extern int SaveWinPos;
extern int ToolBar;
extern int StatusBar;
extern int RegType;
extern char QuoteStr[QUOTE_MAXLEN+1];

extern EXTSET ExtSetTbl[EXT_SET_NUM];
extern int ExtSetNum;
extern int CurExtSet;

extern char EditorName[MAX_PATH+1 - EDITOR_OPT_LEN];
extern char EditOptEUC[EDITOR_OPT_LEN+1];
extern char EditOptJIS[EDITOR_OPT_LEN+1];
extern char EditOptSJIS[EDITOR_OPT_LEN+1];
extern int EditSjisAlways;
extern int EditAndClose;
extern int EditAutoReLoad;

extern int UItype;
extern int ErrBell;
extern int FileHist;

extern int DispCaret;
extern int MouseCopy; // ǉ
extern int ClickableMap; // ǉ
extern int HighlightURL; // ǉ

extern int GrepWndPortrait; // ǉ

extern int SmoothLine;
extern int SmoothPage;
extern int SmoothRate;

/*----- IvVݒ --------------------------------------------------------
*
*	Parameter
*		HWND hWnd : eEChẼEChEnh
*
*	Return Value
*		int Xe[^X
*			YES/NO=
*----------------------------------------------------------------------------*/

int SetOption(HWND hWnd)
{
	PROPSHEETPAGE psp[4];
	PROPSHEETHEADER psh;

	psp[0].dwSize = sizeof(PROPSHEETPAGE);
	psp[0].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[0].hInstance = GetProgInst();
	psp[0].DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(opt_ext_dlg);
	psp[0].DUMMYUNIONNAME2.pszIcon = NULL;
	psp[0].pfnDlgProc = ExtSettingProc;
	psp[0].pszTitle = "t@C";
	psp[0].lParam = 0;
	psp[0].pfnCallback = NULL;

	psp[1].dwSize = sizeof(PROPSHEETPAGE);
	psp[1].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[1].hInstance = GetProgInst();
	psp[1].DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(opt_key_dlg);
	psp[1].DUMMYUNIONNAME2.pszIcon = NULL;
	psp[1].pfnDlgProc = KeySettingProc;
	psp[1].pszTitle = "";
	psp[1].lParam = 0;
	psp[1].pfnCallback = NULL;

	psp[2].dwSize = sizeof(PROPSHEETPAGE);
	psp[2].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[2].hInstance = GetProgInst();
	psp[2].DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(opt_tool_dlg);
	psp[2].DUMMYUNIONNAME2.pszIcon = NULL;
	psp[2].pfnDlgProc = ToolSettingProc;
	psp[2].pszTitle = "c[";
	psp[2].lParam = 0;
	psp[2].pfnCallback = NULL;

	psp[3].dwSize = sizeof(PROPSHEETPAGE);
	psp[3].dwFlags = PSP_USETITLE | PSP_HASHELP;
	psp[3].hInstance = GetProgInst();
	psp[3].DUMMYUNIONNAME.pszTemplate = MAKEINTRESOURCE(opt_misc_dlg);
	psp[3].DUMMYUNIONNAME2.pszIcon = NULL;
	psp[3].pfnDlgProc = MiscSettingProc;
	psp[3].pszTitle = "̑";
	psp[3].lParam = 0;
	psp[3].pfnCallback = NULL;

	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_HASHELP | PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
	psh.hwndParent = hWnd;
	psh.hInstance = GetProgInst();
	psh.DUMMYUNIONNAME.pszIcon = NULL;
	psh.pszCaption = "ݒ";
	psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.DUMMYUNIONNAME2.nStartPage = 0;
	psh.DUMMYUNIONNAME3.ppsp = (LPCPROPSHEETPAGE)&psp;
	psh.pfnCallback = NULL;

	Apply = NO;
	PropertySheet(&psh);

	return(Apply);
}


/*----- gqʐݒEChẼbZ[W --------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK ExtSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *pnmhdr;
	int i;
	int Num;
	char Tmp[EXT_EXT_LEN+1];
	char Tmp2[EXT_EXT_LEN+1];
	int Len;
	static EXTSET TmpExtSetTbl[EXT_SET_NUM];
	static int TmpExtSetNum;
	static int TmpCurExtSet;
	static LOGFONT TmpTmpLogFont;
	static CHOOSEFONT cFont;
	static int SelFont;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, EXT_TAB, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_TAB_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(16, 2));
			SendDlgItemMessage(hDlg, EXT_FOLD, EM_LIMITTEXT, (WPARAM)3, 0);
			SendDlgItemMessage(hDlg, EXT_FOLD_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(260, 5));
			SendDlgItemMessage(hDlg, EXT_LINESPC, EM_LIMITTEXT, (WPARAM)2, 0);
			SendDlgItemMessage(hDlg, EXT_LINESPC_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(99, 0));
			memcpy(TmpExtSetTbl, ExtSetTbl, sizeof(EXTSET)*EXT_SET_NUM);
			TmpExtSetNum = ExtSetNum;
			TmpCurExtSet = CurExtSet;
			for(i = 0; i < TmpExtSetNum; i++)
				SendDlgItemMessage(hDlg, EXT_NAME, CB_ADDSTRING, 0, (LPARAM)TmpExtSetTbl[i].Name);
			SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, TmpCurExtSet, 0);
			SetExtSetToDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
			SetExtSetHide(hDlg, TmpCurExtSet);
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					GetExtSetFromDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
					memcpy(ExtSetTbl, TmpExtSetTbl, sizeof(EXTSET)*EXT_SET_NUM);
					ExtSetNum = TmpExtSetNum;
					Apply = YES;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 14);
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case EXT_NAME :
					if(HIWORD(wParam) == CBN_SELCHANGE)
					{
						Num = SendDlgItemMessage(hDlg, EXT_NAME, CB_GETCURSEL, 0, 0);
						GetExtSetFromDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
						TmpCurExtSet = Num;
						SetExtSetToDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
						SetExtSetHide(hDlg, TmpCurExtSet);
					}
					break;

				case EXT_NEW :
					if(TmpExtSetNum < EXT_SET_NUM)
					{
						strcpy(Tmp, "");
						if(InputDialogBox(newset_dlg, hDlg, "Vݒ̖O", Tmp, EXT_NAME_LEN+1, &i) == YES)
						{
							memmove(&TmpExtSetTbl[TmpExtSetNum], 
									&TmpExtSetTbl[0],
									sizeof(EXTSET));
							TmpCurExtSet = TmpExtSetNum;
							TmpExtSetNum++;
							SendDlgItemMessage(hDlg, EXT_NAME, CB_ADDSTRING, 0, (LPARAM)Tmp);
							SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, TmpCurExtSet, 0);
							strcpy(TmpExtSetTbl[TmpCurExtSet].Name, Tmp);
							SetExtSetToDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
							SetExtSetHide(hDlg, TmpCurExtSet);
						}
					}
					break;

				case EXT_DEL :
					memmove(&TmpExtSetTbl[TmpCurExtSet], 
							&TmpExtSetTbl[TmpCurExtSet+1],
							&TmpExtSetTbl[EXT_SET_NUM] - &TmpExtSetTbl[TmpCurExtSet+1]);
					TmpExtSetNum--;
					SendDlgItemMessage(hDlg, EXT_NAME, CB_DELETESTRING, TmpCurExtSet, 0);
					TmpCurExtSet = 0;
					SendDlgItemMessage(hDlg, EXT_NAME, CB_SETCURSEL, TmpCurExtSet, 0);
					SetExtSetToDialog(hDlg, TmpExtSetTbl, TmpCurExtSet);
					SetExtSetHide(hDlg, TmpCurExtSet);
					break;

				case EXT_EXTADD :
					strcpy(Tmp, "");
					if(InputDialogBox(fname_in_dlg, hDlg, "t@C", Tmp, EXT_EXT_LEN, &i) == YES)
					{
						Len = strlen(Tmp);
						if(Len > 0)
						{
							Len++;
							Num = SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETCOUNT, 0, 0);
							for(i = 0; i < Num; i++)
							{
								SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETTEXT, i, (LPARAM)Tmp2);
								Len += strlen(Tmp2) + 1;
							}

							if(Len > EXT_EXT_LEN)
								MessageBeep(-1);
							else
							{
								SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_ADDSTRING, 0, (LPARAM)Tmp);
								SendDlgItemMessage(hDlg, EXT_EXTIN, WM_SETTEXT, 0, (LPARAM)"");
							}
						}
					}
					break;

				case EXT_EXTDEL :
					if((i = SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETCURSEL, 0, 0)) != LB_ERR)
						SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_DELETESTRING, i, 0);
					break;

				case EXT_TEXTCOLOR :
					if(SelectColor(hDlg, &TmpTextColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
						InvalidateRgn(GetDlgItem(hDlg, EXT_TEXTCOLOR), NULL, FALSE);
					break;

				case EXT_HIGHCOLOR :
					if(SelectColor(hDlg, &TmpHighColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
						InvalidateRgn(GetDlgItem(hDlg, EXT_HIGHCOLOR), NULL, FALSE);
					break;

				case EXT_BACKCOLOR :
					if(SelectColor(hDlg, &TmpBackColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
						InvalidateRgn(GetDlgItem(hDlg, EXT_BACKCOLOR), NULL, FALSE);
					break;

				case EXT_CTRLCOLOR :
					if(SelectColor(hDlg, &TmpCtrlColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
						InvalidateRgn(GetDlgItem(hDlg, EXT_CTRLCOLOR), NULL, FALSE);
					break;

				case EXT_FINDCOLOR :
					if(SelectColor(hDlg, &TmpFindColor, TmpExtSetTbl, TmpExtSetNum) == TRUE)
						InvalidateRgn(GetDlgItem(hDlg, EXT_FINDCOLOR), NULL, FALSE);
					break;

				case EXT_FONT_BR :
					memcpy(&TmpTmpLogFont, &TmpLogFont, sizeof(LOGFONT));
					cFont.lStructSize = sizeof(CHOOSEFONT);
					cFont.hwndOwner = hDlg;
					cFont.hDC = 0;
					cFont.lpLogFont = &TmpTmpLogFont;
					cFont.Flags = CF_FORCEFONTEXIST | CF_SCREENFONTS;
					cFont.nFontType = SCREEN_FONTTYPE;
					cFont.Flags |= CF_INITTOLOGFONTSTRUCT;
					if(ChooseFont(&cFont) == TRUE)
					{
						SelFont = YES;
						memcpy(&TmpLogFont, &TmpTmpLogFont, sizeof(LOGFONT));
						SendDlgItemMessage(hDlg, EXT_FONT, WM_SETTEXT, 0, (LPARAM)TmpLogFont.lfFaceName);
					}
					break;

				case EXT_FOLDRIGHT :
					if(SendDlgItemMessage(hDlg, EXT_FOLDRIGHT, BM_GETCHECK, 0, 0) == 1)
					{
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD), FALSE);
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD), TRUE);
						EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), TRUE);
					}
					break;

			}
			return(TRUE);

		case WM_DRAWITEM :
			switch(wParam)
			{
				case EXT_TEXTCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpTextColor);
					break;

				case EXT_HIGHCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpHighColor);
					break;

				case EXT_BACKCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpBackColor);
					break;

				case EXT_CTRLCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpCtrlColor);
					break;

				case EXT_FINDCOLOR :
					DrawColorButton((DRAWITEMSTRUCT *)lParam, TmpFindColor);
					break;
			}
			return(TRUE);
	}
    return(FALSE);
}


/*----- gqʐݒ_CAOɑ ----------------------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		EXTSET *Tbl : ݒe[u
*		int Num : ݒԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void SetExtSetToDialog(HWND hDlg, EXTSET *Tbl, int Num)
{
	char *Pos;

	Tbl += Num;
	SetDecimalText(hDlg, EXT_TAB, Tbl->TabWidth);
	SetDecimalText(hDlg, EXT_FOLD, Tbl->FoldPos);
	SetDecimalText(hDlg, EXT_LINESPC, Tbl->LineSpace);
	SendDlgItemMessage(hDlg, EXT_CRMARK, BM_SETCHECK, Tbl->CrMark, 0);
	SendDlgItemMessage(hDlg, EXT_EXTIN, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_RESETCONTENT, 0, 0);
	Pos = Tbl->Exts;
	while(*Pos != NUL)
	{
		SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_ADDSTRING, 0, (LPARAM)Pos);
		Pos += strlen(Pos) + 1;
	}

	TmpTextColor = Tbl->TextColor;
	TmpHighColor = Tbl->HighColor;
	TmpBackColor = Tbl->BackColor;
	TmpCtrlColor = Tbl->CtrlColor;
	TmpFindColor = Tbl->FindColor;
	InvalidateRgn(GetDlgItem(hDlg, EXT_TEXTCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(hDlg, EXT_HIGHCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(hDlg, EXT_BACKCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(hDlg, EXT_CTRLCOLOR), NULL, TRUE);
	InvalidateRgn(GetDlgItem(hDlg, EXT_FINDCOLOR), NULL, TRUE);

	memcpy(&TmpLogFont, &Tbl->Font, sizeof(LOGFONT));
	SendDlgItemMessage(hDlg, EXT_FONT, WM_SETTEXT, 0, (LPARAM)Tbl->Font.lfFaceName);

	SendDlgItemMessage(hDlg, EXT_LINENUM, BM_SETCHECK, Tbl->LineNumDisp, 0);
	SetRadioButtonByValue(hDlg, Tbl->LineNumType, LineNumButton, LINENUMBUTTONS);

	SendDlgItemMessage(hDlg, EXT_FOLDRIGHT, BM_SETCHECK, Tbl->FoldRight, 0);
	if(Tbl->FoldRight == YES)
	{
		EnableWindow(GetDlgItem(hDlg, EXT_FOLD), FALSE);
		EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hDlg, EXT_FOLD), TRUE);
		EnableWindow(GetDlgItem(hDlg, EXT_FOLD_SPN), TRUE);
	}

	return;
}


/*----- gqʐݒ_CAO󂯎 ----------------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		EXTSET *Tbl : ݒe[u
*		int Num : ݒԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void GetExtSetFromDialog(HWND hDlg, EXTSET *Tbl, int Num)
{
	int i;
	char Tmp[EXT_EXT_LEN+1];

	Tbl += Num;
	Tbl->TabWidth = GetDecimalText(hDlg, EXT_TAB);
	CheckRange2(&Tbl->TabWidth, 16, 2);
	Tbl->FoldPos = GetDecimalText(hDlg, EXT_FOLD);
	CheckRange2(&Tbl->FoldPos, 260, 5);
	Tbl->LineSpace = GetDecimalText(hDlg, EXT_LINESPC);
	CheckRange2(&Tbl->LineSpace, 99, 0);
	Tbl->CrMark = SendDlgItemMessage(hDlg, EXT_CRMARK, BM_GETCHECK, 0, 0);

	memset(Tbl->Exts, NUL, EXT_EXT_LEN);
	Num = SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETCOUNT, 0, 0);
	for(i = 0; i < Num; i++)
	{
		SendDlgItemMessage(hDlg, EXT_EXTLIST, LB_GETTEXT, i, (LPARAM)Tmp);
		strcpy(Tbl->Exts + AskMultiStrLen(Tbl->Exts), Tmp);
	}

	Tbl->TextColor = TmpTextColor;
	Tbl->HighColor = TmpHighColor;
	Tbl->BackColor = TmpBackColor;
	Tbl->CtrlColor = TmpCtrlColor;
	Tbl->FindColor = TmpFindColor;

	memcpy(&Tbl->Font, &TmpLogFont, sizeof(LOGFONT));

	Tbl->LineNumDisp = SendDlgItemMessage(hDlg, EXT_LINENUM, BM_GETCHECK, 0, 0);
	Tbl->LineNumType = AskRadioButtonValue(hDlg, LineNumButton, LINENUMBUTTONS);

	Tbl->FoldRight = SendDlgItemMessage(hDlg, EXT_FOLDRIGHT, BM_GETCHECK, 0, 0);

	return;
}


/*----- gqʐݒ_CAÕnCh ------------------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		int Num : ݒԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void SetExtSetHide(HWND hDlg, int Num)
{
	BOOL Disp;

	Disp = TRUE;
	if(Num == 0)
		Disp = FALSE;

	EnableWindow(GetDlgItem(hDlg, EXT_DEL), Disp);
	EnableWindow(GetDlgItem(hDlg, EXT_EXTIN), Disp);
	EnableWindow(GetDlgItem(hDlg, EXT_EXTLIST), Disp);
	EnableWindow(GetDlgItem(hDlg, EXT_EXTADD), Disp);
	EnableWindow(GetDlgItem(hDlg, EXT_EXTDEL), Disp);
	return;
}


/*----- ݒEChẼbZ[W ------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK KeySettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *pnmhdr;
	static const RADIOBUTTON BellButton[] = {
		{ KEY_ERR_BELL, YES },
		{ KEY_ERR_NONE, NO }
	};
	#define BELLBUTTONS	(sizeof(BellButton)/sizeof(RADIOBUTTON))

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)"Windows");
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)"Less");
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)"DOS");
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_ADDSTRING, 0, (LPARAM)"Windows2");
			SendDlgItemMessage(hDlg, KEY_TYPE, CB_SETCURSEL, UItype, 0);
			SetRadioButtonByValue(hDlg, ErrBell, BellButton, BELLBUTTONS);
			SendDlgItemMessage(hDlg, KEY_HIST, EM_LIMITTEXT, (WPARAM)2, 0);
			SetDecimalText(hDlg, KEY_HIST, FileHist);
			SendDlgItemMessage(hDlg, KEY_HIST_SPN, UDM_SETRANGE, 0, (LPARAM)MAKELONG(HISTORY_MAX, 0));
			SendDlgItemMessage(hDlg, KEY_MOUSECARET, BM_SETCHECK, DispCaret, 0);
			SendDlgItemMessage(hDlg, KEY_MOUSECOPY, BM_SETCHECK, MouseCopy, 0); // ǉ
			SendDlgItemMessage(hDlg, KEY_CLICKABLE_MAP, BM_SETCHECK, ClickableMap, 0); // ǉ
			SendDlgItemMessage(hDlg, KEY_SMOOTH, BM_SETCHECK, SmoothLine, 0);
			SendDlgItemMessage(hDlg, KEY_PAGESMOOTH, BM_SETCHECK, SmoothPage, 0);
			SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_SETRANGE, TRUE, MAKELPARAM(1, 30));
			SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_SETPOS, TRUE, SmoothRate);
			return(TRUE);

		case WM_NOTIFY :
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					UItype = SendDlgItemMessage(hDlg, KEY_TYPE, CB_GETCURSEL, 0, 0);
					ErrBell = AskRadioButtonValue(hDlg, BellButton, BELLBUTTONS);
					FileHist = GetDecimalText(hDlg, KEY_HIST);
					CheckRange2(&FileHist, HISTORY_MAX, 0);
					DispCaret = SendDlgItemMessage(hDlg, KEY_MOUSECARET, BM_GETCHECK, 0, 0);
					MouseCopy = SendDlgItemMessage(hDlg, KEY_MOUSECOPY, BM_GETCHECK, 0, 0); // ǉ
					ClickableMap = SendDlgItemMessage(hDlg, KEY_CLICKABLE_MAP, BM_GETCHECK, 0, 0); // ǉ
					SmoothLine = SendDlgItemMessage(hDlg, KEY_SMOOTH, BM_GETCHECK, 0, 0);
					SmoothPage = SendDlgItemMessage(hDlg, KEY_PAGESMOOTH, BM_GETCHECK, 0, 0);
					SmoothRate = SendDlgItemMessage(hDlg, KEY_SMOOTHRATE, TBM_GETPOS, 0, 0);
					Apply = YES;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 11);
					break;
			}
			break;
	}
    return(FALSE);
}


/*----- c[ݒEChẼbZ[W ----------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK ToolSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *pnmhdr;
	char Tmp[MAX_PATH+1];

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, TOOL_EDITOR, EM_LIMITTEXT, MAX_PATH-EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_EUC, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_JIS, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_SJIS, EM_LIMITTEXT, EDITOR_OPT_LEN, 0);
			SendDlgItemMessage(hDlg, TOOL_EDITOR, WM_SETTEXT, 0, (LPARAM)EditorName);
			SendDlgItemMessage(hDlg, TOOL_EUC, WM_SETTEXT, 0, (LPARAM)EditOptEUC);
			SendDlgItemMessage(hDlg, TOOL_JIS, WM_SETTEXT, 0, (LPARAM)EditOptJIS);
			SendDlgItemMessage(hDlg, TOOL_SJIS, WM_SETTEXT, 0, (LPARAM)EditOptSJIS);
			SendDlgItemMessage(hDlg, TOOL_SJISONLY, BM_SETCHECK, EditSjisAlways, 0);
			SendDlgItemMessage(hDlg, TOOL_EDITCLOSE, BM_SETCHECK, EditAndClose, 0);
			SendDlgItemMessage(hDlg, TOOL_EDITRELOAD, BM_SETCHECK, EditAutoReLoad, 0);
			if(EditSjisAlways == YES)
			{
				EnableWindow(GetDlgItem(hDlg, TOOL_EUC), FALSE);
				EnableWindow(GetDlgItem(hDlg, TOOL_JIS), FALSE);
			}
			if(EditAndClose == YES)
				EnableWindow(GetDlgItem(hDlg, TOOL_EDITRELOAD), FALSE);
			return(TRUE);

		case WM_NOTIFY :
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					SendDlgItemMessage(hDlg, TOOL_EDITOR, WM_GETTEXT, MAX_PATH+1-EDITOR_OPT_LEN, (LPARAM)EditorName);
					SendDlgItemMessage(hDlg, TOOL_EUC, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)EditOptEUC);
					SendDlgItemMessage(hDlg, TOOL_JIS, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)EditOptJIS);
					SendDlgItemMessage(hDlg, TOOL_SJIS, WM_GETTEXT, EDITOR_OPT_LEN+1, (LPARAM)EditOptSJIS);
					EditSjisAlways = SendDlgItemMessage(hDlg, TOOL_SJISONLY, BM_GETCHECK, 0, 0);
					EditAndClose = SendDlgItemMessage(hDlg, TOOL_EDITCLOSE, BM_GETCHECK, 0, 0);
					EditAutoReLoad = SendDlgItemMessage(hDlg, TOOL_EDITRELOAD, BM_GETCHECK, 0, 0);
					Apply = YES;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 9);
					break;
			}
			break;

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case TOOL_EDITOR_BR :
					if(SelectFileToOpen(hDlg, Tmp, "GfB^̑I",
						 "st@C\0*.exe;*.com;*.bat\0SĂ̧\0*\0") == TRUE)
					{
						SendDlgItemMessage(hDlg, TOOL_EDITOR, WM_SETTEXT, 0, (LPARAM)Tmp);
					}
					break;

				case TOOL_SJISONLY :
					if(SendDlgItemMessage(hDlg, TOOL_SJISONLY, BM_GETCHECK, 0, 0) == 1)
					{
						EnableWindow(GetDlgItem(hDlg, TOOL_EUC), FALSE);
						EnableWindow(GetDlgItem(hDlg, TOOL_JIS), FALSE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg, TOOL_EUC), TRUE);
						EnableWindow(GetDlgItem(hDlg, TOOL_JIS), TRUE);
					}
					break;

				case TOOL_EDITCLOSE :
					if(SendDlgItemMessage(hDlg, TOOL_EDITCLOSE, BM_GETCHECK, 0, 0) == 1)
						EnableWindow(GetDlgItem(hDlg, TOOL_EDITRELOAD), FALSE);
					else
						EnableWindow(GetDlgItem(hDlg, TOOL_EDITRELOAD), TRUE);
					break;

			}
			return(TRUE);
	}
    return(FALSE);
}


/*----- ̑ݒEChẼbZ[W ----------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK MiscSettingProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *pnmhdr;
	int oldGrepWndPortrait;

	switch (message)
	{
		case WM_INITDIALOG :
			SendDlgItemMessage(hDlg, MISC_SAVESIZE, BM_SETCHECK, SaveWinSize, 0);
			SendDlgItemMessage(hDlg, MISC_SAVEPOS, BM_SETCHECK, SaveWinPos, 0);
			SendDlgItemMessage(hDlg, MISC_INISAVE, BM_SETCHECK, RegType, 0);
			SendDlgItemMessage(hDlg, MISC_TOOLBAR, BM_SETCHECK, ToolBar, 0);
			SendDlgItemMessage(hDlg, MISC_STSBAR, BM_SETCHECK, StatusBar, 0);
			SendDlgItemMessage(hDlg, MISC_QUOTE, EM_LIMITTEXT, QUOTE_MAXLEN, 0);
			SendDlgItemMessage(hDlg, MISC_QUOTE, WM_SETTEXT, 0, (LPARAM)QuoteStr);
			SendDlgItemMessage(hDlg, MISC_HIGHLIGHT_URL, BM_SETCHECK, HighlightURL, 0 );
			SendDlgItemMessage(hDlg, KEY_GREP_PORTRAIT, BM_SETCHECK, GrepWndPortrait, 0);
			return(TRUE);

		case WM_NOTIFY:
			pnmhdr = (NMHDR FAR *)lParam;
			switch(pnmhdr->code)
			{
				case PSN_APPLY :
					SaveWinSize = SendDlgItemMessage(hDlg, MISC_SAVESIZE, BM_GETCHECK, 0, 0);
					SaveWinPos = SendDlgItemMessage(hDlg, MISC_SAVEPOS, BM_GETCHECK, 0, 0);
					RegType = SendDlgItemMessage(hDlg, MISC_INISAVE, BM_GETCHECK, 0, 0);
					ToolBar = SendDlgItemMessage(hDlg, MISC_TOOLBAR, BM_GETCHECK, 0, 0);
					StatusBar = SendDlgItemMessage(hDlg, MISC_STSBAR, BM_GETCHECK, 0, 0);
					SendDlgItemMessage(hDlg, MISC_QUOTE, WM_GETTEXT, QUOTE_MAXLEN+1, (LPARAM)QuoteStr);
					HighlightURL = SendDlgItemMessage(hDlg, MISC_HIGHLIGHT_URL, BM_GETCHECK, 0, 0 );
					GrepWndPortrait = SendDlgItemMessage(hDlg, KEY_GREP_PORTRAIT, BM_GETCHECK, 0, 0); // ǉ
					if(oldGrepWndPortrait != GrepWndPortrait)
						SetGrepWindowDefaultSize();
					Apply = YES;
					break;

				case PSN_RESET :
					break;

				case PSN_HELP :
					WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 16);
					break;
			}
			break;
	}
    return(FALSE);
}


/*----- FĨR_CAOЂ炭 --------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		COLORREF *Col : FԂ[N
*		EXTSET *Tbl : ݒe[u
*		int Num : ݒ̌
*
*	Return Value
*		int Xe[^X
*			TRUE/FALSE=
*----------------------------------------------------------------------------*/

static int SelectColor(HWND hWnd, COLORREF *Col, EXTSET *Tbl, int Num)
{
	CHOOSECOLOR cColor;
	COLORREF Cust[16];
	BOOL Sts;
	int i;
	int j;

	memset(Cust, 0, 16 * sizeof(COLORREF));
	Cust[0] = *Col;
	j = 1;
	for(i = 0; i < Num; i++)
	{
		j = SerDefinedColor(j, Cust, Tbl[i].TextColor);
		j = SerDefinedColor(j, Cust, Tbl[i].HighColor);
		j = SerDefinedColor(j, Cust, Tbl[i].CtrlColor);
		j = SerDefinedColor(j, Cust, Tbl[i].BackColor);
		j = SerDefinedColor(j, Cust, Tbl[i].FindColor);
	}

	cColor.lStructSize = sizeof(CHOOSECOLOR);
	cColor.hwndOwner = hWnd;
	cColor.hInstance = 0;
	cColor.rgbResult = *Col;
	cColor.lpCustColors = Cust;
	cColor.Flags = CC_RGBINIT | CC_FULLOPEN;

	if((Sts = ChooseColor(&cColor)) == TRUE)
		*Col = cColor.rgbResult;

	return((int)Sts);
}


/*----- VFe[uɓo^ ----------------------------------------------
*
*	Parameter
*		int Num : o^ԍ
*		COLORREF *Tbl : e[u
*		COLORREF Color : o^F
*
*	Return Value
*		int ̓o^ԍ
*----------------------------------------------------------------------------*/

static int SerDefinedColor(int Num, COLORREF *Tbl, COLORREF Color)
{
	int i;

	if(Num < 16)
	{
		for(i = 1; i < Num; i++)
		{
			if(Tbl[i] == Color)
				break;
		}
		if(i == Num)
			Tbl[Num++] = Color;
	}
	return(Num);
}


/*----- J[{^` ----------------------------------------------------
*
*	Parameter
*		DRAWITEMSTRUCT *dItem : I[i[h[{^̕`\
*		COLORREF Col : {^\ʂ̐F
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DrawColorButton(DRAWITEMSTRUCT *dItem, COLORREF Col)
{
	HPEN hPenSave;
	HBRUSH hBrush;
	HBRUSH hBrushSave;

	hPenSave = SelectObject(dItem->hDC, GetStockObject(BLACK_PEN));
	hBrush = CreateSolidBrush(Col);
	hBrushSave = SelectObject(dItem->hDC, hBrush);

	Rectangle(dItem->hDC, dItem->rcItem.left, dItem->rcItem.top, dItem->rcItem.right, dItem->rcItem.bottom);

	MoveToEx(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.bottom-2, NULL);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.bottom-2);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.top+1);

	SelectObject(dItem->hDC, GetStockObject(WHITE_PEN));
	MoveToEx(dItem->hDC, dItem->rcItem.left, dItem->rcItem.bottom-1, NULL);
	LineTo(dItem->hDC, dItem->rcItem.left, dItem->rcItem.top);
	LineTo(dItem->hDC, dItem->rcItem.right-1, dItem->rcItem.top);

	MoveToEx(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.bottom-2, NULL);
	LineTo(dItem->hDC, dItem->rcItem.left+1, dItem->rcItem.top+1);
	LineTo(dItem->hDC, dItem->rcItem.right-2, dItem->rcItem.top+1);

	SelectObject(dItem->hDC, hPenSave);
	SelectObject(dItem->hDC, hBrushSave);
	DeleteObject(hBrush);

	return;
}


/*----- _CAÕRg[POi擾 ----------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		int Ctrl : Rg[ID
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static int GetDecimalText(HWND hDlg, int Ctrl)
{
	char Tmp[40];

	SendDlgItemMessage(hDlg, Ctrl, WM_GETTEXT, (WPARAM)39, (LPARAM)Tmp);
	return(atoi(Tmp));
}


/*----- _CAÕRg[ɂPOiZbg ----------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		int Ctrl : Rg[ID
*		int Num : l
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void SetDecimalText(HWND hDlg, int Ctrl, int Num)
{
	char Tmp[40];

	sprintf(Tmp, "%d", Num);
	SendDlgItemMessage(hDlg, Ctrl, WM_SETTEXT, 0, (LPARAM)Tmp);
	return;
}


/*----- ݒl͈̔̓`FbN --------------------------------------------------
*
*	Parameter
*		int *Cur : ݒl
*		int Max : ől
*		int Min : ŏl
*
*	Return Value
*		Ȃ
*
*	Parameter change
*		int *Cur : ݒl
*----------------------------------------------------------------------------*/

static void CheckRange2(int *Cur, int Max, int Min)
{
	if(*Cur < Min)
		*Cur = Min;
	if(*Cur > Max)
		*Cur = Max;
	return;
}


