/*=============================================================================
*								WXg֌W
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <windowsx.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static void SaveStr(HKEY hKey, char *Key, char *Str, char *DefaultStr);
static void SaveIntNum(HKEY hKey, char *Key, int Num, int DefaultNum);
static void MakeFontData(LOGFONT Font, char *Buf);
static int RestoreFontData(char *Str, LOGFONT *Font);

static void SetRegType(int Type);
static int OpenReg(char *Name, void **Handle);
static int CreateReg(char *Name, void **Handle);
static int CloseReg(void *Handle);
static int OpenSubKey(void *Parent, char *Name, void **Handle);
static int CreateSubKey(void *Parent, char *Name, void **Handle);
static int CloseSubKey(void *Handle);
static int DeleteSubKey(void *Handle, char *Name);
static int DeleteValue(void *Handle, char *Name);
static int ReadIntValueFromReg(void *Handle, char *Name, int *Value);
static int WriteIntValueToReg(void *Handle, char *Name, int Value);
static int ReadStringFromReg(void *Handle, char *Name, char *Str, DWORD Size);
static int WriteStringToReg(void *Handle, char *Name, char *Str);
static int ReadMultiStringFromReg(void *Handle, char *Name, char *Str, DWORD Size);
static int WriteMultiStringToReg(void *Handle, char *Name, char *Str);
static int ReadBinaryFromReg(void *Handle, char *Name, void *Bin, DWORD Size);
static int WriteBinaryToReg(void *Handle, char *Name, void *Bin, int Len);

/*===== OQ =====*/

/* ݒl */
extern int WinPosX;
extern int WinPosY;
extern int WinWidth;
extern int WinHeight;
extern int Maximize;

extern int SaveWinSize;
extern int SaveWinPos;
extern int ToolBar;
extern int StatusBar;
extern int RegType;
extern char QuoteStr[QUOTE_MAXLEN+1];

extern EXTSET ExtSetTbl[10];
extern int ExtSetNum;

extern char EditorName[MAX_PATH+1 - EDITOR_OPT_LEN];
extern char EditOptEUC[EDITOR_OPT_LEN+1];
extern char EditOptJIS[EDITOR_OPT_LEN+1];
extern char EditOptSJIS[EDITOR_OPT_LEN+1];
extern int EditSjisAlways;
extern int EditAndClose;
extern int EditAutoReLoad;

extern int UItype;
extern int ErrBell;
extern int FileHist;

extern FINDDLGDATA FindData;
extern char FindHist[FINDHIST_NUM*(FINDSTR_LEN+1)+1];

extern int DispCaret;
extern int MouseCopy; // ǉ
extern int ClickableMap; // ǉ
extern int HighlightURL; // ǉ

extern int GrepWndPortrait; // ǉ

extern int SmoothLine;
extern int SmoothPage;
extern int SmoothRate;

/*===== [Jȃ[N =====*/

static LOGFONT ttPageLogFont = {
	-15, 0,
	FALSE, FALSE, FW_NORMAL, FALSE, FALSE, FALSE,
	SHIFTJIS_CHARSET, OUT_STRING_PRECIS, CLIP_STROKE_PRECIS,
	DRAFT_QUALITY, FIXED_PITCH, "FixedSys"
};

static COLORREF TextColor = RGB(0,0,0);
static COLORREF HighColor = RGB(255,0,0);
static COLORREF BackColor = RGB(255,255,255);
static COLORREF CtrlColor = RGB(0,0,255);
static COLORREF FindColor = RGB(128,128,128);

static int LineNumDisp = NO;
static int LineNumType = LINENUM_WP;



/*----- WXg^INIt@Cɐݒlۑ ---------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SaveRegistory(void)
{
	void *hKey3;
	void *hKey4;
	void *hKey5;
	char Str[256];
	int i;
	char *Buf;

	SetRegType(RegType);
	if(CreateReg("ttPage", &hKey3) == SUCCESS)
	{
		WriteIntValueToReg(hKey3, "RegVer", REGISTORY_VER);

		if(CreateSubKey(hKey3, "Options", &hKey4) == SUCCESS)
		{
			WriteIntValueToReg(hKey4, "WinPosX", WinPosX);
			WriteIntValueToReg(hKey4, "WinPosY", WinPosY);
			WriteIntValueToReg(hKey4, "WinWidth", WinWidth);
			WriteIntValueToReg(hKey4, "WinHeight", WinHeight);
			WriteIntValueToReg(hKey4, "Maximize", Maximize);

			WriteIntValueToReg(hKey4, "PosSave", SaveWinPos);
			WriteIntValueToReg(hKey4, "SizeSave", SaveWinSize);
			WriteIntValueToReg(hKey4, "Tbar", ToolBar);
			WriteIntValueToReg(hKey4, "Sbar", StatusBar);
			WriteIntValueToReg(hKey4, "Reg", RegType);
			WriteStringToReg(hKey4, "Quote", QuoteStr);

			WriteStringToReg(hKey4, "Editor", EditorName);
			WriteStringToReg(hKey4, "EdOptEUC", EditOptEUC);
			WriteStringToReg(hKey4, "EdOptJIS", EditOptJIS);
			WriteStringToReg(hKey4, "EdOptSJIS", EditOptSJIS);
			WriteIntValueToReg(hKey4, "EditSJIS", EditSjisAlways);
			WriteIntValueToReg(hKey4, "EditClose", EditAndClose);
			WriteIntValueToReg(hKey4, "EditReload", EditAutoReLoad);

			WriteIntValueToReg(hKey4, "UI", UItype);
			WriteIntValueToReg(hKey4, "Bell", ErrBell);
			WriteIntValueToReg(hKey4, "HistNum", FileHist);
			WriteIntValueToReg(hKey4, "Caret", DispCaret);
			WriteIntValueToReg(hKey4, "MouseCopy", MouseCopy);
			WriteIntValueToReg(hKey4, "ClickableMap", ClickableMap );
			WriteIntValueToReg(hKey4, "HighlightURL", HighlightURL );
			WriteIntValueToReg(hKey4, "GrepWindowPortrait", GrepWndPortrait );
			WriteIntValueToReg(hKey4, "SmLine", SmoothLine);
			WriteIntValueToReg(hKey4, "SmPage", SmoothPage);
			WriteIntValueToReg(hKey4, "SmRare", SmoothRate);

			if((Buf = malloc((MAX_PATH+1)*HISTORY_MAX+1)) != NULL)
			{
				GetAllHistoryFromMenu(Buf, HISTORY_MAX);
				WriteMultiStringToReg(hKey4, "Hist", Buf);
				free(Buf);
			}

			WriteIntValueToReg(hKey4, "Caps", FindData.CapsFlg);
			WriteIntValueToReg(hKey4, "Regx", FindData.Regexp);
			WriteMultiStringToReg(hKey4, "FindHist", FindHist);

			WriteIntValueToReg(hKey4, "ExtSet", ExtSetNum);
			for(i = 0; i < ExtSetNum; i++)
			{
				sprintf(Str, "Ext%d", i);
				if(CreateSubKey(hKey4, Str, &hKey5) == SUCCESS)
				{
					WriteStringToReg(hKey5, "Name", ExtSetTbl[i].Name);
					WriteMultiStringToReg(hKey5, "Ext", ExtSetTbl[i].Exts);
					WriteIntValueToReg(hKey5, "Tab", ExtSetTbl[i].TabWidth);
					WriteIntValueToReg(hKey5, "Fold", ExtSetTbl[i].FoldPos);
					WriteIntValueToReg(hKey5, "LineSp", ExtSetTbl[i].LineSpace);
					WriteIntValueToReg(hKey5, "Cr", ExtSetTbl[i].CrMark);

					MakeFontData(ExtSetTbl[i].Font, Str);
					WriteStringToReg(hKey5, "Font", Str);

					WriteBinaryToReg(hKey5, "TextCol", &ExtSetTbl[i].TextColor, sizeof(COLORREF));
					WriteBinaryToReg(hKey5, "HighCol", &ExtSetTbl[i].HighColor, sizeof(COLORREF));
					WriteBinaryToReg(hKey5, "BackCol", &ExtSetTbl[i].BackColor, sizeof(COLORREF));
					WriteBinaryToReg(hKey5, "CtrlCol", &ExtSetTbl[i].CtrlColor, sizeof(COLORREF));
					WriteBinaryToReg(hKey5, "FindCol", &ExtSetTbl[i].FindColor, sizeof(COLORREF));

					WriteIntValueToReg(hKey5, "LineNum", ExtSetTbl[i].LineNumDisp);
					WriteIntValueToReg(hKey5, "LineType", ExtSetTbl[i].LineNumType);

					WriteIntValueToReg(hKey5, "FoldRight", ExtSetTbl[i].FoldRight);

					CloseSubKey(hKey5);
				}
			}
			for(; i < EXT_SET_NUM; i++)
			{
				sprintf(Str, "Ext%d", i);
				if(RegDeleteKey(hKey4, Str) != ERROR_SUCCESS)
					break;
			}
			CloseSubKey(hKey4);
		}
		CloseReg(hKey3);
	}
	return;
}


/*----- WXg^INIt@CݒlĂяo ---------------------------
*
*	Parameter
*		char *Hist : qXgRs[obt@
*
*	Return Value
*		int ݒ肪ǂ
*			YES/NO=ݒ薳
*----------------------------------------------------------------------------*/

int LoadRegistory(char *Hist)
{
	void *hKey3;
	void *hKey4;
	void *hKey5;
	char Str[256];
	int Sts;
	int i;
	int Ver;
	char TmpExts[EXT_EXT_LEN+1];
	char *Get;
	char *Put;

	Sts = NO;

	*Hist = NUL;

//	SetRegType(REGTYPE_REG);
	SetRegType(REGTYPE_INI);
	if((i = OpenReg("ttPage", &hKey3)) != SUCCESS)
	{
		SetRegType(REGTYPE_REG);
//		SetRegType(REGTYPE_INI);
		i = OpenReg("ttPage", &hKey3);
	}

	if(i == SUCCESS)
	{
		Ver = 0;
		ReadIntValueFromReg(hKey3, "RegVer", &Ver);

		Sts = YES;
		if(OpenSubKey(hKey3, "Options", &hKey4) == SUCCESS)
		{
			ReadIntValueFromReg(hKey4, "WinPosX", &WinPosX);
			ReadIntValueFromReg(hKey4, "WinPosY", &WinPosY);
			ReadIntValueFromReg(hKey4, "WinWidth", &WinWidth);
			ReadIntValueFromReg(hKey4, "WinHeight", &WinHeight);
			ReadIntValueFromReg(hKey4, "Maximize", &Maximize);

			ReadIntValueFromReg(hKey4, "PosSave", &SaveWinPos);
			SaveWinSize = SaveWinPos;	// V0.95ȑÔ߂
			ReadIntValueFromReg(hKey4, "SizeSave", &SaveWinSize);
			ReadIntValueFromReg(hKey4, "Tbar", &ToolBar);
			ReadIntValueFromReg(hKey4, "Sbar", &StatusBar);
			ReadIntValueFromReg(hKey4, "Reg", &RegType);
			ReadStringFromReg(hKey4, "Quote", QuoteStr, QUOTE_MAXLEN+1);

			ReadStringFromReg(hKey4, "Editor", EditorName, MAX_PATH+1 - EDITOR_OPT_LEN);
			ReadStringFromReg(hKey4, "EdOptEUC", EditOptEUC, EDITOR_OPT_LEN+1);
			ReadStringFromReg(hKey4, "EdOptJIS", EditOptJIS, EDITOR_OPT_LEN+1);
			ReadStringFromReg(hKey4, "EdOptSJIS", EditOptSJIS, EDITOR_OPT_LEN+1);
			ReadIntValueFromReg(hKey4, "EditSJIS", &EditSjisAlways);
			ReadIntValueFromReg(hKey4, "EditClose", &EditAndClose);
			ReadIntValueFromReg(hKey4, "EditReload", &EditAutoReLoad);
			if(Ver == 0) strcat(EditorName, " $K $F");

			ReadIntValueFromReg(hKey4, "UI", &UItype);
			ReadIntValueFromReg(hKey4, "Bell", &ErrBell);
			ReadIntValueFromReg(hKey4, "HistNum", &FileHist);
			ReadIntValueFromReg(hKey4, "Caret", &DispCaret);
			ReadIntValueFromReg(hKey4, "MouseCopy", &MouseCopy); // ǉ
			ReadIntValueFromReg(hKey4, "ClickableMap", &ClickableMap ); // ǉ
			ReadIntValueFromReg(hKey4, "HighlightURL", &HighlightURL ); // ǉ
			ReadIntValueFromReg(hKey4, "GrepWindowPortrait", &GrepWndPortrait ); // ǉ
			ReadIntValueFromReg(hKey4, "SmLine", &SmoothLine);
			ReadIntValueFromReg(hKey4, "SmPage", &SmoothPage);
			ReadIntValueFromReg(hKey4, "SmRare", &SmoothRate);

			ReadMultiStringFromReg(hKey4, "Hist", Hist, (MAX_PATH+1)*HISTORY_MAX+1);

			ReadIntValueFromReg(hKey4, "Caps", &FindData.CapsFlg);
			ReadIntValueFromReg(hKey4, "Regx", &FindData.Regexp);
			ReadMultiStringFromReg(hKey4, "FindHist", FindHist, FINDHIST_NUM*(FINDSTR_LEN+1)+1);

			/* ȉ̐ݒ͊gqʂɈڂꂽAłȂo[W */
			/* ȍ~ɔāAΓǂݏoĂ */
			if(ReadStringFromReg(hKey4, "Font", Str, 256) == SUCCESS)
				RestoreFontData(Str, &ttPageLogFont);

			ReadBinaryFromReg(hKey4, "TextCol", &TextColor, sizeof(COLORREF));
			ReadBinaryFromReg(hKey4, "HighCol", &HighColor, sizeof(COLORREF));
			ReadBinaryFromReg(hKey4, "BackCol", &BackColor, sizeof(COLORREF));
			ReadBinaryFromReg(hKey4, "CtrlCol", &CtrlColor, sizeof(COLORREF));
			ReadBinaryFromReg(hKey4, "FindCol", &FindColor, sizeof(COLORREF));

			ReadIntValueFromReg(hKey4, "LineNum", &LineNumDisp);
			ReadIntValueFromReg(hKey4, "LineType", &LineNumType);

			/* gqʂ̐ݒ */
			ReadIntValueFromReg(hKey4, "ExtSet", &ExtSetNum);
			for(i = 0; i < ExtSetNum; i++)
			{
				sprintf(Str, "Ext%d", i);
				if(OpenSubKey(hKey4, Str, &hKey5) == SUCCESS)
				{

					ExtSetTbl[i].FoldRight = NO;

					/* zFAtHgAsԍ̐ݒ肪gqʂłȂo[W*/
					/* ̐ݒ̓ǂݏoɔ */
					ExtSetTbl[i].TextColor = TextColor;
					ExtSetTbl[i].HighColor = HighColor;
					ExtSetTbl[i].BackColor = BackColor;
					ExtSetTbl[i].CtrlColor = CtrlColor;
					ExtSetTbl[i].FindColor = FindColor;
					memcpy(&ExtSetTbl[i].Font, &ttPageLogFont, sizeof(LOGFONT));
					ExtSetTbl[i].LineNumDisp = LineNumDisp;
					ExtSetTbl[i].LineNumType = LineNumType;

					ReadStringFromReg(hKey5, "Name", ExtSetTbl[i].Name, EXT_NAME_LEN+1);

					if(Ver >= REGISTORY_VER)
						ReadMultiStringFromReg(hKey5, "Ext", ExtSetTbl[i].Exts, EXT_EXT_LEN+1);
					else
					{
						/* gqݒt@CɕύX */
						/* ext  *.ext */
						ReadMultiStringFromReg(hKey5, "Ext", TmpExts, EXT_EXT_LEN+1);
						Get = TmpExts;
						Put = ExtSetTbl[i].Exts;
						while(*Get != NUL)
						{
							strcpy(Put, "*.");
							strcpy(Put+2, Get);
							Put += strlen(Put) + 1;
							Get += strlen(Get) + 1;
						}
					}

					ReadIntValueFromReg(hKey5, "Tab", &ExtSetTbl[i].TabWidth);
					ReadIntValueFromReg(hKey5, "Fold", &ExtSetTbl[i].FoldPos);
					ReadIntValueFromReg(hKey5, "LineSp", &ExtSetTbl[i].LineSpace);
					ReadIntValueFromReg(hKey5, "Cr", &ExtSetTbl[i].CrMark);


					if(ReadStringFromReg(hKey5, "Font", Str, 256) == SUCCESS)
						RestoreFontData(Str, &ExtSetTbl[i].Font);

					ReadBinaryFromReg(hKey5, "TextCol", &ExtSetTbl[i].TextColor, sizeof(COLORREF));
					ReadBinaryFromReg(hKey5, "HighCol", &ExtSetTbl[i].HighColor, sizeof(COLORREF));
					ReadBinaryFromReg(hKey5, "BackCol", &ExtSetTbl[i].BackColor, sizeof(COLORREF));
					ReadBinaryFromReg(hKey5, "CtrlCol", &ExtSetTbl[i].CtrlColor, sizeof(COLORREF));
					ReadBinaryFromReg(hKey5, "FindCol", &ExtSetTbl[i].FindColor, sizeof(COLORREF));

					ReadIntValueFromReg(hKey5, "LineNum", &ExtSetTbl[i].LineNumDisp);
					ReadIntValueFromReg(hKey5, "LineType", &ExtSetTbl[i].LineNumType);

					ReadIntValueFromReg(hKey5, "FoldRight", &ExtSetTbl[i].FoldRight);

					CloseSubKey(hKey5);
				}
			}
			CloseSubKey(hKey4);
		}
		CloseReg(hKey3);
	}
	return(Sts);
}


/*----- WXg̐ݒlNA --------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void ClearRegistory(void)
{
	HKEY hKey2;
	HKEY hKey3;
	HKEY hKey4;
	DWORD Dispos;
	int i;
	char Str[20];

	if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Sota", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey2, &Dispos) == ERROR_SUCCESS)
	{
		if(RegCreateKeyEx(hKey2, "ttPage", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey3, &Dispos) == ERROR_SUCCESS)
		{
			if(RegCreateKeyEx(hKey3, "Options", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey4, &Dispos) == ERROR_SUCCESS)
			{
				for(i = 0; ; i++)
				{
					sprintf(Str, "Ext%d", i);
					if(RegDeleteKey(hKey4, Str) != ERROR_SUCCESS)
						break;
				}
				RegCloseKey(hKey4);
			}
			RegDeleteKey(hKey3, "Options");
			RegCloseKey(hKey3);
		}
		RegDeleteKey(hKey2, "ttPage");
		RegCloseKey(hKey2);
	}
	return;
}


/*----- WXg/INIt@CɕZ[u --------------------------------
*
*	Parameter
*		HKEY hKey : WXgL[
*		char *Key : L[
*		char *Str : Z[u镶
*		char *DefaultStr : ftHg̕
*
*	Return Value
*		Ȃ
*
*	Note
*		񂪃ftHg̕ƓȂZ[uȂ
*----------------------------------------------------------------------------*/

static void SaveStr(HKEY hKey, char *Key, char *Str, char *DefaultStr)
{
	if((DefaultStr != NULL) && (strcmp(Str, DefaultStr) == 0))
		DeleteValue(hKey, Key);
	else
		WriteStringToReg(hKey, Key, Str);

	return;
}


/*----- WXg/INIt@Cɐl(INT)Z[u -----------------------------
*
*	Parameter
*		HKEY hKey : WXgL[
*		char *Key : L[
*		int Num : Z[ul
*		int DefaultNum : ftHg̒l
*
*	Return Value
*		Ȃ
*
*	Note
*		lftHg̒lƓȂZ[uȂ
*----------------------------------------------------------------------------*/

static void SaveIntNum(HKEY hKey, char *Key, int Num, int DefaultNum)
{
	if(Num == DefaultNum)
		DeleteValue(hKey, Key);
	else
		WriteIntValueToReg(hKey, Key, Num);

	return;
}


/*----- LOGFONTf[^𕶎ɕϊ ---------------------------------------
*
*	Parameter
*		LOGFONT Font : tHgf[^
*		char *Buf : obt@
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void MakeFontData(LOGFONT Font, char *Buf)
{
	*Buf = NUL;
	sprintf(Buf, "%d %d %d %d %d %d %d %d %d %d %d %d %d %s",
		Font.lfHeight, Font.lfWidth, Font.lfEscapement, Font.lfOrientation,
		Font.lfWeight, Font.lfItalic, Font.lfUnderline, Font.lfStrikeOut,
		Font.lfCharSet, Font.lfOutPrecision, Font.lfClipPrecision,
		Font.lfQuality, Font.lfPitchAndFamily, Font.lfFaceName);
	return;
}


/*----- LOGFONTf[^ɕϊ ---------------------------------------
*
*	Parameter
*		char *Str : 
*		LOGFONT *Font : tHgf[^
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL=ϊłȂ
*----------------------------------------------------------------------------*/

static int RestoreFontData(char *Str, LOGFONT *Font)
{
	int i;
	int Sts;

	Sts = FAIL;
	if(sscanf(Str, "%d %d %d %d %d %d %d %d %d %d %d %d %d",
			&(Font->lfHeight), &(Font->lfWidth), &(Font->lfEscapement), &(Font->lfOrientation),
			&(Font->lfWeight), &(Font->lfItalic), &(Font->lfUnderline), &(Font->lfStrikeOut),
			&(Font->lfCharSet), &(Font->lfOutPrecision), &(Font->lfClipPrecision),
			&(Font->lfQuality), &(Font->lfPitchAndFamily)) == 13)
	{
		for(i = 13; i > 0; i--)
		{
			if((Str = strchr(Str, ' ')) == NULL)
				break;
			Str++;
		}
		if(i == 0)
		{
			strcpy(Font->lfFaceName, Str);
			Sts = SUCCESS;
		}
	}

	if(Sts == FAIL)
		memset(Font, NUL, sizeof(LOGFONT));

	return(Sts);
}



/*===== WXgINIt@C̃ANZX ============*/


/*===== INIt@Cp̃WXgf[^ =====*/

typedef struct regdatatbl {
	char KeyName[80+1];			/* L[ */
	char ValTbl[REG_SECT_MAX];	/* l̃e[u */
	int ValLen;					/* lf[^̃oCg */
	int Mode;					/* L[̃[h */
	struct regdatatbl *Next;
} REGDATATBL;

/*===== vg^Cv =====*/

static void WriteOutRegToFile(REGDATATBL *Pos);
static int ReadInReg(char *Name, REGDATATBL **Handle);
static int StrCatOut(char *Src, int Len, char *Dst);
static int StrReadIn(char *Src, int Max, char *Dst);
static char *ScanValue(void *Handle, char *Name);


/*===== [Jȃ[N =====*/

static int TmpRegType;



/*----- WXg̃^Cvݒ肷 ------------------------------------------
*
*	Parameter
*		int Type : ^Cv (REGTYPE_xxx)
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static void SetRegType(int Type)
{
	TmpRegType = Type;
	return;
}


/*----- WXg/INIt@CI[viǂݍ݁j-----------------------
*
*	Parameter
*		char *Name : WXg
*		void **Handle : nhԂ[N
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int OpenReg(char *Name, void **Handle)
{
	int Sts;
	char Tmp[MAX_PATH+1];

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		strcpy(Tmp, "Software\\Sota\\");
		strcat(Tmp, Name);
		if(RegOpenKeyEx(HKEY_CURRENT_USER, Tmp, 0, KEY_READ, (HKEY *)Handle) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		if((Sts = ReadInReg(Name, (REGDATATBL **)Handle)) == SUCCESS)
			((REGDATATBL *)(*Handle))->Mode = 0;
	}
	return(Sts);
}


/*----- WXg/INIt@C쐬i݁j---------------------------
*
*	Parameter
*		char *Name : WXg
*		void **Handle : nhԂ[N
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int CreateReg(char *Name, void **Handle)
{
	int Sts;
	char Tmp[MAX_PATH+1];
	DWORD Dispos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		strcpy(Tmp, "Software\\Sota\\");
		strcat(Tmp, Name);
		if(RegCreateKeyEx(HKEY_CURRENT_USER, Tmp, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, (HKEY *)Handle, &Dispos) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		if((*Handle = malloc(sizeof(REGDATATBL))) != NULL)
		{
			strcpy(((REGDATATBL *)(*Handle))->KeyName, Name);
			((REGDATATBL *)(*Handle))->ValLen = 0;
			((REGDATATBL *)(*Handle))->Next = NULL;
			((REGDATATBL *)(*Handle))->Mode = 1;
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*----- WXg/INIt@CN[Y ----------------------------------
*
*	Parameter
*		void *Handle : nh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int CloseReg(void *Handle)
{
	REGDATATBL *Pos;
	REGDATATBL *Next;

	if(TmpRegType == REGTYPE_REG)
	{
		RegCloseKey(Handle);
	}
	else
	{
		if(((REGDATATBL *)Handle)->Mode == 1)
			WriteOutRegToFile(Handle);

		/* e[u폜 */
		Pos = Handle;
		while(Pos != NULL)
		{
			Next = Pos->Next;
			free(Pos);
			Pos = Next;
		}
	}
	return(SUCCESS);
}


/*----- WXgINIt@Cɏ ---------------------------------
*
*	Parameter
*		REGDATATBL *Pos : WXgf[^
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void WriteOutRegToFile(REGDATATBL *Pos)
{
	char Fname[MAX_PATH+1];
	FILE *Strm;
	char *Disp;

	GetModuleFileName(NULL, Fname, MAX_PATH);
	strcpy(GetFileName(Fname), Pos->KeyName);
	strcat(Fname, ".ini");

	if((Strm = fopen(Fname, "wt")) != NULL)
	{
		fprintf(Strm, "# ̃t@C͕ҏWȂłB\n");
		while(Pos != NULL)
		{
			fprintf(Strm, "\n[%s]\n", Pos->KeyName);

			Disp = Pos->ValTbl;
			while(Disp < (Pos->ValTbl + Pos->ValLen))
			{
				fprintf(Strm, "%s\n", Disp);
				Disp = Disp + strlen(Disp) + 1;
			}
			Pos = Pos->Next;
		}
		fclose(Strm);

//		/* ̓ǂݍݎ̂߂ɃWXgNA */
//		ClearRegistory();
	}
	else
		MessageBox(NULL, "INIt@Cɐݒ肪ۑł܂", "ttPage", MB_OK);
	return;
}


/*----- INIt@C烌WXgǂݍ -------------------------------
*
*	Parameter
*		char *Name : O
*		void *Handle : nh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int ReadInReg(char *Name, REGDATATBL **Handle)
{
	char Fname[MAX_PATH+1];
	FILE *Strm;
	char *Buf;
	char *Tmp;
	char *Data;
	REGDATATBL *New;
	REGDATATBL *Pos;
	int Sts;

	Sts = FAIL;
	*Handle = NULL;

	GetModuleFileName(NULL, Fname, MAX_PATH);
	strcpy(GetFileName(Fname), Name);
	strcat(Fname, ".ini");

	if((Strm = fopen(Fname, "rt")) != NULL)
	{
		if((Buf = malloc(REG_SECT_MAX)) != NULL)
		{
			while(fgets(Buf, REG_SECT_MAX, Strm) != NULL)
			{
				if(*Buf != '#')
				{
					if((Tmp = strchr(Buf, '\n')) != NULL)
						*Tmp = NUL;

					if(*Buf == '[')
					{
						if((New = malloc(sizeof(REGDATATBL))) != NULL)
						{
							if((Tmp = strchr(Buf, ']')) != NULL)
								*Tmp = NUL;
							strcpy(New->KeyName, Buf+1);
							New->ValLen = 0;
							New->Next = NULL;
							Data = New->ValTbl;
						}
						if(*Handle == NULL)
							*Handle = New;
						else
						{
							Pos = *Handle;
							while(Pos->Next != NULL)
								Pos = Pos->Next;
							Pos->Next = New;
						}
					}
					else if(strlen(Buf) > 0)
					{
						strcpy(Data, Buf);
						Data += strlen(Buf) + 1;
						New->ValLen += strlen(Buf) + 1;
					}
				}
			}
			Sts = SUCCESS;
			free(Buf);
		}
		fclose(Strm);
	}
	return(Sts);
}


/*----- TuL[I[v ------------------------------------------------
*
*	Parameter
*		void *Parent : ẽnh
*		char *Name : O
*		void **Handle : nhԂ[N
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int OpenSubKey(void *Parent, char *Name, void **Handle)
{
	int Sts;
	char Key[80];
	REGDATATBL *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegOpenKeyEx(Parent, Name, 0, KEY_READ, (HKEY *)Handle) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		strcpy(Key, ((REGDATATBL *)Parent)->KeyName);
		strcat(Key, "\\");
		strcat(Key, Name);
		Pos = Parent;
		while(Pos != NULL)
		{
			if(strcmp(Pos->KeyName, Key) == 0)
			{
				*Handle = Pos;
				Sts = SUCCESS;
				break;
			}
			Pos = Pos->Next;
		}
	}
	return(Sts);
}


/*----- TuL[쐬 ----------------------------------------------------
*
*	Parameter
*		void *Parent : ẽnh
*		char *Name : O
*		void **Handle : nhԂ[N
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int CreateSubKey(void *Parent, char *Name, void **Handle)
{
	int Sts;
	DWORD Dispos;
	REGDATATBL *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegCreateKeyEx(Parent, Name, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, (HKEY *)Handle, &Dispos) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		if((*Handle = malloc(sizeof(REGDATATBL))) != NULL)
		{
			strcpy(((REGDATATBL *)(*Handle))->KeyName, ((REGDATATBL *)Parent)->KeyName);
			strcat(((REGDATATBL *)(*Handle))->KeyName, "\\");
			strcat(((REGDATATBL *)(*Handle))->KeyName, Name);

			((REGDATATBL *)(*Handle))->ValLen = 0;
			((REGDATATBL *)(*Handle))->Next = NULL;

			Pos = (REGDATATBL *)Parent;
			while(Pos->Next != NULL)
				Pos = Pos->Next;
			Pos->Next = *Handle;
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*----- TuL[N[Y ------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int CloseSubKey(void *Handle)
{
	if(TmpRegType == REGTYPE_REG)
		RegCloseKey(Handle);
	else
	{
		/* Nothing */
	}
	return(SUCCESS);
}


/*----- TuL[폜 ----------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int DeleteSubKey(void *Handle, char *Name)
{
	int Sts;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegDeleteKey(Handle, Name) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		Sts = FAIL;
	}
	return(Sts);
}


/*----- l폜 ----------------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int DeleteValue(void *Handle, char *Name)
{
	int Sts;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegDeleteValue(Handle, Name) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		Sts = FAIL;
	}
	return(Sts);
}


/*----- INTlǂݍ -------------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		int *Value : INTlԂ[N
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int ReadIntValueFromReg(void *Handle, char *Name, int *Value)
{
	int Sts;
	DWORD Size;
	char *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		Size = sizeof(int);
		if(RegQueryValueEx(Handle, Name, NULL, NULL, (BYTE *)Value, &Size) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		if((Pos = ScanValue(Handle, Name)) != NULL)
		{
			*Value = atoi(Pos);
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*----- INTl -------------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		int Value : INTl
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int WriteIntValueToReg(void *Handle, char *Name, int Value)
{
	REGDATATBL *Pos;
	char *Data;
	char Tmp[20];

	if(TmpRegType == REGTYPE_REG)
		RegSetValueEx(Handle, Name, 0, REG_DWORD, (CONST BYTE *)&Value, sizeof(int));
	else
	{
		Pos = (REGDATATBL *)Handle;
		Data = Pos->ValTbl + Pos->ValLen;
		strcpy(Data, Name);
		strcat(Data, "=");
		sprintf(Tmp, "%d", Value);
		strcat(Data, Tmp);
		Pos->ValLen += strlen(Data) + 1;
	}
	return(SUCCESS);
}


/*----- ǂݍ ------------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		char *Str : Ԃ[N
*		DWORD Size : őTCY
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int ReadStringFromReg(void *Handle, char *Name, char *Str, DWORD Size)
{
	int Sts;
	char *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegQueryValueEx(Handle, Name, NULL, NULL, (BYTE *)Str, &Size) == ERROR_SUCCESS)
		{
			*(Str + Size) = NUL;
			Sts = SUCCESS;
		}
	}
	else
	{
		if((Pos = ScanValue(Handle, Name)) != NULL)
		{
			Size = min(Size-1, strlen(Pos));
			Size = StrReadIn(Pos, Size, Str);
			*(Str + Size) = NUL;
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*-----  ------------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		char *Str :
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int WriteStringToReg(void *Handle, char *Name, char *Str)
{
	REGDATATBL *Pos;
	char *Data;

	if(TmpRegType == REGTYPE_REG)
		RegSetValueEx(Handle, Name, 0, REG_SZ, (CONST BYTE *)Str, strlen(Str)+1);
	else
	{
		Pos = (REGDATATBL *)Handle;
		Data = Pos->ValTbl + Pos->ValLen;
		strcpy(Data, Name);
		strcat(Data, "=");
		Pos->ValLen += strlen(Data);
		Data = Pos->ValTbl + Pos->ValLen;
		Pos->ValLen += StrCatOut(Str, strlen(Str), Data) + 1;
	}
	return(SUCCESS);
}


/*----- }`ǂݍ ------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		char *Str : Ԃ[N
*		DWORD Size : őTCY
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int ReadMultiStringFromReg(void *Handle, char *Name, char *Str, DWORD Size)
{
	int Sts;
	char *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegQueryValueEx(Handle, Name, NULL, NULL, (BYTE *)Str, &Size) == ERROR_SUCCESS)
		{
			*(Str + Size) = NUL;
			Sts = SUCCESS;
		}
	}
	else
	{
		if((Pos = ScanValue(Handle, Name)) != NULL)
		{
			Size = min(Size-1, strlen(Pos));
			Size = StrReadIn(Pos, Size, Str);
			*(Str + Size) = NUL;
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*----- }` ------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		char *Str : 
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int WriteMultiStringToReg(void *Handle, char *Name, char *Str)
{
	REGDATATBL *Pos;
	char *Data;

	if(TmpRegType == REGTYPE_REG)
		RegSetValueEx(Handle, Name, 0, REG_MULTI_SZ, (CONST BYTE *)Str, AskMultiStrLen(Str)+1);
	else
	{
		Pos = (REGDATATBL *)Handle;
		Data = Pos->ValTbl + Pos->ValLen;
		strcpy(Data, Name);
		strcat(Data, "=");
		Pos->ValLen += strlen(Data);
		Data = Pos->ValTbl + Pos->ValLen;
		Pos->ValLen += StrCatOut(Str, AskMultiStrLen(Str), Data) + 1;
	}
	return(SUCCESS);
}


/*----- oCiǂݍ-----------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		void *Bin : oCiԂ[N
*		DWORD Size : őTCY
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int ReadBinaryFromReg(void *Handle, char *Name, void *Bin, DWORD Size)
{
	int Sts;
	char *Pos;

	Sts = FAIL;
	if(TmpRegType == REGTYPE_REG)
	{
		if(RegQueryValueEx(Handle, Name, NULL, NULL, (BYTE *)Bin, &Size) == ERROR_SUCCESS)
			Sts = SUCCESS;
	}
	else
	{
		if((Pos = ScanValue(Handle, Name)) != NULL)
		{
			Size = min(Size, strlen(Pos));
			Size = StrReadIn(Pos, Size, Bin);
			Sts = SUCCESS;
		}
	}
	return(Sts);
}


/*----- oCi ----------------------------------------------------
*
*	Parameter
*		void *Handle : nh
*		char *Name : O
*		void *Bin : oCi
*		int Len : 
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

static int WriteBinaryToReg(void *Handle, char *Name, void *Bin, int Len)
{
	REGDATATBL *Pos;
	char *Data;

	if(TmpRegType == REGTYPE_REG)
		RegSetValueEx(Handle, Name, 0, REG_BINARY, (CONST BYTE *)Bin, Len);
	else
	{
		Pos = (REGDATATBL *)Handle;
		Data = Pos->ValTbl + Pos->ValLen;
		strcpy(Data, Name);
		strcat(Data, "=");
		Pos->ValLen += strlen(Data);
		Data = Pos->ValTbl + Pos->ValLen;
		Pos->ValLen += StrCatOut(Bin, Len, Data) + 1;
	}
	return(SUCCESS);
}


/*----- obt@ɒǉ݂ ------------------------------------
*
*	Parameter
*		char *Src : 
*		int len : ̒
*		char *Dst : ݂obt@
*
*	Return Value
*		int ǉoCg
*----------------------------------------------------------------------------*/

static int StrCatOut(char *Src, int Len, char *Dst)
{
	int Count;

	Dst += strlen(Dst);
	Count = 0;
	for(; Len > 0; Len--)
	{
		if(*Src == '\\')
		{
			*Dst++ = '\\';
			*Dst++ = '\\';
			Count += 2;
		}
		else if((*Src >= 0x20) && (*Src <= 0x7E))
		{
			*Dst++ = *Src;
			Count++;
		}
		else
		{
			sprintf(Dst, "\\%02X", *(unsigned char *)Src);
			Dst += 3;
			Count += 3;
		}
		Src++;
	}
	*Dst = NUL;
	return(Count);
}


/*----- obt@ɓǂݍ --------------------------------------------
*
*	Parameter
*		char *Src : 
*		int Max : őTCY
*		char *Dst : ݂obt@
*
*	Return Value
*		int ǂݍ񂾃oCg
*----------------------------------------------------------------------------*/

static int StrReadIn(char *Src, int Max, char *Dst)
{
	int Count;
	int Tmp;

	Count = 0;
	while(*Src != NUL)
	{
		if(Count >= Max)
			break;

		if(*Src == '\\')
		{
			Src++;
			if(*Src == '\\')
				*Dst = '\\';
			else
			{
				sscanf(Src, "%02x", &Tmp);
				*Dst = Tmp;
				Src++;
			}
		}
		else
			*Dst = *Src;

		Count++;
		Dst++;
		Src++;
	}
	return(Count);
}


/*----- l ----------------------------------------------------------
*
*	Parameter
*		char *Handle : nh
*		char *Name : O
*
*	Return Value
*		char *lf[^̐擪
*			NULL=w̖O̒lȂ
*----------------------------------------------------------------------------*/

static char *ScanValue(void *Handle, char *Name)
{
	REGDATATBL *Cur;
	char *Pos;
	char *Ret;

	Ret = NULL;
	Cur = Handle;
	Pos = Cur->ValTbl;
	while(Pos < (Cur->ValTbl + Cur->ValLen))
	{
		if((strncmp(Name, Pos, strlen(Name)) == 0) &&
		   (*(Pos + strlen(Name)) == '='))
		{
			Ret = Pos + strlen(Name) + 1;
			break;
		}
		Pos += strlen(Pos) + 1;
	}
	return(Ret);
}


