/*=============================================================================
*						eLXg\EChE
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>
#include <crtdbg.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static LRESULT CALLBACK ViewWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static void MoveMouseCursor(HWND hWnd, int PosX, int PosY);
static void RePaintView(HWND hWnd);
static void ChangeDispTopLine(HWND hWnd, int Num, int Redraw);
static void ChangeDispTopColumn(HWND hWnd, int Num, int Redraw);
static void DispText(HWND hWnd, HDC hDC, int Top, int Btm);
static void DispOneLine(HDC hDC, int PosX, int PosY, char *Text, int Len, HDC memDC, int TabWid, char *RgnTop, char *RgnBtm, FILEMANTBL *CurFile);
static int DispLineGo(HDC hDC, int PosX, int PosY, char *Text, char *Btm, int BtmPosX, COLORREF TxCol, COLORREF BkCol, HDC memDC);
static void InvertTextColor(HWND hWnd, HDC hDC, char *RgnTop, char *RgnBtm);
static int GetTextPixelWidth(HDC hDC, char *Text, int Len, int Fixed);
static void CheckTopAndBtmAdrs(char **Top, char **Btm);
static void CheckTopAndBtmLine(int *Top, int *Btm);
static void ScrollUpDownView(int Num, int Smooth);
static void ScrollLeftRightView(int Num);
static char *AskCursorCharPos(HWND hWnd, int PosX, int PosY);
static void CopyToClipBoard(HWND hWnd, char *RgnTop, char *RgnBtm, char *Quote);
static void AppendToClipBoard(HWND hWnd, char *RgnTop, char *RgnBtm);
static void CopyToBuffer(HWND hWnd, char *RgnTop, char *RgnBtm, char *Buf, int Max);
static BOOL CALLBACK FindDialogCallBack(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
static void DispMouseCaret(HWND hWnd, int PosX, int PosY);
static void EraseMouseCaret(HWND hWnd);
// by yhatley
//static void SetStrToFindHist(char *Str);

/*===== [Jȃ[N =====*/

static const char ViewClassStr[] = "ttPageViewClass";
static HWND hWndView = NULL;

static HBRUSH hBrushBack = NULL;

static int WinLines;
static int WinColumns;

static int CharCellHeight;
int CharCellWidth;
static int CharHeight;
static int CharWidth;

static int CellSep[ONELINE_MAXLEN];

static int WaitTripleClick = NO;

static int RevFindStr = YES;

static char *CaretPos = NULL;
static RECT CaretRect;

/*===== OQ =====*/

extern HFONT hFontttPage;

/* ݒl */
extern char QuoteStr[QUOTE_MAXLEN+1];
extern FINDDLGDATA FindData;
extern char FindHist[FINDHIST_NUM*(FINDSTR_LEN+1)+1];
extern int DispCaret;
extern int MouseCopy; // ǉ
extern int ClickableMap; // ǉ
extern int HighlightURL; // ǉ
extern int SmoothLine;
extern int SmoothPage;
extern int SmoothRate;

/*----- r[EChE쐬 ------------------------------------------------
*
*	Parameter
*		HWND hWnd : eEChẼEChEnh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int MakeViewWindow(HWND hWnd)
{
	WNDCLASSEX wClass;
	RECT Rect;
	int Sts;

	Sts = FAIL;
	wClass.cbSize        = sizeof(WNDCLASSEX);
	wClass.style         = CS_DBLCLKS;
	wClass.lpfnWndProc   = ViewWndProc;
	wClass.cbClsExtra    = 0;
	wClass.cbWndExtra    = 0;
	wClass.hInstance     = GetProgInst();
	wClass.hIcon         = NULL;
	wClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wClass.hbrBackground = NULL;
	wClass.lpszMenuName  = NULL;
	wClass.lpszClassName = ViewClassStr;
	wClass.hIconSm       = NULL;
	RegisterClassEx(&wClass);

	GetClientRect(hWnd, &Rect);

	hWndView = CreateWindow(ViewClassStr, "",
				WS_CHILD | WS_BORDER | WS_HSCROLL | WS_VSCROLL,
				AskNumWinWidth(), GetToolBarHeight(), Rect.right - AskNumWinWidth(), Rect.bottom - GetStatusWinHeight() - GetToolBarHeight(),
				hWnd, (HMENU)1500, GetProgInst(), NULL);

	if(hWndView != NULL)
	{
		ShowWindow(hWndView, SW_SHOW);
		DragAcceptFiles(hWndView, TRUE);
		Sts = SUCCESS;
	}
	return(Sts);
}


/*----- r[EChE폜 ------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DeleteViewWindow(void)
{
	UnregisterClass(ViewClassStr, GetProgInst());
	return;
}


/*----- r[EChẼEChEnhԂ ----------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HWND EChEnh
*----------------------------------------------------------------------------*/

HWND GetViewWinHwnd(void)
{
	return(hWndView);
}


/*----- r[EChE̔wiFݒ ----------------------------------------
*
*	Parameter
*		COLORREF Col : wiF
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetViewBackColor(COLORREF Col)
{
	if(hBrushBack != NULL)
		DeleteObject(hBrushBack);
	hBrushBack = CreateSolidBrush(Col);
	return;
}


/*----- r[EChE̔wiFԂ ----------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HBRUSH uV
*----------------------------------------------------------------------------*/

HBRUSH AskViewBackColor(void)
{
	return(hBrushBack);
}


/*----- r[EChẼTCYύX̏ ------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*
*	Note
*		CEChEc[o[^Xe[^Xo[sԍEChE
*		r[EChȄŃTCYύX邱
*----------------------------------------------------------------------------*/

void ResizeViewWindow(void)
{
	RECT Rect;

	GetClientRect(GetMainHwnd(), &Rect);
	SetWindowPos(hWndView, NULL, 
		AskNumWinWidth(), 
		GetToolBarHeight(), 
		Rect.right - AskNumWinWidth(), 
		Rect.bottom - GetStatusWinHeight() - GetToolBarHeight(), 
		SWP_NOACTIVATE | SWP_NOZORDER);

	if(AskCurFileTbl() != NULL){
		if(AskCurExtSet()->FoldRight == YES){
			MakeLineTopTbl(AskCurFileTbl());
			InvalidateRgn(hWndView, NULL, TRUE);
			InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
			DispCurrentLineNum(1, AskCurFileTbl()->DispTopLine);
			DispMousePos();
		}
	}

	return;
}


/*----- r[EChẼbZ[W --------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		UINT message  : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		bZ[WɑΉ߂l
*----------------------------------------------------------------------------*/

static LRESULT CALLBACK ViewWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int Tmp;
	int PosX;
	int PosY;
	POINT CsrPos;
	char Fname[MAX_PATH+1];
	EXTSET *CurExt;
	FILEMANTBL *CurFile;
	char *TmpPos;
	int Dist;
	static HCURSOR hFingerCursor = NULL;
	static HCURSOR hOldCursor = NULL;
	static BOOL bFinger = FALSE;
	static int iURLLen = 0;
	static int iURLStart = 0;
	static int iURLLine = 0;
	static int iRetType = ID_NONE;

	CurExt = AskCurExtSet();
	CurFile = AskCurFileTbl();

	switch (message){
	case WM_COMMAND :
		EraseMouseCaret(hWnd);
		switch(LOWORD(wParam)){
		case MENU_NEXTLINE :
		case MENU_PREVLINE :
		case MENU_NEXT5LINE :
		case MENU_PREV5LINE :
		case MENU_NEXT_N_LINE :
		case MENU_PREV_N_LINE :
		case MENU_NEXTPAGE :
		case MENU_PREVPAGE :
		case MENU_FILEBTM :
		case MENU_FILETOP :
		case MENU_RIGHT :
		case MENU_LEFT :
		case MENU_RIGHT5 :
		case MENU_LEFT5 :
		case MENU_FIND :
		case MENU_FINDBACKWD :
		case MENU_FINDNEXT :
		case MENU_FINDPREV :
		case MENU_FINDDISP :
		case MENU_SELALL :
		case MENU_COPY :
		case MENU_APPENDCOPY :
		case MENU_QUOTECOPY :
		case MENU_GOTO :
		case MENU_OPEN_URL :
			if(CurFile != NULL){
				switch(LOWORD(wParam)){
				case MENU_NEXTLINE :
					if(CurFile->DispTopLine < (CurFile->TextLines - (WinLines - 1)))
						ChangeDispTopLine(hWnd, CurFile->DispTopLine + 1, NO);
					break;

				case MENU_PREVLINE :
					if(CurFile->DispTopLine > 0)
						ChangeDispTopLine(hWnd, CurFile->DispTopLine - 1, NO);
					break;

				case MENU_NEXT5LINE :
					lParam = 5;
					/* break͂Ȃ */

				case MENU_NEXT_N_LINE :
					if(CurFile->DispTopLine < (CurFile->TextLines - (WinLines - 1)))
					{
						Tmp = CurFile->DispTopLine + lParam;
						if(Tmp > (CurFile->TextLines - (WinLines - 1)))
							Tmp = CurFile->TextLines - (WinLines - 1);

						ChangeDispTopLine(hWnd, Tmp, NO);
					}
					break;

				case MENU_PREV5LINE :
					lParam = 5;
					/* break͂Ȃ */

				case MENU_PREV_N_LINE :
					if(CurFile->DispTopLine > 0)
					{
						Tmp = CurFile->DispTopLine - lParam;
						if(Tmp < 0)
							Tmp = 0;

						ChangeDispTopLine(hWnd, Tmp, NO);
					}
					break;

				case MENU_NEXTPAGE :
					if(CurFile->DispTopLine < (CurFile->TextLines - (WinLines - 1)))
					{
						Tmp = CurFile->DispTopLine + (WinLines - 2);
						if(Tmp > (CurFile->TextLines - (WinLines - 1)))
							Tmp = CurFile->TextLines - (WinLines - 1);

						ChangeDispTopLine(hWnd, Tmp, NO);
					}
					break;

				case MENU_PREVPAGE :
					if(CurFile->DispTopLine > 0)
					{
						Tmp = CurFile->DispTopLine - (WinLines - 2);
						if(Tmp < 0)
							Tmp = 0;

						ChangeDispTopLine(hWnd, Tmp, NO);
					}
					break;

				case MENU_FILEBTM :
					if(CurFile->DispTopLine < (CurFile->TextLines - (WinLines - 1)))
						ChangeDispTopLine(hWnd, CurFile->TextLines - (WinLines - 1), NO);
					break;

				case MENU_FILETOP :
					if(CurFile->DispTopLine > 0)
						ChangeDispTopLine(hWnd, 0, NO);
					break;

				case MENU_RIGHT :
					if(CurFile->DispTopColumn < (CurExt->FoldPos - (WinColumns - 1)))
						ChangeDispTopColumn(hWnd, CurFile->DispTopColumn + 1, NO);
					break;

				case MENU_LEFT :
					if(CurFile->DispTopColumn > 0)
						ChangeDispTopColumn(hWnd, CurFile->DispTopColumn - 1, NO);
					break;

				case MENU_RIGHT5 :
					if(CurFile->DispTopColumn < (CurExt->FoldPos - (WinColumns - 1)))
					{
						Tmp = CurFile->DispTopColumn + CurExt->TabWidth;
						if(Tmp > (CurExt->FoldPos - (WinColumns - 1)))
							Tmp = CurExt->FoldPos - (WinColumns - 1);

						ChangeDispTopColumn(hWnd, Tmp, NO);
					}
					break;

				case MENU_LEFT5 :
					if(CurFile->DispTopColumn > 0)
					{
						Tmp = CurFile->DispTopColumn - CurExt->TabWidth;
						if(Tmp < 0)
							Tmp = 0;

						ChangeDispTopColumn(hWnd, Tmp, NO);
					}
					break;

				case MENU_FIND :
				case MENU_FINDBACKWD :
					strcpy(FindData.Str, "");
					if(CurFile->RgnStartPos != NULL)
					{
						CopyToBuffer(hWnd, CurFile->RgnStartPos, CurFile->RgnEndPos, FindData.Str, FINDSTR_LEN+1);
						CurFile->RgnStartPos = NULL;
						CurFile->RgnEndPos = NULL;
						InvalidateRgn(hWnd, NULL, TRUE);
					}
					if(DialogBoxParam(GetProgInst(), MAKEINTRESOURCE(find_dlg), GetMainHwnd(), FindDialogCallBack, (LPARAM)&FindData) == YES)
					{
						SetStrToFindHist(FindData.Str);
						if(LOWORD(wParam) == MENU_FIND)
							Dist = DIST_FORWARD;
						else
							Dist = MENU_FINDBACKWD;
						if((Tmp = SearchText(CurFile, CurFile->DispTopLine, FindData.Str, FindData.CapsFlg, FindData.Regexp, Dist)) != -1)
						{
							RevFindStr = YES;
							ChangeDispTopLine(hWnd, Tmp, YES);
						}
						else
						{
							InvalidateRgn(hWndView, NULL, TRUE);
							RingErrorBell();
						}
						MakeButtonsHide();
					}
					break;

				case MENU_FINDNEXT :
					if((Tmp = SearchNextFoundLine(CurFile, CurFile->DispTopLine)) != -1)
					{
						if(RevFindStr == YES)
							ChangeDispTopLine(hWnd, Tmp, NO);
						else
						{
							RevFindStr = YES;
							ChangeDispTopLine(hWnd, Tmp, YES);
						}
						MakeButtonsHide();
					}
					else
						RingErrorBell();

					break;

				case MENU_FINDPREV :
					if((Tmp = SearchPrevFoundLine(CurFile, CurFile->DispTopLine)) != -1)
					{
						if(RevFindStr == YES)
							ChangeDispTopLine(hWnd, Tmp, NO);
						else
						{
							RevFindStr = YES;
							ChangeDispTopLine(hWnd, Tmp, YES);
						}
						MakeButtonsHide();
					}
					else
						RingErrorBell();
					break;

				case MENU_FINDDISP :
					RevFindStr ^= YES;
					InvalidateRgn(hWnd, NULL, TRUE);
					MakeButtonsHide();
					break;

				case MENU_SELALL :
					if(CurFile->RgnStartPos != NULL)
						InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);
					CurFile->RgnStartPos = CurFile->TextData;
					CurFile->RgnEndPos = CurFile->TextData + CurFile->TextSize;
					CurFile->RgnSelecting = NO;
					MakeButtonsHide();
					InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);
					break;

				case MENU_COPY :
					if(CurFile->RgnStartPos != NULL)
						CopyToClipBoard(hWnd, CurFile->RgnStartPos, CurFile->RgnEndPos, "");
					CurFile->RgnStartPos = NULL;
					CurFile->RgnEndPos = NULL;
					InvalidateRgn(hWnd, NULL, TRUE);
					MakeButtonsHide();
					break;

				case MENU_APPENDCOPY :
					if(CurFile->RgnStartPos != NULL)
						AppendToClipBoard(hWnd, CurFile->RgnStartPos, CurFile->RgnEndPos);
					CurFile->RgnStartPos = NULL;
					CurFile->RgnEndPos = NULL;
					InvalidateRgn(hWnd, NULL, TRUE);
					MakeButtonsHide();
					break;

				case MENU_QUOTECOPY :
					if(CurFile->RgnStartPos != NULL)
						CopyToClipBoard(hWnd, CurFile->RgnStartPos, CurFile->RgnEndPos, QuoteStr);
					CurFile->RgnStartPos = NULL;
					CurFile->RgnEndPos = NULL;
					InvalidateRgn(hWnd, NULL, TRUE);
					MakeButtonsHide();
					break;

				case MENU_GOTO :
					strcpy(Fname, "");
					if(InputDialogBox(goto_dlg, hWnd, "Wv", Fname, 10, &Tmp) == YES)
					{
						SendMessage(GetViewWinHwnd(), WM_CHANGE_TOP, 0, atoi(Fname)-1);
					}
					break;

				case MENU_OPEN_URL:
					if( ClickableMap && iURLLen > 0 ){
						char * szURL;
						char * start = AskCursorCharPos( hWnd, 0, iURLLine );
						if( iRetType == ID_MAIL_ADDRESS ){
							szURL = (char*)malloc(iURLLen+1+strlen("mailto:"));
							memset( szURL, 0, iURLLen+1+strlen("mailto:") );
							strcpy( szURL, "mailto:" );
							strncat( szURL, start+iURLStart, iURLLen );
						} else {
							// Clickable Map
							szURL = (char*)malloc(iURLLen+1);
							memset( szURL, 0, iURLLen+1 );
							strncpy( szURL, start+iURLStart, iURLLen );
						}
						ShellExecute( hWnd, "open", szURL, NULL, NULL, SW_SHOW);
						free(szURL);
					}
					break;
				}
			}
			break;
		}
		break;

	case WM_CREATE:
		hFingerCursor = GetFingerCursor();
		break;

	case WM_VSCROLL :
	case WM_HSCROLL :
	case WM_LBUTTONDOWN :
	case WM_LBUTTONUP :
	case WM_LBUTTONDBLCLK :
	case WM_LBUTTONTRICLK :
	case WM_MOUSEMOVE :
	case WM_TIMER :
		if(CurFile != NULL){
			switch (message){
			case WM_VSCROLL :
				EraseMouseCaret(hWnd);
				switch(GET_WM_VSCROLL_CODE(wParam, lParam)){
				case SB_LINEUP:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_PREVLINE, 0), 0);
					break;

				case SB_LINEDOWN:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_NEXTLINE, 0), 0);
					break;

				case SB_PAGEUP:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_PREVPAGE, 0), 0);
					break;

				case SB_PAGEDOWN:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_NEXTPAGE, 0), 0);
					break;

				case SB_THUMBTRACK:
						Tmp = GET_WM_VSCROLL_POS(wParam, lParam) * CurFile->SbarStep;
						if(Tmp >= CurFile->TextLines - 1)
							Tmp = CurFile->TextLines - 1;

						ChangeDispTopLine(hWnd, Tmp, NO);
					break;
				}
				break;

			case WM_HSCROLL :
				EraseMouseCaret(hWnd);
				switch(GET_WM_HSCROLL_CODE(wParam, lParam)){
				case SB_LINERIGHT:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_RIGHT, 0), 0);
					break;

				case SB_LINELEFT:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_LEFT, 0), 0);
					break;

				case SB_PAGERIGHT:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_RIGHT5, 0), 0);
					break;

				case SB_PAGELEFT:
					PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_LEFT5, 0), 0);
					break;

				case SB_THUMBTRACK:
						Tmp = GET_WM_VSCROLL_POS(wParam, lParam);
						if(Tmp >= CurExt->FoldPos - 1)
							Tmp = CurExt->FoldPos - 1;

						ChangeDispTopColumn(hWnd, Tmp, NO);
					break;
				}
				break;

			case WM_LBUTTONDOWN :
				EraseMouseCaret(hWnd);
				SetFocus(hWnd);
				KillTimer(hWnd, 2);
				if(WaitTripleClick == YES){
					WaitTripleClick = NO;
					PostMessage(hWnd, WM_LBUTTONTRICLK, wParam, lParam);
				} else {
					if(CurFile->RgnStartPos != NULL)
						InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);
					CurFile->RgnStartPos = AskCursorCharPos(hWnd, LOWORD(lParam), HIWORD(lParam));
					CurFile->RgnEndPos = CurFile->RgnStartPos;
					CurFile->RgnSelecting = YES;
					SetCapture(hWnd);
				}
				break;

			case WM_LBUTTONUP :
				EraseMouseCaret(hWnd);
				if(CurFile->RgnSelecting == YES)
				{
					KillTimer(hWnd, 1);
					CurFile->RgnSelecting = NO;
					if(CurFile->RgnEndPos == CurFile->RgnStartPos)
					{
						CurFile->RgnStartPos = NULL;
						CurFile->RgnEndPos = NULL;
					}
					ReleaseCapture();
					MakeButtonsHide();
				}
				if( MouseCopy ) {
					// ͈͑IŏɃRs[
					// ͈͑IŃRs[Ȃꍇ́CĂ
					if(CurFile->RgnStartPos != NULL)
						CopyToClipBoard(hWnd, CurFile->RgnStartPos, CurFile->RgnEndPos, "");
					CurFile->RgnStartPos = NULL;
					CurFile->RgnEndPos = NULL;
					InvalidateRgn(hWnd, NULL, TRUE);
					MakeButtonsHide();
				}
				break;

			case WM_LBUTTONDBLCLK :
				EraseMouseCaret(hWnd);

				if( ClickableMap && iURLLen && bFinger ){
					char * szURL;
					char * start = AskCursorCharPos( hWnd, 0, iURLLine );
					if( iRetType == ID_MAIL_ADDRESS ){
						szURL = (char*)malloc(iURLLen+1+strlen("mailto:"));
						memset( szURL, 0, iURLLen+1+strlen("mailto:") );
						strcpy( szURL, "mailto:" );
						strncat( szURL, start+iURLStart, iURLLen );
					} else {
						// Clickable Map
						szURL = (char*)malloc(iURLLen+1);
						memset( szURL, 0, iURLLen+1 );
						strncpy( szURL, start+iURLStart, iURLLen );
					}
					ShellExecute( hWnd, "open", szURL, NULL, NULL, SW_SHOW);
					free(szURL);
				}

				if(CurFile->RgnStartPos != NULL)
					InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);

				TmpPos = AskCursorCharPos(hWnd, LOWORD(lParam), HIWORD(lParam));
				AskWordTopAndBtm(CurFile, TmpPos, &CurFile->RgnStartPos, &CurFile->RgnEndPos);

				CurFile->RgnSelecting = NO;
				MakeButtonsHide();
				InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);
				WaitTripleClick = YES;
				SetTimer(hWnd, 2, GetDoubleClickTime(), NULL);
				break;

			case WM_LBUTTONTRICLK :
				EraseMouseCaret(hWnd);
				if(CurFile->RgnStartPos != NULL)
					InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);

				TmpPos = AskCursorCharPos(hWnd, LOWORD(lParam), HIWORD(lParam));

				AskPhysLineTopAndBtm(CurFile, TmpPos, &CurFile->RgnStartPos, &CurFile->RgnEndPos);
				CurFile->RgnSelecting = NO;
				MakeButtonsHide();
				InvertTextColor(hWnd, NULL, CurFile->RgnStartPos, CurFile->RgnEndPos);
				break;

			case WM_MOUSEMOVE :
				if(CurFile->RgnSelecting == YES)
				{
					EraseMouseCaret(hWnd);
					KillTimer(hWnd, 1);
					PosX = LOWORD(lParam);
					PosY = HIWORD(lParam);
					if(PosY > 32767)
						PosY -= 65536;
					MoveMouseCursor(hWnd, PosX, PosY);
				}
				else
				{
					// }EXLbg
					PosX = LOWORD(lParam);
					PosY = HIWORD(lParam);
					if(PosY > 32767)
						PosY -= 65536;
					DispMouseCaret(hWnd, PosX, PosY);
				}

				// قƂɓKŃSiTC
				if( ClickableMap ) {
					// s̐擪擾
					char * start = AskCursorCharPos( hWnd, 0, PosY );
					// ݈ʒu擾
					char * now = AskCursorCharPos( hWnd, PosX, PosY );
					int pos = PosX;
					int mailLen=0; //  tOƂĂp
					// s擾DƊȒPȕ@邯ǖʓ|Ȃ̂ŁEEE
					int len = 0;

					iURLLine = PosY;
					iRetType=ID_NONE;
					while( start+len ){
						if( start[len] == '\0' ) break;
						else if( start[len] == '\r' ) break;
						else if( start[len] == '\n' ) break;
						len++;
					}

					// ̏vORsyȂ̂ňӖǂ킩
					iURLLen = 0;
					while( pos >= 0 ){
						iRetType = IsURL( start+pos, len-pos, &iURLLen );
						if( iRetType == ID_NONE && mailLen > 0 ){
							// O񃁁[AhXƌmāĈ
							iRetType = ID_MAIL_ADDRESS;
							iURLLen = mailLen;
							pos++;
							break;
						} else if( iRetType == ID_MAIL_ADDRESS ){
							iURLStart = pos;
							if( PosX == 0 ) break; // sȂOKł傤
							mailLen = iURLLen;
						} else if( iRetType == ID_URL ){
							iURLStart = pos;
							break;
						}
						pos--;
					}

					if( iRetType != ID_NONE ){
						if( start+pos+iURLLen <= now ){
							iRetType = ID_NONE;
						} else if( now < start+pos ){
							iRetType = ID_NONE;
						}
					}

					// URL܂MailaddressJ[\̕\FingerType
					if( iRetType == ID_URL || iRetType == ID_MAIL_ADDRESS ){
						hOldCursor = SetCursor( hFingerCursor );
						bFinger = TRUE;
					} else if( bFinger ){
						SetCursor( hOldCursor );
						bFinger = FALSE;
					}
				}
				break;

			case WM_TIMER :
				EraseMouseCaret(hWnd);
				KillTimer(hWnd, wParam);
				if(wParam == 1)
				{
					GetCursorPos(&CsrPos);
					ScreenToClient(hWnd, &CsrPos);
					MoveMouseCursor(hWnd, CsrPos.x, CsrPos.y);
				}
				else if(wParam == 2)
					WaitTripleClick = NO;
				break;
			}
		}
		break;

	case WM_CHANGE_TOP :
		EraseMouseCaret(hWnd);
		Tmp = lParam;
		if(AskCurExtSet()->LineNumType == LINENUM_WP)
		{
			if((Tmp < 0) || (Tmp >= CurFile->TextLines))
				Tmp = -1;
		}
		else
			Tmp = GetLineNumFromLogicalLineNum(CurFile, Tmp);

		if(Tmp != -1)
			ChangeDispTopLine(hWnd, Tmp, NO);
		else
			RingErrorBell();
		break;

	case WM_RBUTTONDOWN :
		EraseMouseCaret(hWnd);
		RightButtonMenu(iRetType);
		break;

	case WM_DROPFILES :
		EraseMouseCaret(hWnd);
		DragQueryFile((HDROP)wParam, 0, Fname, MAX_PATH);
		DragFinish((HDROP)wParam);
		OpenViewFromFile(Fname, 0, CODE_AUTO, NO);
		MakeButtonsHide();
		break;

	case WM_PAINT :
		EraseMouseCaret(hWnd);
		RePaintView(hWnd);
		break;

	default :
		return(DefWindowProc(hWnd, message, wParam, lParam));
	}
    return(0L);
}


/*----- ͈͑I𒆂̃}EXJ[\̈ړ ----------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		int PosX : J[\XW
*		int PosY : J[\YWa
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void MoveMouseCursor(HWND hWnd, int PosX, int PosY)
{
	char *Old;
	int Timer;
	RECT Rect;
	FILEMANTBL *CurFile;

	CurFile = AskCurFileTbl();

	Timer = NO;
	GetClientRect(hWnd, &Rect);
	if(PosY < 0)
	{
		SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_PREVLINE, 0), 0);
		PosY = 0;
		Timer = YES;
	}
	else if(PosY > Rect.bottom)
	{
		SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(MENU_NEXTLINE, 0), 0);
		PosY = Rect.bottom-1;
		Timer = YES;
	}

	Old = CurFile->RgnEndPos;
	CurFile->RgnEndPos = AskCursorCharPos(hWnd, PosX, PosY);
	if(Old != CurFile->RgnEndPos)
		InvertTextColor(hWnd, NULL, Old, CurFile->RgnEndPos);

	if(Timer == YES)
		SetTimer(hWnd, 1, 1, NULL);

	return;
}


/*----- tHg̑傫vZ ------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetFontSize(void)
{
	HDC hDC;
	HFONT hFontOld;
	SIZE Size;
	int i;

	hDC = GetDC(hWndView);

	if(hFontttPage != NULL)
		DeleteObject(hFontttPage);
	hFontttPage = CreateFontIndirect(&(AskCurExtSet()->Font));

	hFontOld = NULL;
	if(hFontttPage != NULL)
		hFontOld = SelectObject(hDC, hFontttPage);

    GetTextExtentPoint32(hDC, "aAjJ,_", 6, &Size);

	Size.cx /= 6;
	for(i = 0; i < ONELINE_MAXLEN; i++)
		CellSep[i] = Size.cx;
	CharWidth = Size.cx;
	CharHeight = Size.cy;

	if(hFontOld != NULL)
		SelectObject(hDC, hFontOld);

	ReleaseDC(hWndView, hDC);

	return;
}


/*----- Z̃TCYvZ ------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetCellSize(void)
{
	CharCellHeight = CharHeight + AskCurExtSet()->LineSpace;
	CharCellWidth = CharWidth;
	return;
}


/*----- Z̍Ԃ --------------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int 
*----------------------------------------------------------------------------*/

int AskCharCellHeight(void)
{
	return(CharCellHeight);
}


/*----- EChE̕\^svZ --------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetWindowSize(void)
{
	RECT Rect;

	GetClientRect(hWndView, &Rect);
	WinLines = (Rect.bottom - Rect.top + CharCellHeight - 1) / CharCellHeight;
	WinColumns = (Rect.right - Rect.left + CharCellWidth - 1) / CharCellWidth;

	return;
}


/*----- WM_PAINT̏ --------------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void RePaintView(HWND hWnd)
{
	PAINTSTRUCT ps;
	RECT Rect;

    BeginPaint(hWnd, (LPPAINTSTRUCT) &ps);

	if(AskCurFileTbl() != NULL)
		DispText(hWnd, ps.hdc, 0, WinLines);
	else
	{
		GetClientRect(hWnd, &Rect);
		FillRect(ps.hdc, &Rect, hBrushBack);
	}

    EndPaint(hWnd, (LPPAINTSTRUCT) &ps);
	return;
}


/*----- \擪sς̏ ------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		int Num : ړ̕\擪sԍ
*		int Redraw : Sĕ\tO (YES/NO)
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ChangeDispTopLine(HWND hWnd, int Num, int Redraw)
{
	int Offs;
	FILEMANTBL *CurFile;
	int Dir;
	int i;
	int Smooth;

	CurFile = AskCurFileTbl();
	Offs = Num - CurFile->DispTopLine;
	if((Redraw == YES) || (abs(Offs) >= WinLines))
	{
		CurFile->DispTopLine = Num;
		InvalidateRgn(hWndView, NULL, TRUE);
		InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
		SetScrollBar();
	}
	else
	{
		if(((Offs < 0) && (CurFile->DispTopLine > 0)) ||
		   ((Offs > 0) && (CurFile->DispTopLine < (CurFile->TextLines - 1))))
		{
			if((SmoothPage == NO) || (abs(Offs) <= 3))
			{
				Smooth = NO;
				if(abs(Offs) <= 3)
					Smooth = SmoothLine;
				CurFile->DispTopLine = Num;
				ScrollUpDownView(-Offs, Smooth);
				ScrollUpDownNum(-Offs);
				SetScrollBar();
			}
			else
			{
				Dir = (Offs < 0) ? -1 : 1;
				for(i = 0; i < abs(Offs); i++)
				{
					CurFile->DispTopLine += Dir;
					ScrollUpDownView(-Dir, NO);
				}
				ScrollUpDownNum(-Offs);
				SetScrollBar();
			}
		}
	}

	DispCurrentLineNum(1, Num);
	DispMousePos();

	return;
}


/*----- \擪ς̏ ------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		int Num : ړ̕\擪ԍ
*		int Redraw : Sĕ\tO (YES/NO)
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ChangeDispTopColumn(HWND hWnd, int Num, int Redraw)
{
	int Offs;
	FILEMANTBL *CurFile;

	CurFile = AskCurFileTbl();

	Offs = Num - CurFile->DispTopColumn;
	if((Redraw == YES) || (abs(Offs) >= WinColumns))
	{
		CurFile->DispTopColumn = Num;
		InvalidateRgn(hWndView, NULL, TRUE);
		SetScrollBar();
	}
	else
	{
		if(Offs < 0)
		{
			if(CurFile->DispTopColumn > 0)
			{
				CurFile->DispTopColumn = Num;
				ScrollLeftRightView(-Offs);
				SetScrollBar();
			}
		}
		else if(Offs > 0)
		{
			if(CurFile->DispTopColumn < (AskCurExtSet()->FoldPos - 1))
			{
				CurFile->DispTopColumn = Num;
				ScrollLeftRightView(-Offs);
				SetScrollBar();
			}
		}
	}

	return;
}


/*----- eLXg\ --------------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		HDC hDC : foCXReLXg
*			NULL=GetDCŋ߂
*		int Top : \擪sԍ
*		int Btm : \sԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DispText(HWND hWnd, HDC hDC, int Top, int Btm)
{
	HDC InDC;
	HFONT hFontOld;
	int PosY;
	int PosX;
	char *Text;
	int Len;
	int i;
	HDC memDC;
	HBITMAP bmp;
	HBITMAP bmpOld;
    BITMAP bmpx;
	RECT Rect;
	int Tab;
	char *RgnTop;
	char *RgnBtm;
	FILEMANTBL *CurFile;

	static const BYTE CrMarkBmp[2][16] = {
		{	0xff,0x00,
			0xff,0x00,
			0xff,0x00,
			0xff,0x00,
			0xff,0x00,
			0xff,0x00,
			0xff,0x00,
			0xff,0x00	},

		{	0xdf,0x00,
			0xdf,0x00,
			0xdf,0x00,
			0xdf,0x00,
			0xdf,0x00,
			0x57,0x00,
			0x8f,0x00,
			0xdf,0x00	}
	};

//DoPrintf("DispText --------------\n\n\n");

	InDC = hDC;
	if(InDC == NULL)
		hDC = GetDC(hWnd);

	CurFile = AskCurFileTbl();

	/* s}[N */
	memDC = CreateCompatibleDC(hDC);
	bmp = CreateBitmap(8, 8, 1, 1, CrMarkBmp[AskCurExtSet()->CrMark]);
	GetObject(bmp, sizeof(BITMAP), (LPSTR) &bmpx);
	bmpOld = SelectObject(memDC, bmp);

	/* tHg */
	hFontOld = NULL;
	if(hFontttPage != NULL)
		hFontOld = SelectObject(hDC, hFontttPage);

	/* ͈͎w͈̔ */
	RgnTop = CurFile->RgnStartPos;
	RgnBtm = CurFile->RgnEndPos;
	CheckTopAndBtmAdrs(&RgnTop, &RgnBtm);

	/* ̑ */
	GetClientRect(hWnd, &Rect);
	SetBkMode(hDC, OPAQUE);
	SetTextColor(hDC, AskCurExtSet()->TextColor);
	Tab = AskCurExtSet()->TabWidth;
	CheckTopAndBtmLine(&Top, &Btm);

	/* eLXg\郋[v */
	PosX = LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth);
	PosY = Top * CharCellHeight;
	for(i = Top; i < Btm; i++)
	{
		/* 炩ߏ */
		Rect.top = PosY;
		Rect.left = 0;
		Rect.right = Rect.right;
		Rect.bottom = PosY + CharCellHeight;
		FillRect(hDC, &Rect, hBrushBack);

		if((Text = GetLineTop(CurFile, CurFile->DispTopLine + i)) != NULL)
		{
			Len = GetLineLen(CurFile, CurFile->DispTopLine + i);
			DispOneLine(hDC, PosX, PosY, Text, Len, memDC, Tab, RgnTop, RgnBtm, CurFile);
		}
		else
			DispOneLine(hDC, PosX, PosY, "~", 1, memDC, Tab, RgnTop, RgnBtm, CurFile);

		PosY += CharCellHeight;
	}

	if(hFontOld != NULL)
		SelectObject(hDC, hFontOld);

	SelectObject(memDC, bmpOld);
	DeleteDC(memDC);
	DeleteObject(bmp);

	if(InDC == NULL)
		ReleaseDC(hWnd, hDC);

	return;
}




/*----- Ps̃eLXg\ --------------------------------------------------
*
*	Parameter
*		HDC hDC : foCXReLXg
*		int PosX : wW
*		int PosY : xW
*		char *Text : eLXg
*		int Len : Ps̃eLXg̒
*		HDC memDC : s}[N
*		int TabWid : ^u
*		char *RgnTop : ͈͎w̐擪
*		char *RgnBtm : ͈͎w̖
*		FILEMANTBL *CurFile : t@C
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DispOneLine(HDC hDC, int PosX, int PosY, char *Text, int Len, HDC memDC, int TabWid, char *RgnTop, char *RgnBtm, FILEMANTBL *CurFile)
{
	char *Disp;
	int Tabs;
	int Col;
	COLORREF BkCol;
	COLORREF TxCol;
	int TmpPosX;
	int OrgPosX;

	char *FoundPos;
	int FoundChars;
	char *RgnPos;
	int RgnChars;

	char *UnderPos;
	int UnderChars;
	int Attr;

//DoPrintf("DispOneLine ###\n");

	FoundPos = NULL;
	FoundChars = 0;
	if(RevFindStr == YES){
		if((FoundChars = -AskCurPosFound(CurFile, Text)) != 0){
			FoundPos = Text;
		} else {
			FoundPos = GetNextFoundPos(CurFile, Text, &FoundChars);
			FoundChars = -FoundChars;
		}
	}

	RgnPos = NULL;
	RgnChars = 0;
	if((Text < RgnBtm) && (RgnTop != RgnBtm)){
		if(Text >= RgnTop) RgnPos = Text;
		else RgnPos = RgnTop;
		RgnChars = -(RgnBtm - RgnPos);
	}

	if(AskCurPosAttr(CurFile, Text, &UnderChars, &Attr) != 0){
		UnderChars = -UnderChars;
		UnderPos = Text;
	}else{
		UnderPos = GetNextAttrPos(CurFile, Text, &UnderChars, &Attr);
		UnderChars = -UnderChars;
	}

	OrgPosX = PosX;
	BkCol = AskCurExtSet()->BackColor;
	TxCol = AskCurExtSet()->TextColor;
	Disp = Text;
	Col = 0;
	for(; Len > 0; Len--){
		/* ̃AhXɑ΂`FbN */
		if((Text == FoundPos) || (Text == RgnPos) || (Text == UnderPos)){
			PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);
			Disp = Text;

			if(Text == FoundPos){
				BkCol = (BkCol & 0xFF000000) | AskCurExtSet()->FindColor;
				FoundChars = -FoundChars;
			}
			if(Text == RgnPos){
				BkCol |= ATTR_REGION;
				RgnChars = -RgnChars;
			}

			if(Text == UnderPos){
				BkCol |= Attr;
				if(BkCol & ATTR_BOLD)
					TxCol = AskCurExtSet()->HighColor;
				UnderChars = -UnderChars;
			}
		}

		/* ɑ΂`FbN */
		if((uchar)*Text < (uchar)' '){ /* Rg[R[h */
			PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);
			Disp = Text+1;

			if(*Text == '\t')			/* TAB */
			{
				Tabs = GetTabWidth(TabWid, Col);
				Col += Tabs;
				TmpPosX = OrgPosX + (Col * CharCellWidth);
				while(TmpPosX < PosX)
				{
					Col += TabWid;
					TmpPosX = OrgPosX + (Col * CharCellWidth);
				}
				PosX = DispLineGo(hDC, PosX, PosY, Text, Text+1, TmpPosX, TxCol, BkCol, memDC);
			}
			else
			{
				PosX = DispLineGo(hDC, PosX, PosY, Text, Text+1, 0, AskCurExtSet()->CtrlColor, BkCol, memDC);
				Col++;
			}
		}
		else
			Col++;

		Text++;

		if(FoundChars > 0)
		{
			if(--FoundChars == 0)
			{
				PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);
				Disp = Text;
				BkCol = (BkCol & 0xFF000000) | AskCurExtSet()->BackColor;
				FoundPos = GetNextFoundPos(CurFile, Text, &FoundChars);
				FoundChars = -FoundChars;
			}
		}

		if(RgnChars > 0)
		{
			if(--RgnChars == 0)
			{
				PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);
				Disp = Text;
				BkCol &= ~ATTR_REGION;
			}
		}

		if(UnderChars > 0)
		{
			if(--UnderChars == 0)
			{
				PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);
				Disp = Text;

				BkCol &= ~Attr;
				TxCol = AskCurExtSet()->TextColor;
				UnderPos = GetNextAttrPos(CurFile, Text, &UnderChars, &Attr);
				UnderChars = -UnderChars;
			}
		}
	}
	PosX = DispLineGo(hDC, PosX, PosY, Disp, Text, 0, TxCol, BkCol, memDC);

	return;
}


/*----- Pŝ̎w͈͂̃eLXg\ ----------------------------------
*
*	Parameter
*		HDC hDC : foCXReLXg
*		int PosX : wW
*		int PosY : xW
*		char *Text : eLXg
*		char *Btm : eLXg̖
*		int BtmPosX : ^ȕIʒûwW(*Text=='\t'̎̂)
*		COLORREF TxCol : F
*		COLORREF BkCol : wiF (& ATTR_REGION)
*		HDC memDC : s}[N
*
*	Return Value
*		int \̂wW
*----------------------------------------------------------------------------*/

static int DispLineGo(HDC hDC, int PosX, int PosY, char *Text, char *Btm, int BtmPosX, COLORREF TxCol, COLORREF BkCol, HDC memDC)
{
	RECT Rect;
	SIZE Size;
	int Len;
	int NextPosX;
	char Tmp[2];
	HPEN hPen;
	HPEN hPenOld;

//DoPrintf("DispLineAndGo 0x%x-0x%x (%d) 0x%02x\n", Text, Btm, Btm-Text, *Text);

	Len = Btm - Text;
	if(Len > 0)
	{
		GetClientRect(hWndView, &Rect);
		Rect.left = LEFT_OFFSET;
		SetTextColor(hDC, TxCol);
		SetBkColor(hDC, (BkCol & 0x00FFFFFF));

		if(*Text == '\n')
		{
			Rect.left = PosX;
			Rect.top = PosY;
			Rect.right = PosX + CharCellWidth;
			Rect.bottom = PosY + CharHeight;
			ExtTextOut(hDC, PosX, PosY, ETO_OPAQUE, &Rect, "", 0, (const int *)&CellSep);
			BitBlt(hDC, PosX+((CharWidth-5)/2), PosY+((CharHeight-8)/2), 5, 8, memDC, 0, 0, SRCCOPY);
			NextPosX = PosX + CharCellWidth;
		}
		else if(*Text == '\t')
		{
			Rect.left = PosX;
			Rect.top = PosY;
			Rect.right = BtmPosX;
			Rect.bottom = PosY + CharHeight;
			ExtTextOut(hDC, PosX, PosY, ETO_OPAQUE, &Rect, "", 0, (const int *)&CellSep);
			NextPosX = BtmPosX;
		}
		else
		{
			if((uchar)*Text < (uchar)' ')
			{
				Tmp[0] = '@' + *Text;
				Text = Tmp;
				Len = 1;
			}

			if(AskFixedPitchFont() == YES)
			{
				ExtTextOut(hDC, PosX, PosY, ETO_CLIPPED, &Rect, Text, Len, (const int *)&CellSep);
				NextPosX = PosX + (Len * CharCellWidth);
			}
			else
			{
				ExtTextOut(hDC, PosX, PosY, ETO_CLIPPED, &Rect, Text, Len, NULL);
				GetTextExtentPoint32(hDC, Text, Len, &Size);
				NextPosX = PosX + Size.cx;
			}
		}

		if(BkCol & ATTR_UNDER)
		{
			hPen = CreatePen(PS_SOLID, 0, TxCol);
			hPenOld = (HPEN)SelectObject(hDC, hPen);
			Rect.bottom = PosY + CharHeight - 1;
			Rect.left  = max(LEFT_OFFSET, PosX);
			Rect.right  = max(LEFT_OFFSET, NextPosX);
			MoveToEx(hDC, Rect.left, Rect.bottom, NULL);
			LineTo(hDC, Rect.right, Rect.bottom);
			SelectObject(hDC, hPenOld);
			DeleteObject(hPen);
		}
		if(BkCol & ATTR_REGION)
		{
			Rect.top = PosY;
			Rect.bottom = PosY + CharHeight;
			Rect.left  = max(LEFT_OFFSET, PosX);
			Rect.right  = max(LEFT_OFFSET, NextPosX);
			InvertRect(hDC, &Rect);
		}
		PosX = NextPosX;
	}
	return(PosX);
}


/*----- w͈͂̃eLXg𔽓]\ ------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		HDC hDC : foCXReLXg
*			NULL=GetDCŋ߂
*		int RgnTop : ͈͎w̐擪
*		int RgnBtm : ͈͎w̖
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void InvertTextColor(HWND hWnd, HDC hDC, char *RgnTop, char *RgnBtm)
{
	char *Text;
	char *LineTop;
	int Len;
	int i;
	RECT Rev;
	HDC InDC;
	int Col;
	int TabWid;
	FILEMANTBL *CurFile;
	int Fixed;
	HFONT hFontOld;
	int PosX;
	int TmpPosX;
	char *ChkTop;

	Fixed = AskFixedPitchFont();
	CheckTopAndBtmAdrs(&RgnTop, &RgnBtm);
	CurFile = AskCurFileTbl();
	TabWid = AskCurExtSet()->TabWidth;

	InDC = hDC;
	if(InDC == NULL)
		hDC = GetDC(hWnd);

	if(Fixed == NO)
	{
		hFontOld = NULL;
		if(hFontttPage != NULL)
			hFontOld = SelectObject(hDC, hFontttPage);
	}

	for(i = 0; i < WinLines; i++)
	{
		if((LineTop = GetLineTop(CurFile, CurFile->DispTopLine + i)) != NULL)
		{
			Len = GetLineLen(CurFile, CurFile->DispTopLine + i);

			Text = LineTop;
			Rev.left = -1;
			Rev.right = -1;
			Col = 0;
			PosX = 0;
			ChkTop = Text;
			for(; Len > 0; Len--)
			{
				if((Rev.left == -1) && (Text >= RgnTop) && (Text < RgnBtm))
					Rev.left = PosX + GetTextPixelWidth(hDC, ChkTop, Text-ChkTop, Fixed);
				else if((Rev.left != -1) && (Rev.right == -1) && (Text >= RgnBtm))
				{
					Rev.right = PosX + GetTextPixelWidth(hDC, ChkTop, Text-ChkTop, Fixed);
					break;
				}

				if(*Text == '\t')
				{
					PosX += GetTextPixelWidth(hDC, ChkTop, Text-ChkTop, Fixed);

					Col += GetTabWidth(TabWid, Col);
					TmpPosX = Col * CharCellWidth;
					if(Fixed == NO)
					{
						while(TmpPosX < PosX)
						{
							Col += TabWid;
							TmpPosX = (Col * CharCellWidth);
						}
					}
					PosX = TmpPosX;
					Text++;
					ChkTop = Text;
				}
				else if(*Text == '\n')
				{
					PosX += GetTextPixelWidth(hDC, ChkTop, Text-ChkTop, Fixed);
					PosX += CharCellWidth;
					Text++;
					Col++;
					ChkTop = Text;
				}
				else
				{
					Col++;
					Text++;
				}
			}

			if(Rev.left != -1)
			{
				if(Rev.right == -1)
					Rev.right = PosX + GetTextPixelWidth(hDC, ChkTop, Text-ChkTop, Fixed);

				Rev.top = CharCellHeight * i;
				Rev.bottom = Rev.top + CharHeight;
				Rev.left  = max(LEFT_OFFSET, Rev.left + LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth));
				Rev.right  = max(LEFT_OFFSET, Rev.right + LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth));
				InvertRect(hDC, &Rev);
			}
		}
	}

	if(Fixed == NO)
	{
		if(hFontOld != NULL)
			SelectObject(hDC, hFontOld);
	}

	if(InDC == NULL)
		ReleaseDC(hWnd, hDC);

	return;
}


/*----- w͈͂̃eLXg̃sNZԂ ----------------------------------
*
*	Parameter
*		HDC hDC : foCXReLXg
*		char *Text : eLXg
*		int Len : eLXg̒
*		int Fixed : Œ蒷tHgǂ
*
*	Return Value
*		int sNZ
*----------------------------------------------------------------------------*/

static int GetTextPixelWidth(HDC hDC, char *Text, int Len, int Fixed)
{
	int Ret;
	SIZE Size;

	if(Fixed == YES)
		Ret = Len * CharCellWidth;
	else
	{
		GetTextExtentPoint32(hDC, Text, Len, &Size);
		Ret = Size.cx;
	}
	return(Ret);
}


/*----- AhX̑O֌W𒲐 ----------------------------------------------
*
*	Parameter
*		char **Top : 擪
*		char **Btm : 
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CheckTopAndBtmAdrs(char **Top, char **Btm)
{
	char *Tmp;

	if(*Btm < *Top)
	{
		Tmp = *Top;
		*Top = *Btm;
		*Btm = Tmp;
	}
	return;
}


/*----- sԍ̑O֌W𒲐 ------------------------------------------------
*
*	Parameter
*		int *Top : 擪
*		int *Btm : 
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CheckTopAndBtmLine(int *Top, int *Btm)
{
	int Tmp;

	if(*Btm < *Top)
	{
		Tmp = *Top;
		*Top = *Btm;
		*Btm = Tmp;
	}
	return;
}


/*----- ͈͎w肪sĂ邩ǂԂ ----------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int Xe[^X
*			YES/NO
*----------------------------------------------------------------------------*/

int AskRegSelected(void)
{
	int Sts;

	Sts = NO;
	if(AskCurFileTbl()->RgnStartPos != NULL)
		Sts = YES;
	return(Sts);
}


/*----- ㉺XN[ --------------------------------------------------------
*
*	Parameter
*		inr Num : XN[s (Smooth=1̏ꍇ1ŝ)
*		int Smooth : X[XXN[ǂ (YES/NO)
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ScrollUpDownView(int Num, int Smooth)
{
	RECT Rect;
	RECT UpRect;
	HDC hDC;
	int Dir;
	int Step;
	int Lines;
	int LinesX;
	int CurX;
	int Cur;
	int i;

	hDC = GetDC(hWndView);
	GetClientRect(hWndView, &Rect);
	Rect.left += LEFT_OFFSET;

	if(Smooth == NO)
	{
		ScrollDC(hDC, 0, Num * CharCellHeight, &Rect, &Rect, NULL, &UpRect);
		RedrawWindow(hWndView, &UpRect, NULL, RDW_UPDATENOW | RDW_INVALIDATE | RDW_NOINTERNALPAINT);
	}
	else
	{
		Dir = (Num < 0) ? -1 : 1;
		Lines = abs(Num) * CharCellHeight;
		LinesX = Lines * 1000;
		Step = LinesX / SmoothRate;
		Cur = 0;
		CurX = 0;

		for(i = 0; i < SmoothRate; i++)
		{
			CurX += Step;
			if(Cur < (CurX/1000))
			{
				ScrollDC(hDC, 0, (CurX/1000 - Cur) * Dir, &Rect, &Rect, NULL, &UpRect);
				FillRect(hDC, &UpRect, hBrushBack);
				Cur = CurX/1000;
			}
		}

		if(Cur < Lines)
		{
			ScrollDC(hDC, 0, (Lines - Cur) * Dir, &Rect, &Rect, NULL, &UpRect);
			FillRect(hDC, &UpRect, hBrushBack);
		}

		if(Dir == -1)
			Rect.top = Rect.bottom - Lines;
		else
			Rect.bottom = Rect.top + Lines;
 
		RedrawWindow(hWndView, &Rect, NULL, RDW_UPDATENOW | RDW_INVALIDATE | RDW_NOINTERNALPAINT);
	}

	ReleaseDC(hWndView, hDC);

	return;
}


/*----- EXN[ --------------------------------------------------------
*
*	Parameter
*		inr Num : XN[s
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void ScrollLeftRightView(int Num)
{
	RECT Rect;
	RECT UpRect;
	HDC hDC;

	hDC = GetDC(hWndView);
	GetClientRect(hWndView, &Rect);
	Rect.left += LEFT_OFFSET;
	ScrollDC(hDC, Num * CharCellWidth, 0, &Rect, &Rect, NULL, &UpRect);
	ReleaseDC(hWndView, hDC);

	RedrawWindow(hWndView, &UpRect, NULL, RDW_UPDATENOW | RDW_INVALIDATE | RDW_NOINTERNALPAINT);

	return;
}


/*----- XN[o[̃Zbg --------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetScrollBar(void)
{
	SCROLLINFO ScrInfo;
	FILEMANTBL *CurFile;

	CurFile = AskCurFileTbl();

	/* XN[o[ */
	ScrInfo.cbSize = sizeof(SCROLLINFO);
	ScrInfo.fMask = SIF_RANGE | SIF_PAGE | SIF_POS | SIF_DISABLENOSCROLL;
	ScrInfo.nMax = CurFile->TextLines / CurFile->SbarStep;
	ScrInfo.nMin = 0;
	ScrInfo.nPage = WinLines / CurFile->SbarStep;
	ScrInfo.nPos = CurFile->DispTopLine / CurFile->SbarStep;
	SetScrollInfo(hWndView, SB_VERT, &ScrInfo, TRUE);

	/* XN[o[ */
	ScrInfo.cbSize = sizeof(SCROLLINFO);
	ScrInfo.fMask = SIF_RANGE | SIF_PAGE | SIF_POS  | SIF_DISABLENOSCROLL;
	ScrInfo.nMin = 0;
	if(AskCurExtSet()->FoldRight == NO)
	{
		ScrInfo.nMax = AskCurExtSet()->FoldPos;
		ScrInfo.nPage = WinColumns;
		ScrInfo.nPos = CurFile->DispTopColumn;
	}
	else
	{
		ScrInfo.nMax = 0;
		ScrInfo.nPage = 0;
		ScrInfo.nPos = 0;
	}
	SetScrollInfo(hWndView, SB_HORZ, &ScrInfo, TRUE);

	return;
}


/*----- EChẼTCYɂ悤ɕ\擪ʒu𒲐߂ ------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void SetDispTopWindowMatch(void)
{
	SCROLLINFO ScrInfo;
	EXTSET *CurExt;
	FILEMANTBL *CurFile;

	CurExt = AskCurExtSet();
	CurFile = AskCurFileTbl();

	ScrInfo.cbSize = sizeof(SCROLLINFO);
	ScrInfo.fMask = SIF_POS;
	GetScrollInfo(hWndView, SB_HORZ, &ScrInfo);

	if(ScrInfo.nPos >= CurExt->FoldPos - 1)
		ScrInfo.nPos = CurExt->FoldPos - 1;
	ChangeDispTopColumn(hWndView, ScrInfo.nPos, NO);

	ScrInfo.cbSize = sizeof(SCROLLINFO);
	ScrInfo.fMask = SIF_POS;
	GetScrollInfo(hWndView, SB_VERT, &ScrInfo);

	if(ScrInfo.nPos >= CurFile->TextLines - 1)
		ScrInfo.nPos = CurFile->TextLines - 1;
	ChangeDispTopLine(hWndView, ScrInfo.nPos, NO);

	return;
}


/*----- J[\ʒu當ʒu߂ --------------------------------------
*
*	Parameter
*		HWND hWnd : 
*		int PosX : XW
*		inr PosY : YW
*
*	Return Value
*		char *ʒu
*----------------------------------------------------------------------------*/

static char *AskCursorCharPos(HWND hWnd, int PosX, int PosY)
{
	HDC hDC;
	HFONT hFontOld;
	int TabWid;
	char *LineTop;
	char *Text;
	int Len;
	int Col;
	FILEMANTBL *CurFile;
	int Fixed;
	int Add;
	int ChkPosX;
	int TmpPosX;

	Fixed = AskFixedPitchFont();
	CurFile = AskCurFileTbl();
	TabWid = AskCurExtSet()->TabWidth;

	if(Fixed == NO)
	{
		hDC = GetDC(hWnd);
		hFontOld = NULL;
		if(hFontttPage != NULL)
			hFontOld = SelectObject(hDC, hFontttPage);
	}

	PosY /= CharCellHeight;
	PosX -= LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth);

	if((LineTop = GetLineTop(CurFile, CurFile->DispTopLine + PosY)) != NULL)
	{
		Len = GetLineLen(CurFile, CurFile->DispTopLine + PosY);
		Text = LineTop;
		Col = 0;
		ChkPosX = 0;
		for(; Len > 0; )
		{
			if(IsSjis(*Text) == YES)
			{
				ChkPosX += GetTextPixelWidth(hDC, Text, 2, Fixed);
				Add = 2;
			}
			else
			{
				if(*Text == '\t')		/* TAB */
				{
					Col += GetTabWidth(TabWid, Col);
					TmpPosX = Col * CharCellWidth;
					if(Fixed == NO)
					{
						while(TmpPosX < ChkPosX)
						{
							Col += TabWid;
							TmpPosX = (Col * CharCellWidth);
						}
					}
					ChkPosX = TmpPosX;
				}
				else
				{
					ChkPosX += GetTextPixelWidth(hDC, Text, 1, Fixed);
					Col++;
				}
				Add = 1;
			}

			if(ChkPosX >= PosX)
				break;

			Text += Add;
			Len -= Add;
		}
	}
	else
		Text = CurFile->TextData + CurFile->TextSize;	/*  */

	if(Fixed == NO)
	{
		if(hFontOld != NULL)
			SelectObject(hDC, hFontOld);
		ReleaseDC(hWnd, hDC);
	}
	return(Text);
}


/*----- Nbv{[hփRs[ ------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		char *RgnTop : ͈͎w̐擪
*		char *RgnBtm : ͈͎w̖
*		char *Quote : p
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CopyToClipBoard(HWND hWnd, char *RgnTop, char *RgnBtm, char *Quote)
{
	int Len;
	void *gBuf;
	HGLOBAL hGlobal;

	CheckTopAndBtmAdrs(&RgnTop, &RgnBtm);

	if(OpenClipboard(hWnd))
	{
		if(EmptyClipboard())
		{
			Len = AskStrLenLFtoCRLF(RgnTop, (RgnBtm-RgnTop), Quote);
			if((hGlobal = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE | GMEM_ZEROINIT, Len+1)) != NULL)
			{
				if((gBuf = GlobalLock(hGlobal)) != NULL)
				{
					CopyStrLFtoCRLF(gBuf, RgnTop, RgnBtm-RgnTop, Quote);
					*((char *)gBuf + Len) = NUL;

					GlobalUnlock(hGlobal);
					SetClipboardData(CF_TEXT, hGlobal);
				}
			}
		}
		CloseClipboard();
	}
	return;
}


/*----- Nbv{[h֒ǉRs[ --------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		char *RgnTop : ͈͎w̐擪
*		char *RgnBtm : ͈͎w̖
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void AppendToClipBoard(HWND hWnd, char *RgnTop, char *RgnBtm)
{
	int Len;
	int Size;
	char *gBuf;
	HGLOBAL hGlobal;
	char *Tmp;

	CheckTopAndBtmAdrs(&RgnTop, &RgnBtm);

	if(OpenClipboard(hWnd))
	{
		if((hGlobal = GetClipboardData(CF_TEXT)) != NULL)
		{
			if((gBuf = GlobalLock(hGlobal)) != NULL)
			{
				Size = strlen(gBuf);
				Len = AskStrLenLFtoCRLF(RgnTop, (RgnBtm-RgnTop), "");

				/* GlobalReAlloc()găNbN{[h̃g	*/
				/* Ă܂Ȃ̂ŁAʂ̃obt@ɕۑĂ	*/
				/* ăNbv{[hȂ							*/
				if((Tmp = malloc(Size+1)) != NULL)
				{
					strcpy(Tmp, gBuf);

					GlobalUnlock(hGlobal);
					if(EmptyClipboard())
					{
						if((hGlobal = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE | GMEM_ZEROINIT, Size+Len+1)) != NULL)
						{
							if((gBuf = GlobalLock(hGlobal)) != NULL)
							{
								strcpy(gBuf, Tmp);
								CopyStrLFtoCRLF(gBuf+Size, RgnTop, RgnBtm-RgnTop, "");
								*(gBuf+Size+Len) = NUL;

								GlobalUnlock(hGlobal);
								SetClipboardData(CF_TEXT, hGlobal);
							}
						}
					}
					free(Tmp);
				}
			}
		}
		CloseClipboard();
	}
	return;
}











/*----- w̃obt@փRs[ ------------------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		char *RgnTop : ͈͎w̐擪
*		char *RgnBtm : ͈͎w̖
*		char *Buf : obt@
*		int Max : obt@̃TCY
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void CopyToBuffer(HWND hWnd, char *RgnTop, char *RgnBtm, char *Buf, int Max)
{
	memset(Buf, NUL, Max);
	Max--;

	CheckTopAndBtmAdrs(&RgnTop, &RgnBtm);
	if((RgnBtm - RgnTop) < Max)
		Max = RgnBtm - RgnTop;

	memcpy(Buf, RgnTop, Max);

	return;
}


/*----- ʂ̔]\sȂǂԂ ------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int Xe[^X
*			YES/NO
*----------------------------------------------------------------------------*/

int AskDispFindRev(void)
{
	return(RevFindStr);
}






/*----- _CAÕR[obN ------------------------------------------
*
*	Parameter
*		HWND hDlg : EChEnh
*		UINT message : bZ[Wԍ
*		WPARAM wParam : bZ[W WPARAM 
*		LPARAM lParam : bZ[W LPARAM 
*
*	Return Value
*		BOOL TRUE/FALSE
*----------------------------------------------------------------------------*/

static BOOL CALLBACK FindDialogCallBack(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static FINDDLGDATA *Find;
	char *Pos;

	switch (iMessage)
	{
		case WM_INITDIALOG :
			Find = (FINDDLGDATA *)lParam;
			SendDlgItemMessage(hDlg, FIND_EDIT, CB_LIMITTEXT, FINDSTR_LEN, 0);
			Pos = FindHist;
			while(*Pos != NUL)
			{
				SendDlgItemMessage(hDlg, FIND_EDIT, CB_ADDSTRING, 0, (LPARAM)Pos);
				Pos += strlen(Pos) + 1;
			}
			SendDlgItemMessage(hDlg, FIND_EDIT, CB_SETCURSEL, 0, 0);
			if(strlen(Find->Str) > 0)
				SendDlgItemMessage(hDlg, FIND_EDIT, WM_SETTEXT, 0, (LPARAM)Find->Str);
			SendDlgItemMessage(hDlg, FIND_SELCASE, BM_SETCHECK, Find->CapsFlg, 0);
			SendDlgItemMessage(hDlg, FIND_REGEXP, BM_SETCHECK, Find->Regexp, 0);
			if(Find->Regexp == YES)
				EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), FALSE);
			return(TRUE);

		case WM_COMMAND :
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				case IDOK :
					SendDlgItemMessage(hDlg, FIND_EDIT, WM_GETTEXT, FINDSTR_LEN+1, (LPARAM)Find->Str);
					Find->CapsFlg = SendDlgItemMessage(hDlg, FIND_SELCASE, BM_GETCHECK, 0, 0);
					Find->Regexp = SendDlgItemMessage(hDlg, FIND_REGEXP, BM_GETCHECK, 0, 0);
					EndDialog(hDlg, YES);
					break;

				case IDCANCEL :
					EndDialog(hDlg, NO);
					break;

				case FIND_REGEXP :
					if(SendDlgItemMessage(hDlg, FIND_REGEXP, BM_GETCHECK, 0, 0) == 1)
						EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), FALSE);
					else
						EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), TRUE);
					break;

				case IDHELP :
					WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 10);
					break;

			}
            return(TRUE);
	}
	return(FALSE);
}

/*----- qXgɕo^ --------------------------------------------
*
*	Parameter
*		char *Str : 
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/
void SetStrToFindHist(char *Str)
{
	DeleteStrFromMultiStr(Str, FindHist);
	while(CountMultiStrNum(FindHist) >= FINDHIST_NUM)
		DeleteNumFromMultiStr(FINDHIST_NUM-1, FindHist);
	InsertStrToMultiStr(Str, FindHist, FINDHIST_NUM*(FINDSTR_LEN+1)+1);
	return;
}

/*----- }EXJ[\̃Jbg\ ------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*		int PosX : }EXJ[\Xʒu
*		int PosY : }EXJ[\Yʒu
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void DispMouseCaret(HWND hWnd, int PosX, int PosY)
{
	HDC hDC;
	char *Text;
	char *LineTop;
	int Len;
	RECT Rev;
	int Col;
	int TabWid;
	FILEMANTBL *CurFile;
	int Fixed;
	HFONT hFontOld;
	char *RgnTop;
	int Add;
	int ChkPosX;
	int NextPosX;

	DispMousePos();

	if(DispCaret == YES)
	{
		hDC = GetDC(hWnd);

		Fixed = AskFixedPitchFont();
		CurFile = AskCurFileTbl();
		TabWid = AskCurExtSet()->TabWidth;

		if(Fixed == NO)
		{
			hFontOld = NULL;
			if(hFontttPage != NULL)
				hFontOld = SelectObject(hDC, hFontttPage);
		}

		PosY /= CharCellHeight;
		PosX -= LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth);

		/* }EXJ[\ʒu̕߂ */
		Rev.left = -1;
		Rev.right = -1;
		RgnTop = NULL;
		if((LineTop = GetLineTop(CurFile, CurFile->DispTopLine + PosY)) != NULL)
		{
			Len = GetLineLen(CurFile, CurFile->DispTopLine + PosY);
			Text = LineTop;
			Col = 0;
			ChkPosX = 0;
			for(; Len > 0; )
			{
				if(IsSjis(*Text) == YES)
				{
					NextPosX = ChkPosX + GetTextPixelWidth(hDC, Text, 2, Fixed);
					Add = 2;
				}
				else
				{
					if(*Text == '\t')		/* TAB */
					{
						Col += GetTabWidth(TabWid, Col);
						NextPosX = Col * CharCellWidth;
						if(Fixed == NO)
						{
							while(NextPosX < ChkPosX)
							{
								Col += TabWid;
								NextPosX = (Col * CharCellWidth);
							}
						}
					}
					else
					{
						NextPosX = ChkPosX + GetTextPixelWidth(hDC, Text, 1, Fixed);
						Col++;
					}
					Add = 1;
				}

				if((PosX >= ChkPosX) && (PosX <= NextPosX))
				{
					Rev.left = ChkPosX;
					Rev.right = NextPosX;
					RgnTop = Text;
					break;
				}

				ChkPosX = NextPosX;
				Text += Add;
				Len -= Add;
			}
		}

		if(CaretPos != RgnTop)
		{
			if(CaretPos != NULL)
			{
				/*  */
				InvertRect(hDC, &CaretRect);
				CaretPos = NULL;
			}
			if(Rev.left != -1)
			{
				/* \ */
				Rev.top = CharCellHeight * PosY;
				Rev.bottom = Rev.top + CharHeight;
				Rev.left  = max(LEFT_OFFSET, Rev.left + LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth));
				Rev.right  = max(LEFT_OFFSET, Rev.right + LEFT_OFFSET - (CurFile->DispTopColumn * CharCellWidth));
				InvertRect(hDC, &Rev);

				CaretRect.top = Rev.top;
				CaretRect.bottom = Rev.bottom;
				CaretRect.left = Rev.left;
				CaretRect.right = Rev.right;
				CaretPos = RgnTop;
			}
		}

		if(Fixed == NO)
		{
			if(hFontOld != NULL)
				SelectObject(hDC, hFontOld);
		}
		ReleaseDC(hWnd, hDC);
	}
	return;
}


/*----- }EXJ[\̃Jbg ------------------------------------
*
*	Parameter
*		HWND hWnd : EChEnh
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

static void EraseMouseCaret(HWND hWnd)
{
	HDC hDC;
	if(CaretPos != NULL)
	{
		hDC = GetDC(hWnd);
		InvertRect(hDC, &CaretRect);
		CaretPos = NULL;
		ReleaseDC(hWnd, hDC);
	}
	return;
}






/*----- }EXJ[\̈ʒu\ ----------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DispMousePos(void)
{
	FILEMANTBL *CurFile;
	POINT Pos;
	RECT Rect;

	GetClientRect(hWndView, &Rect);
	GetCursorPos(&Pos);
	ScreenToClient(hWndView, &Pos);
	if(((Pos.y >= 0) && (Pos.y < Rect.bottom)) &&
	   ((Pos.x >= 0) && (Pos.x < Rect.right)))
	{
		CurFile = AskCurFileTbl();
		Pos.y /= CharCellHeight;
		DispCurrentLineNum(2, CurFile->DispTopLine + Pos.y);
	}
	return;
}
