/*=============================================================================
*								K\Cu
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */


#define	STRICT
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock.h>
#include <windowsx.h>

#define MSDOS
#define MSC6BCPP3
#define KANJI
#define BYTEWIDTH 8

#include "regex.h"
#include "regexp.h"

#define VERSION_STR		"Regexp.dll Ver.1.00\r\nCopyright 1999-2001 Sota && F.S.F."


#define NUL				'\0'


/*===== vg^Cv =====*/

static int MakeRegexp(char *Str, char *Buf, int BufSize);

/*===== [Jȕϐ =====*/

static struct re_pattern_buffer Patbuf;


/*----- K\Cu --------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int Xe[^X (REG_SUCCESS/REG_FAIL)
*----------------------------------------------------------------------------*/

int RegexInit(void)
{
	int Sts;

	Sts = REG_FAIL;
	re_set_syntax(RE_SYNTAX_AWK);
	Patbuf.allocated = 40;
	if((Patbuf.buffer = malloc(Patbuf.allocated)) != NULL)
	{
		if((Patbuf.fastmap = malloc(1 << BYTEWIDTH)) != NULL)
		{
			Patbuf.translate = NULL;
			Sts = REG_SUCCESS;
		}
		else
			free(Patbuf.buffer);
	}
	return(Sts);
}


/*----- K\CuI ----------------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void RegexFree(void)
{
	if(Patbuf.buffer != NULL)
		free(Patbuf.buffer);
	if(Patbuf.fastmap != NULL)
		free(Patbuf.fastmap);
	return;
}


/*----- RpC ------------------------------------------------
*
*	Parameter
*		char *Pat : 
*
*	Return Value
*		int Xe[^X (REG_SUCCESS/REG_FAIL)
*----------------------------------------------------------------------------*/

int RegexCompile(char *Pat)
{
	char Tmp[1024];
	int Sts;

	Sts = REG_SUCCESS;
	MakeRegexp(Pat, Tmp, 1024);
	if(re_compile_pattern(Tmp, strlen(Tmp), &Patbuf) == NULL)
		Sts = REG_FAIL;
	return(Sts);
}


/*----- eLXg̒當 ------------------------------------------
*
*	Parameter
*		char *Top : ̐擪
*		char *Btm : ̖
*		char **mPos : ʒu (NULL=Ȃ)
*		int *mLen : 
*
*	Return Value
*		int Xe[^X (REG_SUCCESS/REG_FAIL)
*----------------------------------------------------------------------------*/

int RegexSearch(char *Top, char *Btm, char **mPos, int *mLen)
{
	int Sts;
	int Len;
	int Result;
	struct re_registers Mreg;

	*mPos = NULL;
	Sts = REG_FAIL;
	Len = Btm - Top;
	if((Result = re_search(&Patbuf, Top, Len, 0, Len, &Mreg)) >= 0)
	{
		*mPos = Top + Result;
		*mLen = Mreg.end[0] - Mreg.start[0];
		Sts = REG_SUCCESS;
	}
	return(Sts);
}


/*----- 𐮌` --------------------------------------------------
*
*	Parameter
*		char *Str : 
*		char *Buf : `̕i[obt@
*		int BufSize : Buf̃TCY
*
*	Return Value
*		int Xe[^X (REG_SUCCESS/REG_FAIL)
*----------------------------------------------------------------------------*/

static int MakeRegexp(char *Str, char *Buf, int BufSize)
{
	int c;
	int Sts;
	char *Btm;

	Sts = REG_SUCCESS;
	Btm = strchr(Str, NUL);
	while((BufSize >= 2) && (Str < Btm))
	{
		if(*Str == '\\')
		{
			c = *++Str;
			switch (c)
			{
				case 'n':
					if(BufSize >= 2)
						*Buf++ = 0x0A;
					Str++;
					BufSize--;
					break;

				case 't':
					if(BufSize >= 2)
						*Buf++ = 0x09;
					Str++;
					BufSize--;
					break;

				default:
					if(BufSize >= 3)
					{
						*Buf++ = '\\';
						*Buf++ = c;
					}
					Str++;
					BufSize -= 2;
					break;
			}
		}
		else
		{
			if(BufSize >= 2)
				*Buf++ = *Str++;
			BufSize--;
		}
	}
	*Buf = '\0';

	return(Sts);
}


/*----- K\Cũo[W擾 ----------------------------------
*
*	Parameter
*		char *Buf : o[WRs[obt@
*		int Max : obt@̃TCY
*
*	Return Value
*		int Xe[^X (REG_SUCCESS/REG_FAIL)
*----------------------------------------------------------------------------*/

int RegexGetVer(char *Buf, int Max)
{

	memset(Buf, NUL, Max);
	strncpy(Buf, VERSION_STR, Max-1);
	return(REG_SUCCESS);
}


