/*=============================================================================
 *							t@CANZX
 *
 =============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
 *	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
 *	ĔЕzĂB */

/* Kazuya NOGUCHI ɂC܂݂܂B */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include <crtdbg.h>
#include <limits.h>

#include "common.h"
#include "resource.h"
#include "regexp.h"

/*===== vg^Cv =====*/

static void GetLongFileName(char *Fname);
static void GetLinkTarget(HWND hWnd, char *Fname);
static void ReadCommonProc(FILEMANTBL *CurFile, int TopLine, int Kanji, int KeepSet);
static void CheckEOLcode(FILEMANTBL *Tbl);
static char *MakeOneLineSubNum(char *Text, char *Btm, int TabWid, int Fold, int *LineNum);
static char *MakeOneLineSubRitht(HDC hDC, char *Text, char *Btm, int TabWid, int Width, int *LineNum);
static void RemoveLineTopTbl(FILEMANTBL *Tbl);
// by yhatley
//static char *GetLineTopFromAdrs(FILEMANTBL *Tbl, char *Text);
//static int GetLineNumFromAdrs(FILEMANTBL *Tbl, char *Text);
static int ConvLineToTableAndIndex(FILEMANTBL *Tbl, int Num, LINETOPTBL **Cur, int *Index);
static void MoveToNextTableAndIndex(LINETOPTBL **Cur, int *Index);
static int AskCharacterType(char *Text);
static void MakeAttributeTable(FILEMANTBL *Tbl);
static void RemoveAttributeTable(FILEMANTBL *Tbl);

/*===== [Jȃ[N ======*/

static FILEMANTBL *FileTblTop = NULL;
static int CurrentFile = -1;
static FILEMANTBL *CurrentTbl = NULL;

/*===== O[oȃ[N ======*/

extern int LineNum;
extern HFONT hFontttPage;
extern int CharCellWidth;
extern int HighlightURL; // ǉ


/*----- t@CÕtpXɕϊ ------------------------------
 *
 *	Parameter
 *		char *Fname : t@C
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

static void GetLongFileName(char *Fname)
{
	char *Pos;
	char *Pos1;
	char *Set;
	char Org[MAX_PATH+1];
	int Len;
	int OneLen;
	HANDLE hFind;
	WIN32_FIND_DATA FindBuf;

	/* ܂tpXɕϊ */
	GetFullPathName(Fname, MAX_PATH+1, Org, &Pos);

	/* hCu,zXgRs[ */
	memset(Fname, NUL, MAX_PATH+1);
	Len = MAX_PATH;
	Pos = Org;
	if((Pos1 = _mbschr(Pos, ':')) != NULL)
		Pos = Pos1 + 1;
	else if(_mbsncmp(Org, "\\\\", 2) == 0)
		{
			Pos += 2;
			if((Pos1 = _mbschr(Pos, '\\')) != NULL)
				{
					Pos = Pos1+1;
					if((Pos1 = _mbschr(Pos, '\\')) != NULL)
						Pos = Pos1;
					else
						Pos = _mbschr(Pos, NUL);
				}
			else
				Pos = _mbschr(Pos, NUL);
		}
	Len -= Pos-Org;
	_mbsncpy(Fname, Org, Pos-Org);

	/* fBNgPiRs[ */
	Pos1 = _mbstok(Pos, "\\");
	while(Pos1 != NULL)
		{
			_mbscat(Fname, "\\");
			Set = _mbschr(Fname, NUL);
			OneLen = strlen(Pos1);
			if(Len < OneLen)
				break;
			_mbscpy(Set, Pos1);

			if((hFind = FindFirstFile(Fname, &FindBuf)) != INVALID_HANDLE_VALUE)
				{
					FindClose(hFind);

					OneLen = strlen(FindBuf.cFileName);
					if(Len < OneLen)
						break;
					_mbscpy(Set, FindBuf.cFileName);
				}
			Len -= OneLen;
			Pos1 = _mbstok(NULL, "\\");
		}
	return;
}


/*----- .lnkt@C̃^[Qbg擾 ----------------------------------------
 *
 *	Parameter
 *		HWND hWnd : EChEnh
 *		char *Fname : t@C
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void GetLinkTarget(HWND hWnd, char *Fname)
{
	HRESULT  hres;
	IShellLink *pShLink; 
	WORD mbFname[MAX_PATH+1];
	IPersistFile *ppf;
	char Tmp[MAX_PATH+1];

	hres = CoCreateInstance(&CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, &IID_IShellLink, (void **)&pShLink);
	if(SUCCEEDED(hres))
		{
			hres = pShLink->lpVtbl->QueryInterface(pShLink, &IID_IPersistFile, (void **)&ppf);
			if(SUCCEEDED(hres))
				{
					MultiByteToWideChar(CP_ACP, 0, Fname, -1, mbFname, MAX_PATH);
					hres = ppf->lpVtbl->Load(ppf, mbFname, STGM_READ);
					if(SUCCEEDED(hres))
						{
							hres = pShLink->lpVtbl->Resolve(pShLink, hWnd, SLR_ANY_MATCH);
							if(SUCCEEDED(hres))
								{
									hres = pShLink->lpVtbl->GetPath(pShLink, Tmp, MAX_PATH, NULL, 0L);
									if(SUCCEEDED(hres))
										{
											strcpy(Fname, Tmp);
										}
								}
						}
					ppf->lpVtbl->Release(ppf);
				}
			pShLink->lpVtbl->Release(pShLink);
		}
	return;
}


/*----- t@CǗe[uǉ --------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL **Anchor : t@CǗf[^̐擪
 *
 *	Return Value
 *		int f[^ԍ
 *			-1 = G[
 *----------------------------------------------------------------------------*/

int AddFileData(FILEMANTBL **Anchor)
{
	FILEMANTBL *New;
	FILEMANTBL *Prev;
	int Ret;

	Ret = -1;
	if((New = malloc(sizeof(FILEMANTBL))) != NULL)
		{
			strcpy(New->Fname, "");
			New->ReadFrom = READFROM_NONE;
			New->Kanji = CODE_AUTO;
			New->TextData = NULL;
			New->TextSize = 0;
			New->TextLines = 0;
			New->LineData = NULL;
			New->AttrData = NULL;
			New->DispTopLine = 0;
			New->DispTopColumn = 0;
			New->FindStrLen = 0;
			strcpy(New->FindStr, "");
			New->FoundTbl = NULL;
			New->RgnSelecting = NO;
			New->RgnStartPos = NULL;
			New->RgnEndPos = NULL;
			New->Next = NULL;

			Ret = 0;
			if(*Anchor == NULL)
				*Anchor = New;
			else
				{
					Prev = *Anchor;
					Ret++;
					while(Prev->Next != NULL)
						{
							Prev = Prev->Next;
							Ret++;
						}
					Prev->Next = New;
				}
		}
	return(Ret);
}


/*----- t@CǗe[u폜 --------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL **Anchor : t@CǗf[^̐擪
 *		int Num : f[^ԍ
 *
 *	Return Value
 *		int Xe[^X
 *			SUCCESS/FAIL
 *----------------------------------------------------------------------------*/

int RemoveFileData(FILEMANTBL **Anchor, int Num)
{
	FILEMANTBL *Cur;
	FILEMANTBL *Prev;
	int Sts;

	Sts = FAIL;
	if((*Anchor != NULL) && (Num >= 0))
		{
			Sts = SUCCESS;

			Cur = *Anchor;
			if(Num == 0)
				*Anchor = Cur->Next;
			else
				{
					for(; Num > 0; Num--)
						{
							Prev = Cur;
							Cur = Cur->Next;
							if(Cur == NULL)
								{
									Sts = FAIL;
									break;
								}
						}
					Prev->Next = Cur->Next;
				}

			if(Sts == SUCCESS)
				{
					RemoveLineTopTbl(Cur);
					CancelSearchText(Cur);
					RemoveAttributeTable(Cur);
					free(Cur->TextData);
					free(Cur);
				}
		}
	return(Sts);
}


/*----- wԍ̃t@CǗf[^Ԃ ------------------------------------
 *
 *	Parameter
 *		FILEMANTBL **Anchor : t@CǗf[^̐擪
 *		int Num : f[^ԍ
 *
 *	Return Value
 *		FILEMANTBL *f[^̈ʒu
 *			NULL=Ȃ
 *----------------------------------------------------------------------------*/

FILEMANTBL *AskFileData(FILEMANTBL **Anchor, int Num)
{
	FILEMANTBL *Ret;

	Ret = NULL;
	if(Num >= 0)
		{
			Ret = *Anchor;
			for(; Num > 0; Num--)
				{
					if(Ret == NULL)
						break;

					Ret = Ret->Next;
				}
		}
	return(Ret);
}


/*----- Jgt@C̃t@CǗe[uԂ --------------------------
 *
 *	Parameter
 *		Ȃ
 *
 *	Return Value
 *		FILEMANTBL *f[^̈ʒu
 *----------------------------------------------------------------------------*/

FILEMANTBL *AskCurFileTbl(void)
{
	return(CurrentTbl);
}


/*----- t@Cǂݍ --------------------------------------------------
 *
 *	Parameter
 *		char *Fname : t@C
 *		int TopLine : \擪sԍ (0` : -1=ŏIy[W)
 *		int Kanji : R[h
 *		int KeepSet : ݒێ邩ǂ(YES/NO)
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void OpenViewFromFile(char *Fname, int TopLine, int Kanji, int KeepSet)
{
	FILE *Strm;
	long Size;
	int Tmp;

	GetLinkTarget(GetMainHwnd(), Fname);
	GetLongFileName(Fname);

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	if((Strm = fopen(Fname, "rt")) != NULL){
		fseek(Strm, 0, SEEK_END);
		Size = ftell(Strm);
		fseek(Strm, 0, SEEK_SET);

		if((Tmp = AddFileData(&FileTblTop)) != -1){
			CurrentFile = Tmp;
			CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

			strcpy(CurrentTbl->Fname, Fname);
			if((CurrentTbl->TextData = malloc(Size + BUFFER_MARGIN)) != NULL){
				CurrentTbl->TextSize = fread(CurrentTbl->TextData, 1, Size, Strm);
				CurrentTbl->ReadFrom = READFROM_FILE;
			}
		}
		fclose(Strm);

		AddFileToHistory(Fname);
	}
	if( CurrentTbl ) ReadCommonProc(CurrentTbl, TopLine, Kanji, KeepSet);
	return;
}


/*----- t@C̍ēǂݍ ----------------------------------------------
 *
 *	Parameter
 *		int Kanji : R[h
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void ReopenViewFromFile(int Kanji)
{
	char Fname[MAX_PATH+1];
	int Num;

	if(CurrentTbl->ReadFrom == READFROM_FILE){
		CurrentTbl = AskFileData(&FileTblTop, CurrentFile);
		strcpy(Fname, CurrentTbl->Fname);
		Num = CurrentTbl->DispTopLine;
		if(AskCurExtSet()->LineNumType == LINENUM_EDITOR)
			Num = GetLogicalLineNum(CurrentTbl, Num);
		OpenViewFromFile(Fname, Num, Kanji, YES);
	}
	return;
}


/*----- Nbv{[hǂݍ --------------------------------------------
 *
 *	Parameter
 *		int TopLine : \擪sԍ (0` : -1=ŏIy[W)
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void OpenViewFromClipBoard(int TopLine)
{
	HGLOBAL cbhdl;
	char *Data;
	int Size;
	int Tmp;

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	if(OpenClipboard(GetMainHwnd())){
		if((cbhdl = GetClipboardData(CF_TEXT)) != NULL){
			if((Data = GlobalLock(cbhdl)) != NULL){
				Size = strlen(Data);
				if((Tmp = AddFileData(&FileTblTop)) != -1){
					CurrentFile = Tmp;
					CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

					strcpy(CurrentTbl->Fname, "()");
					if((CurrentTbl->TextData = malloc(Size + BUFFER_MARGIN)) != NULL){
						CurrentTbl->TextSize = Size;
						memcpy(CurrentTbl->TextData, Data, Size);
						CurrentTbl->ReadFrom = READFROM_CBOARD;
					}
				}
				GlobalUnlock(cbhdl);
			}
		}
		CloseClipboard();
	}
	ReadCommonProc(CurrentTbl, TopLine, CODE_AUTO, NO);
	return;
}


/*----- W͂ǂݍ --------------------------------------------------
 *
 *	Parameter
 *		int TopLine : \擪sԍ (0` : -1=ŏIy[W)
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void OpenViewFromStdin(int TopLine)
{
	char Buf[1024];
	int Size;
	int Read;
	int Zero;
	HANDLE *hStdin;
	char *Text;
	int Tmp;

	RemoveFileData(&FileTblTop, CurrentFile);
	CurrentTbl = NULL;

	Read = 0;
	if((hStdin = GetStdHandle(STD_INPUT_HANDLE)) != INVALID_HANDLE_VALUE)
		ReadFile(hStdin, Buf, 1024, &Read, NULL);

	if(Read > 0){
		if((Text = malloc(Read + BUFFER_MARGIN)) != NULL){
			/* ȉƉ */
			Zero = 2;
			memcpy(Text, Buf, Read);
			Size = Read;
			while(Zero > 0){
				ReadFile(hStdin, Buf, 1024, &Read, NULL);
				if(Read > 0){
					if((Text = realloc(Text, Size + Read + BUFFER_MARGIN)) != NULL){
						memcpy(Text + Size, Buf, Read);
						Size += Read;
					}
				} else Zero--;
			}
		}

		if(Text != NULL){
			if((Tmp = AddFileData(&FileTblTop)) != -1){
				CurrentFile = Tmp;
				CurrentTbl = AskFileData(&FileTblTop, CurrentFile);

				strcpy(CurrentTbl->Fname, "()");
				CurrentTbl->TextSize = Size;
				CurrentTbl->TextData = Text;
				CurrentTbl->ReadFrom = READFROM_STDIN;
			}
			else free(Text);
		}
	}
	ReadCommonProc(CurrentTbl, TopLine, CODE_AUTO, NO);
	return;
}


/*----- Ǎ̋ʏ ----------------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗe[u
 *		int TopLine : \擪sԍ (0` : -1=ŏIy[W)
 *		int Kanji : R[h (CODE_xxx)
 *		int KeepSet : ݒێ邩ǂ(YES/NO)
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

static void ReadCommonProc(FILEMANTBL *CurFile, int TopLine, int Kanji, int KeepSet)
{
	char Buf[MAX_PATH+11];
	CODECONVINFO cInfo;
	int TmpLen;

	if(CurFile != NULL){
		if(CurFile->TextSize > 0){
			DispFileInfo(CurFile->Fname);
			ExitAllEditor(NO);
			CheckEOLcode(CurFile);

			CurFile->Kanji = CheckKanjiCode(CurFile->TextData, CurFile->TextSize);
			DispKanjiCode(CurFile->Kanji);
			// KȂ̂ŗvC
			if(CurFile->Kanji != CODE_SJIS){
				InitCodeConvInfo(&cInfo);
				cInfo.Str = CurFile->TextData;
				cInfo.StrLen = CurFile->TextSize;
				cInfo.Buf = CurFile->TextData;
				cInfo.BufSize = CurFile->TextSize + BUFFER_MARGIN;
				if(CurFile->Kanji == CODE_JIS) ConvJIStoSJIS(&cInfo);
				else if(CurFile->Kanji == CODE_UTF8) ConvUTF8toSJIS(&cInfo);
				else if(CurFile->Kanji == CODE_UNICODE) ConvUnicodetoSJIS(&cInfo);
				else ConvEUCtoSJIS(&cInfo);
				TmpLen = cInfo.OutLen;

				cInfo.Buf = CurFile->TextData + cInfo.OutLen;
				cInfo.BufSize = CurFile->TextSize - cInfo.OutLen;
				FlushRestData(&cInfo);

				CurFile->TextSize = TmpLen + cInfo.OutLen;
			}
			MakeAttributeTable(CurFile);
		}

		if(KeepSet == NO)
			SetCurExtNum();
		LineNum = AskCurExtSet()->LineNumDisp;
		SetFontSize();
		SetCellSize();
		/* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
		if(AskCurExtSet()->FoldRight == NO)
			MakeLineTopTbl(CurFile);
		CalcLineNumWinWidth();
		ResizeNumWindow();
		ResizeViewWindow();
		SetWindowSize();
		SetScrollBar();
		SetViewBackColor(AskCurExtSet()->BackColor);

		if(TopLine == -1)
			SendMessage(GetViewWinHwnd(), WM_COMMAND, MAKEWPARAM(MENU_FILEBTM, 0), 0);
		else
			SendMessage(GetViewWinHwnd(), WM_CHANGE_TOP, 0, TopLine);
		DispCurrentLineNum(1, CurFile->DispTopLine);
		DispMousePos();

		//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: start
		//ANeBu̎
		if( (GetActiveWindow() != GetMainHwnd()) )
			{
				char *sFname ;

				sFname = _mbsrchr(CurFile->Fname,'\\') ;
				sprintf(Buf, "%s - ttPage", sFname ? sFname+1 : CurFile->Fname ) ;
			}
		//ANeBu̎
		else
			{
				sprintf(Buf, "%s - ttPage", CurFile->Fname);
			}
		//Kazuya NOGUCHI: t@CpX̕\؂ւΉ: end

		SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)Buf);
	}
	else
		SendMessage(GetMainHwnd(), WM_SETTEXT, 0, (LPARAM)"ttPage");

	InvalidateRgn(GetNumWinHwnd(), NULL, TRUE);
	InvalidateRgn(GetViewWinHwnd(), NULL, TRUE);
	return;
}


/*----- sR[h̃`FbN ----------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗe[u
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/
static void CheckEOLcode(FILEMANTBL *Tbl)
{
	char *Text;
	char *Btm;
	int Size;

	Text = Tbl->TextData;
	Size = Tbl->TextSize;
	Btm = Text + Size;
	while((Text != NULL) && (Text < Btm))
		{
			if((Text = memchr(Text, '\r', Btm-Text)) != NULL)
				{
					if((Text+1 >= Btm) || (*(Text+1) != '\n'))
						*Text = '\n';
					else
						{
							memmove(Text, Text+1, Btm-(Text+1));
							Btm--;
							Size--;
						}
				}
		}
	Tbl->TextSize = Size;
	return;
}


/*----- eLXgŜɂčs擪ʒuf[^쐬 ------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		int Xe[^X
 *			SUCCESS/FAIL
 *
 *	Note
 *		s擪ʒuf[^ɂ́A܂܂
 *			j	LineTop[0] = "line 1\n"		Ps
 *					LineTop[1] = "Line 2\n"		Qs
 *					LineTop[2] = ""				
 *					Lines = 2
 *----------------------------------------------------------------------------*/

int MakeLineTopTbl(FILEMANTBL *Tbl)
{
	LINETOPTBL *Pos;
	LINETOPTBL *Prev;
	int Index;
	char *Text;
	char *Btm;
	int Sts;
	int Fold;
	int Tab;
	int LineNum;
	HDC hDC;
	HWND hWnd;
	HFONT hFontOld;
	RECT Rect;

	EXTSET *ExtSet;
	ExtSet = AskFileExtSet(GetFileExtSetNum(Tbl));

	Sts = SUCCESS;

	RemoveLineTopTbl(Tbl);
	Fold = ExtSet->FoldPos;
	Tab = ExtSet->TabWidth;
	if(ExtSet->FoldRight == YES)
		{
			hWnd = GetViewWinHwnd();
			hDC = GetDC(hWnd);
			hFontOld = NULL;
			if(hFontttPage != NULL)
				hFontOld = SelectObject(hDC, hFontttPage);
			GetClientRect(hWnd, &Rect);
		}

	Text = Tbl->TextData;
	Btm = Text + Tbl->TextSize;
	LineNum = 0;
	do
		{
			if((Pos = malloc(sizeof(LINETOPTBL))) != NULL)
				{
					if(Tbl->LineData == NULL)
						Tbl->LineData = Pos;
					else
						Prev->Next = Pos;

					Prev = Pos;
					Pos->Next = NULL;
					Pos->Lines = 0;
					for(Index = 0; Index < LINETBLMAX; Index++)
						{
							Pos->LineTop[Index] = Text;
							Pos->LineNum[Index] = LineNum;

							if(Text >= Btm)
								{
									Text++;
									break;
								}

							Pos->Lines += 1;
							Tbl->TextLines += 1;

							if(ExtSet->FoldRight == NO)
								Text = MakeOneLineSubNum(Text, Btm, Tab, Fold, &LineNum);
							else
								Text = MakeOneLineSubRitht(hDC, Text, Btm, Tab, Rect.right - (LEFT_OFFSET * 2), &LineNum);
						}
				}
			else
				Sts = FAIL;
		}
	while((Sts == SUCCESS) && (Text <= Btm));

	Tbl->SbarStep = (Tbl->TextLines + 65535) / 65535;

	if(ExtSet->FoldRight == YES)
		{
			if(hFontOld != NULL)
				SelectObject(hDC, hFontOld);
			ReleaseDC(hWnd, hDC);
		}

	return(Sts);
}

/*----- ܂ԂʒuwłPs쐬 --------------------------------------------
 *
 *	Parameter
 *		char *Text : eLXg
 *		char *Btm : eLXg̖
 *		int TabWid : ^u
 *		int Fold : ܂Ԃʒu
 *		int *LineNum : sԍ
 *
 *	Return Value
 *		char *s̃AhX
 *----------------------------------------------------------------------------*/

static char *MakeOneLineSubNum(char *Text, char *Btm, int TabWid, int Fold, int *LineNum)
{
	int Col;

	for(Col = 0; Col < Fold; )
		{
			if(Text >= Btm)
				break;
			else if(*Text == '\n')
				{
					Text++;
					*LineNum += 1;
					break;
				}
			else if(*Text == 0x09)		/* TAB */
				{
					Col += GetTabWidth(TabWid, Col);
					Text++;
				}
			else if(IsSjis(*Text) == YES)
				{
					if((Fold - Col) >= 2)
						{
							Text += 2;
							Col += 2;
						}
					else
						break;
				}
			else
				{
					Text++;
					Col++;
				}
		}
	return(Text);
}


/*----- E[Ő܂ԂłPs쐬 ----------------------------------------------
 *
 *	Parameter
 *		HDC hDC : foCXReLXg
 *		char *Text : eLXg
 *		char *Btm : eLXg̖
 *		int TabWid : ^u
 *		int Width : EChE̕
 *		int *LineNum : sԍ
 *
 *	Return Value
 *		char *s̃AhX
 *----------------------------------------------------------------------------*/

static char *MakeOneLineSubRitht(HDC hDC, char *Text, char *Btm, int TabWid, int Width, int *LineNum)
{
	int Tabs;
	int Col;
	int TmpPosX;
	int PosX;
	SIZE Size;
	char Tmp[2];
	int Len;
	char *Anchor;
	char *OrgTop;
	int Sjis;
	int Chars;
	int i;

	PosX = 0;
	Col = 0;
	OrgTop = Text;
	Anchor = Text;
	Sjis = NO;
	while(Text < Btm)
		{
			if((Text < Btm-1) && (Sjis == NO) && (IsSjis(*Text) == YES))
				Sjis = YES;
			else
				{
					Sjis = NO;

					if((Text == Btm-1) || ((uchar)*Text < (uchar)' '))
						/* x̒ɂȂAs悤ɂH */
						{
							Len = Text + 1 - Anchor;
							if((uchar)*Text < (uchar)' ')
								Len--;

							if(Len > 0)
								{
									if(AskFixedPitchFont() == YES)
										{
											Size.cx = Len * CharCellWidth;
											Chars = (Width - PosX) / CharCellWidth;
											if(Chars > Len)
												Chars = Len;
											if(Len > 1)
												{
													Sjis = NO;
													for(i = 0; i < Chars; i++)
														{
															if(Sjis == YES)
																Sjis = NO;
															else
																Sjis = IsSjis(Anchor[i]);
														}
													if(Sjis == YES)
														Chars--;
												}
										}
									else
										GetTextExtentExPoint(hDC, Anchor, Len, Width - PosX, &Chars, NULL, &Size);

									if(Chars < Len)
										{
											Text = Anchor + Chars;
											break;
										}
									PosX += Size.cx;
								}

							Anchor = Text + 1;
							if((uchar)*Text < (uchar)' ')
								Anchor--;
						}
				}

			/* Rg[R[h̏ */
			if((uchar)*Text < (uchar)' ')
				{
					if(*Text == '\t')			/* TAB */
						{
							Tabs = GetTabWidth(TabWid, Col);
							Col += Tabs;
							TmpPosX = Col * CharCellWidth;
							while(TmpPosX < PosX)
								{
									Col += TabWid;
									TmpPosX = Col * CharCellWidth;
								}
							PosX = TmpPosX;
						}
					else if(*Text == '\n')
						{
							PosX += CharCellWidth;
						}
					else
						{
							if((uchar)*Text < (uchar)' ')
								{
									Tmp[0] = '@' + *Text;
									Len = 1;
								}

							if(AskFixedPitchFont() == YES)
								PosX += CharCellWidth;
							else
								{
									GetTextExtentPoint32(hDC, Tmp, 1, &Size);
									PosX += Size.cx;
								}
						}

					if(PosX >= Width)
						break;
					else
						Anchor = Text + 1;

					if(*Text == '\n')
						{
							Text++;
							*LineNum += 1;
							break;
						}
				}
			else
				Col++;

			Text++;
		}

	/* Ps͍ŒP */
	if(OrgTop == Text)
		{
			if(((Btm - Text) > 2) && (IsSjis(*Text) == YES))
				Text += 2;
			else
				Text++;
		}

	return(Text);
}


/*----- ݂̌ʒu玟̃^uXgbv܂ł̌Ԃ ----------------------
 *
 *	Parameter
 *		int TabWid : ^u
 *		int Col : ݂̌ʒu
 *
 *	Return Value
 *		int ̃^uXgbv܂ł̌
 *----------------------------------------------------------------------------*/

int GetTabWidth(int TabWid, int Col)
{
	int Tabs;

	Tabs = (((Col + TabWid) / TabWid) * TabWid) - Col;
	return(Tabs);
}


/*----- SHIFT-JIŜPoCgڂ`FbN ---------------------------------------
 *
 *	Parameter
 *		char ch : 
 *
 *	Return Value
 *		int Xe[^X
 *			YES/NO
 *----------------------------------------------------------------------------*/

int IsSjis(char ch)
{
	int sts;

	sts = NO;
	if((((uchar)ch >= (uchar)0x81) && ((uchar)ch <= (uchar)0x9F)) ||	/* 0x81`0x9F  */
	   (((uchar)ch >= (uchar)0xE0) && ((uchar)ch <= (uchar)0xEF)))		/* 0xE0`0xEF Ȃ */
		sts = YES;										/* SHIFT-JIS */
	return(sts);
}


/*----- s擪ʒuf[^폜 --------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

static void RemoveLineTopTbl(FILEMANTBL *Tbl)
{
	LINETOPTBL *Pos;
	LINETOPTBL *Next;

	Pos = Tbl->LineData;
	while(Pos != NULL)
		{
			Next = Pos->Next;
			free(Pos);
			Pos = Next;
		}
	Tbl->LineData = NULL;
	Tbl->TextLines = 0;
	return;
}


/*----- sԍŎw肳ꂽs̐擪̃̕AhX߂ --------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : sԍ
 *
 *	Return Value
 *		char *ʒu
 *----------------------------------------------------------------------------*/

char *GetLineTop(FILEMANTBL *Tbl, int Num)
{
	LINETOPTBL *Cur;
	int Index;
	char *Top;

	Top = NULL;
	if(ConvLineToTableAndIndex(Tbl, Num, &Cur, &Index) == SUCCESS)
		Top = Cur->LineTop[Index];

	return(Top);
}


/*----- sԍŎw肳ꂽs̕Ԃ ------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : sԍ
 *
 *	Return Value
 *		int 
 *----------------------------------------------------------------------------*/

int GetLineLen(FILEMANTBL *Tbl, int Num)
{
	LINETOPTBL *Cur;
	int Index;
	char *Top;
	int Ret;

	Ret = 0;
	if(ConvLineToTableAndIndex(Tbl, Num, &Cur, &Index) == SUCCESS)
		{
			Top = Cur->LineTop[Index];
			MoveToNextTableAndIndex(&Cur, &Index);
			Ret = Cur->LineTop[Index] - Top;
		}
	return(Ret);
}


/*----- sԍŎw肳ꂽs̘_sԍ߂ ------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : sԍ
 *
 *	Return Value
 *		int _sԍ (-1=G[)
 *----------------------------------------------------------------------------*/

int GetLogicalLineNum(FILEMANTBL *Tbl, int Num)
{
	LINETOPTBL *Cur;
	int Index;
	int Ret;

	Ret = -1;
	if(ConvLineToTableAndIndex(Tbl, Num, &Cur, &Index) == SUCCESS)
		Ret = Cur->LineNum[Index];

	return(Ret);
}


/*----- Cӂ̕ʒu炻̂̕s̍sԍ߂ --------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : _sԍ
 *
 *	Return Value
 *		int sԍ (-1=G[)
 *----------------------------------------------------------------------------*/

int GetLineNumFromLogicalLineNum(FILEMANTBL *Tbl, int Num)
{
	LINETOPTBL *Pos;
	LINETOPTBL *Prev;
	int Tmp;
	int Ret;
	int i;

	Ret = 0;
	Tmp = 0;
	Pos = Tbl->LineData;
	Prev = Pos;
	while(Pos != NULL)
		{
			if(Pos->LineNum[0] > Num)
				break;

			Prev = Pos;
			Ret += Tmp;
			Tmp = Pos->Lines;
			Pos = Pos->Next;
		}

	Tmp = -1;
	if(Prev != NULL)
		{
			for(i = 0; i < Prev->Lines; i++)
				{
					if(Num == Prev->LineNum[i])
						{
							Tmp = Ret;
							break;
						}
					Ret++;
				}
		}
	return(Tmp);
}




















/*----- Cӂ̕ʒu炻̂̕s̐擪̃̕AhX߂ ------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *
 *	Return Value
 *		char *ʒu
 *----------------------------------------------------------------------------*/

char *GetLineTopFromAdrs(FILEMANTBL *Tbl, char *Text)
{
	LINETOPTBL *Pos;
	LINETOPTBL *Prev;
	char *Ret;
	int i;

	Ret = NULL;
	Pos = Tbl->LineData;
	Prev = Pos;
	while(Pos != NULL)
		{
			if(Text < Pos->LineTop[0])
				break;

			Prev = Pos;
			Pos = Pos->Next;
		}

	if(Prev != NULL)
		{
			Ret = Prev->LineTop[0];
			for(i = 1; i < Prev->Lines; i++)
				{
					if(Text < Prev->LineTop[i])
						break;

					Ret = Prev->LineTop[i];
				}
		}
	return(Ret);
}


/*----- Cӂ̕ʒu炻̂̕s̍sԍ߂ --------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *
 *	Return Value
 *		int sԍ
 *----------------------------------------------------------------------------*/

int GetLineNumFromAdrs(FILEMANTBL *Tbl, char *Text) // yhatley
	 //static int GetLineNumFromAdrs(FILEMANTBL *Tbl, char *Text)
{
	LINETOPTBL *Pos;
	LINETOPTBL *Prev;
	int Tmp;
	int Ret;
	int i;

	Ret = 0;
	Tmp = 0;
	Pos = Tbl->LineData;
	Prev = Pos;
	while(Pos != NULL)
		{
			if(Text < Pos->LineTop[0])
				break;

			Prev = Pos;
			Ret += Tmp;
			Tmp = Pos->Lines;
			Pos = Pos->Next;
		}

	if(Prev != NULL)
		{
			for(i = 1; i < Prev->Lines; i++)
				{
					if(Text < Prev->LineTop[i])
						break;

					Ret++;
				}
		}
	return(Ret);
}


/*----- sԍs擪ʒuf[^e[uƃe[ũCfbNX߂ --
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : sԍ
 *		LINETOPTBL **Cur : s擪ʒuf[^e[uԂ[N
 *		int *Index : CfbNXԂ[N
 *
 *	Return Value
 *		int Xe[^X
 *			SUCCESS/FAIL
 *----------------------------------------------------------------------------*/

static int ConvLineToTableAndIndex(FILEMANTBL *Tbl, int Num, LINETOPTBL **Cur, int *Index)
{
	int Sts;
	LINETOPTBL *Pos;

	Sts = FAIL;
	Pos = Tbl->LineData;
	while(Pos != NULL)
		{
			if(Num < Pos->Lines)
				{
					*Cur = Pos;
					*Index = Num;
					Sts = SUCCESS;
					break;
				}
			else
				{
					Num -= Pos->Lines;
					Pos = Pos->Next;
				}
		}
	return(Sts);
}


/*----- ̍s̃e[uɈړ ------------------------------------------------
 *
 *	Parameter
 *		LINETOPTBL **Cur : s擪ʒuf[^e[uԂ[N
 *		int *Index : CfbNXԂ[N
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

static void MoveToNextTableAndIndex(LINETOPTBL **Cur, int *Index)
{
	*Index += 1;
	if(*Index >= (*Cur)->Lines)
		{
			if((*Cur)->Next != NULL)
				{
					*Cur = (*Cur)->Next;
					*Index = 0;
				}
		}
	return;
}


/*----- Cӂ̕ʒu̒P̐擪ƖԂ --------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗe[u
 *		char *Text : ʒu
 *		char **Top : P̐擪
 *		char **Btm : P̖
 *
 *	Return Value
 *		int Xe[^X
 *			SUCCESS/FAIL
 *----------------------------------------------------------------------------*/

int AskWordTopAndBtm(FILEMANTBL *Tbl, char *Text, char **Top, char **Btm)
{
	int Find;
	char *LineTop;
	char *LineBtm;
	char *Tmp;
	int Check;

	AskPhysLineTopAndBtm(Tbl, Text, &LineTop, &LineBtm);

	Find = AskCharacterType(Text);

	Tmp = LineTop;
	while(LineTop < Text)
		{
			Check = AskCharacterType(LineTop);
			if((Check == CHAR_ZEN_CHOU) &&
			   ((Find == CHAR_ZEN_HIRA) || (Find == CHAR_ZEN_KATA)))
				Check = Find;

			if(IsSjis(*LineTop) == YES)
				LineTop += 2;
			else
				LineTop++;
			if(Find != Check)
				Tmp = LineTop;
		}
	*Top = Tmp;

	Tmp = LineTop;
	*Btm = LineBtm;
	while(LineTop < LineBtm)
		{
			Check = AskCharacterType(LineTop);
			if((Check == CHAR_ZEN_CHOU) &&
			   ((Find == CHAR_ZEN_HIRA) || (Find == CHAR_ZEN_KATA)))
				Check = Find;

			if(Find != Check)
				{
					*Btm = LineTop;
					break;
				}
			if(IsSjis(*LineTop) == YES)
				LineTop += 2;
			else
				LineTop++;
		}
	return(SUCCESS);
}


/*----- ̎ނԂ ------------------------------------------------------
 *
 *	Parameter
 *		char *Text : ʒu
 *
 *	Return Value
 *		int ̎ (CHAR_xxx / R[h)
 *----------------------------------------------------------------------------*/

static int AskCharacterType(char *Text)
{
	int Ret;
	ushort Ch;

	if(IsSjis(*Text) == NO)
		{
			Ret = CHAR_HAN_ALPHA;
			if((isalpha(*Text) == 0) && (isdigit(*Text) == 0) && (*Text != '_'))
				Ret = *Text;
		}
	else
		{
			Ch = C2INT(*Text, *(Text+1));
			if((Ch >= 0x829F) && (Ch <= 0x82F1))		/* Ђ炪 */
				Ret = CHAR_ZEN_HIRA;
			else if((Ch >= 0x8340) && (Ch <= 0x8396))	/* J^Ji */
				Ret = CHAR_ZEN_KATA;
			else if(Ch == 0x815B)						/*  */
				Ret = CHAR_ZEN_CHOU;
			else if(((Ch >= 0x824F) && (Ch <= 0x829A)) || (Ch == 0x8151))	/* AAt@xbgAA_[C */
				Ret = CHAR_ZEN_ALPHA;
			else if((Ch >= 0x889F) && (Ch <= 0xEAA4))	/*  */
				Ret = CHAR_ZEN_KANJI;
			else
				Ret = CHAR_ZEN_OTHER;
		}
	return(Ret);
}


/*----- Cӂ̕ʒu̘_s̐擪ƖԂ ------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗe[u
 *		char *Text : ʒu
 *		char **Top : P̐擪
 *		char **Btm : P̖
 *
 *	Return Value
 *		int Xe[^X
 *			SUCCESS/FAIL
 *----------------------------------------------------------------------------*/

int AskPhysLineTopAndBtm(FILEMANTBL *Tbl, char *Text, char **Top, char **Btm)
{
	char *Tmp;

	Tmp = Text;
	while((Tmp >= Tbl->TextData) && (*Tmp != '\n'))
		Tmp--;
	*Top = Tmp+1;

	if((*Btm = memchr(*Top, '\n', (Tbl->TextData + Tbl->TextSize) - Text)) == NULL)
		*Btm = Tbl->TextData + Tbl->TextSize;

	return(SUCCESS);
}


/*----- eLXgŜČʃe[u쐬 --------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : ݂̍sԍ
 *		char *Key : L[
 *		int Caps : 啶Aʂ邩ǂ (YES/NO)
 *		int Regexp : K\ (YES/NO)
 *		int ScanDist :  (DIST_xxx)
 *
 *	Return Value
 *		int ݈ʒuȍ~^ȑOōŏɌs̍sԍ
 *----------------------------------------------------------------------------*/

// BM alogrithm Kp by yhatley

int SearchText(FILEMANTBL *Tbl, int Num, uchar *Key, int Caps, int Regexp, int ScanDist)
{
    uchar *Text;
    uchar *Btm;
    int Len;
    FOUNDTBL *Prev;
    FOUNDTBL *Set;
    int Sts;
    int Sjis1st;

    uchar *Pos;
    int mLen;

    int i;
    int bm_skip[UCHAR_MAX+1];
    uchar c, tail, taillow;
    uchar KeyOriginal[FINDSTR_LEN+1];

    if(Regexp == YES)
		RegexInit();

    Sts = FAIL;
    CancelSearchText(Tbl);

    if((Len = strlen(Key)) > 0)
		{
			if(Regexp == YES)
				RegexCompile(Key);
			else {
				for (i = 0; i <= UCHAR_MAX; i++) bm_skip[i] = Len;
				for (i = 0; i < Len - 1; i++)
					if(Caps)
						bm_skip[Key[i]] = Len - 1 - i;
					else
						bm_skip[tolower(Key[i])] = Len - 1 - i;
				tail = Key[Len - 1];
				taillow = tolower(tail);
			}

			Set = NULL;
			Text = Tbl->TextData;
			if(Regexp == NO)
				Btm = Text + Tbl->TextSize - (Len - 1);
			else
				Btm = Text + Tbl->TextSize - 1;

			Sjis1st = NO;
			while(Text < Btm)
				{
					Pos = NULL;
					if(Regexp == NO)
						{
							int j = Len - 1;
							while(Key[j] == Text[j]
								  || (Caps == NO && tolower(Key[j]) == tolower(Text[j])))
								{
									j--;
									if(j == -1) break;
								}
		
							if(j == -1) {
								// 2oCg̃`FbN
								uchar *Ch = GetLineTopFromAdrs(Tbl, Text);
								Sjis1st = NO;
								while(Ch < Text) {
									if(Sjis1st)
										Sjis1st = NO;
									else if(IsSjis(*Ch) == YES)
										Sjis1st = YES;
									Ch++;
								}
								if(!Sjis1st) {
									if(   ( Caps && !_mbsncmp (Text, Key, _mbslen(Key)))
										  || (!Caps && !_mbsnicmp(Text, Key, _mbslen(Key))))
										{
			    
											/*  */
											Pos = Text;
											mLen = Len;
										}
								}
							}
						}
					else
						{
							if(RegexSearch(Text, Btm+1, &Pos, &mLen) == REG_SUCCESS)
								{
									if(mLen < 1)
										{
											Text = Pos + 1;
											continue;
										}
								}
						}

					if(Pos != NULL)
						{

							Text = Pos;

							Tbl->FindStrLen = Len;
							if(Set == NULL)
								{
									if((Set = malloc(sizeof(FOUNDTBL))) != NULL)
										{
											Set->StrNum = 1;
											Set->Find[0].Pos = Text;
											Set->Find[0].Len = mLen;
											Set->Next = NULL;
											Tbl->FoundTbl = Set;
										}
								}
							else if(Set->StrNum == (FOUNDDATAMAX-1))
								{
									Prev = Set;
									if((Set = malloc(sizeof(FOUNDTBL))) != NULL)
										{
											Set->StrNum = 1;
											Set->Find[0].Pos = Text;
											Set->Find[0].Len = mLen;
											Set->Next = NULL;
											Prev->Next = Set;
										}
								}
							else
								{
									Set->Find[Set->StrNum].Pos = Text;
									Set->Find[Set->StrNum].Len = mLen;
									Set->StrNum += 1;
								}
							Sts = SUCCESS;

							Text += mLen;
							Sjis1st = NO;

						}
					else
						{
							if(Regexp == NO) {
								if(Len == 1)
									Text++;
								else {
									if(Caps)
										Text += bm_skip[Text[Len-1]];
									else
										Text += bm_skip[tolower(Text[Len-1])];
								}
							}
							else
								break;
						}
				}
		}

    if(Sts == SUCCESS)
		{
			if(ScanDist == DIST_FORWARD)
				Sts = SearchNextFoundLine(Tbl, Num);
			else
				Sts = SearchPrevFoundLine(Tbl, Num);
		}
    else
		Sts = -1;

    if(Regexp == YES)
		RegexFree();

    return(Sts);
}


/*----- ʃe[u폜 ------------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

void CancelSearchText(FILEMANTBL *Tbl)
{
	FOUNDTBL *Pos;
	FOUNDTBL *Next;

	Pos = Tbl->FoundTbl;
	while(Pos != NULL)
		{
			Next = Pos->Next;
			free(Pos);
			Pos = Next;
		}
	Tbl->FoundTbl = NULL;
	Tbl->FindStrLen = 0;
	strcpy(Tbl->FindStr, "");
	return;
}


/*----- Ō̍sԍԂ --------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : ݂̍sԍ
 *
 *	Return Value
 *		int sԍ
 *----------------------------------------------------------------------------*/

int SearchNextFoundLine(FILEMANTBL *Tbl, int Num)
{
	int Ret;
	LINETOPTBL *Cur;
	int Index;
	char *Pos;
	int mLen;

	Ret = -1;
	if(ConvLineToTableAndIndex(Tbl, Num, &Cur, &Index) == SUCCESS)
		{
			MoveToNextTableAndIndex(&Cur, &Index);
			Pos = Cur->LineTop[Index];

			if((Pos = GetNextFoundPos(Tbl, Pos, &mLen)) != NULL)
				Ret = GetLineNumFromAdrs(Tbl, Pos);
		}
	return(Ret);
}


/*----- ŌO̍sԍԂ --------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		int Num : ݂̍sԍ
 *
 *	Return Value
 *		int sԍ
 *----------------------------------------------------------------------------*/

int SearchPrevFoundLine(FILEMANTBL *Tbl, int Num)
{
	int Ret;
	LINETOPTBL *Cur;
	int Index;
	char *Pos;
	int mLen;

	Ret = -1;
	if(ConvLineToTableAndIndex(Tbl, Num, &Cur, &Index) == SUCCESS)
		{
			//		MoveToNextTableAndIndex(&Cur, &Index);
			Pos = Cur->LineTop[Index];

			if((Pos = GetPrevFoundPos(Tbl, Pos, &mLen)) != NULL)
				Ret = GetLineNumFromAdrs(Tbl, Pos);
		}
	return(Ret);
}


/*----- sĂ邩ǂԂ --------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		int sĂ邩ǂ
 *			YES/NO
 *----------------------------------------------------------------------------*/

int AskSearched(FILEMANTBL *Tbl)
{
	int Sts;

	Sts = NO;
	if(Tbl->FindStrLen > 0)
		Sts = YES;

	return(Sts);
}


/*----- w̕ʒu͈͂ǂԂ --------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *
 *	Return Value
 *		int wʒu܂߈ȍ~Ō
 *			0=Ōł͂Ȃ
 *----------------------------------------------------------------------------*/

int AskCurPosFound(FILEMANTBL *Tbl, char *Text)
{
	FOUNDTBL *Pos;
	int Ret;
	int i;

	Ret = 0;
	if(Tbl->FindStrLen > 0)
		{
			Pos = Tbl->FoundTbl;
			while(Pos != NULL)
				{
					if(Text > Pos->Find[Pos->StrNum-1].Pos)
						{
							if(Text <= (Pos->Find[Pos->StrNum-1].Pos + Pos->Find[Pos->StrNum-1].Len))
								{
									Ret = Pos->Find[Pos->StrNum-1].Len - (Text - Pos->Find[Pos->StrNum-1].Pos);
									break;
								}
							else
								Pos = Pos->Next;
						}
					else
						break;
				}

			if((Ret == 0) && (Pos != NULL))
				{
					for(i = 0; i < Pos->StrNum; i++)
						{
							if((Text >= Pos->Find[i].Pos) &&
							   (Text < (Pos->Find[i].Pos + Pos->Find[i].Len)))
								{
									Ret = Pos->Find[i].Len - (Text - Pos->Find[i].Pos);
									break;
								}
						}
				}
		}
	return(Ret);
}


/*----- ݂̕ʒuȍ~̍ŏ͈̌͂Ԃ ------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *		int *mLen : 
 *
 *	Return Value
 *		char *͈
 *			NULL=Ȃ
 *
 *	Note
 *		ʒu͈͂Ɋ܂
 *----------------------------------------------------------------------------*/

char *GetNextFoundPos(FILEMANTBL *Tbl, char *Text, int *mLen)
{
	FOUNDTBL *Pos;
	char *Ret;
	int i;

	Ret = NULL;
	if(Tbl->FindStrLen > 0)
		{
			Pos = Tbl->FoundTbl;
			while(Pos != NULL)
				{
					if(Text <= Pos->Find[Pos->StrNum-1].Pos)
						break;
					Pos = Pos->Next;
				}

			if(Pos != NULL)
				{
					for(i = 0; i < Pos->StrNum; i++)
						{
							if(Text <= Pos->Find[i].Pos)
								{
									Ret = Pos->Find[i].Pos;
									*mLen = Pos->Find[i].Len;
									break;
								}
						}
				}
		}
	return(Ret);
}


/*----- ݂̕ʒuȑO̍Ō͈̌͂Ԃ ------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *		int *mLen : 
 *
 *	Return Value
 *		char *͈
 *			NULL=Ȃ
 *
 *	Note
 *		ʒu͌ʒuɊ܂܂Ȃ
 *----------------------------------------------------------------------------*/

char *GetPrevFoundPos(FILEMANTBL *Tbl, char *Text, int *mLen)
{
	FOUNDTBL *Pos;
	FOUNDTBL *Prev;
	char *Ret;
	int i;

	Ret = NULL;
	if(Tbl->FindStrLen > 0)
		{
			Pos = Tbl->FoundTbl;
			Prev = NULL;
			while(Pos != NULL)
				{
					if(Text <= Pos->Find[Pos->StrNum-1].Pos)
						break;
					Prev = Pos;
					Pos = Pos->Next;
				}

			if(Pos != NULL)
				{
					for(i = Pos->StrNum-1; i >= 0; i--)
						{
							if(Text > Pos->Find[i].Pos)
								{
									Ret = Pos->Find[i].Pos;
									*mLen = Pos->Find[i].Len;
									break;
								}
						}
				}

			if((Ret == NULL) && (Prev != NULL))
				{
					Ret = Prev->Find[Prev->StrNum-1].Pos;
					*mLen = Prev->Find[Prev->StrNum-1].Len;
				}
		}
	return(Ret);
}


/*----- eLXgŜ̃Agr[ge[u쐬 ----------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		Ȃ
 *
 *	Note
 *		̃p^[`FbN i^H  Ctrl-H \j
 *			_^HA  --- AɃA_[C
 *			A^HA  --- A̋
 *----------------------------------------------------------------------------*/

static void MakeAttributeTable(FILEMANTBL *Tbl)
{
	char *Get;
	char *Put;
	char *Btm;
	char *Prev;
	char *ChAttrTop;
	char *ChAttrBtm;
	int ChkAttr;
	ATTRTBL *PrevTbl;
	ATTRTBL *SetTbl;
	
	RemoveAttributeTable(Tbl);

	/*===== A Ctrl-H Pɂ =====*/

	Get = Tbl->TextData;
	Btm = Get + Tbl->TextSize;
	ChkAttr = NO;
	while((Get = memchr(Get, 0x08, Btm-Get)) != NULL)
		{
			Get++;
			Prev = Get;
			while((Get < Btm) && (*Get == 0x08))
				Get++;
			memmove(Prev, Get, Btm-Get);
			Btm -= (Get - Prev);
			ChkAttr = YES;
		}

	/*===== Agr[g쐬 =====*/
	_RPT1( _CRT_WARN, "make attributes = %d\n", ChkAttr );

	if(ChkAttr == YES)
		{
			_RPT0( _CRT_WARN, "make attributes\n" );
			SetTbl = NULL;

			Get = Tbl->TextData;
			Put = Get;
			Prev = NULL;
			while(Get < Btm)
				{
					if((*Get == 0x08) && (Prev != NULL))	/* Ctrl-H */
						{
							ChAttrTop = Prev;
							ChAttrBtm = NULL;

							/* A_[C̃`FbN */
							ChkAttr = ATTR_UNDER;

							while(((Btm-Get) >= 2) &&
								  (*Get == 0x08) &&
								  (((*Prev == '_') || (*(Get+1) == '_'))))
								{
									Get++;
									if(*Prev == '_')
										{
											Put--;
											if(((Btm-Get) >= 2) && (IsSjis(*Get) == YES))
												*Put++ = *Get++;
											*Put++ = *Get++;
										}
									else
										Get++;

									ChAttrBtm = Put;

									if(Get >= Btm) break;

									if(*Get != 0x08){
										Prev = Put;
										if((IsSjis(*Get) == YES) && ((Btm-Get) >= 2))
											*Put++ = *Get++;
										*Put++ = *Get++;
									}
								}

							if(ChAttrBtm == NULL)
								{
									/* ̃`FbN */
									ChkAttr = ATTR_BOLD;

									while(((Btm-Get) >= 2) &&
										  (*Get == 0x08) &&
										  (*Prev == *(Get+1)))
										{
											if(IsSjis(*Prev) == YES)
												{
													if(((Btm-Get+1) < 2) ||
													   (IsSjis(*(Get+1)) == NO) ||
													   (*(Prev+1) != *(Get+2)))
														{
															break;
														}
													Get++;
												}
											Get += 2;

											ChAttrBtm = Put;

											if(Get >= Btm)
												break;

											if(*Get != 0x08)
												{
													Prev = Put;
													if((IsSjis(*Get) == YES) && ((Btm-Get) >= 2))
														*Put++ = *Get++;
													*Put++ = *Get++;
												}
										}
								}

							if(ChAttrBtm != NULL)
								{
									/* A_[C^e[uɃZbg */
									if(SetTbl == NULL)
										{
											if((SetTbl = malloc(sizeof(ATTRTBL))) != NULL)
												{
													SetTbl->Attr[0].AttrPos = ChAttrTop;
													SetTbl->Attr[0].AttrLen = ChAttrBtm - ChAttrTop;
													SetTbl->Attr[0].AttrData = ChkAttr;
													SetTbl->AttrNum = 1;
													SetTbl->Next = NULL;
													Tbl->AttrData = SetTbl;
												}
										}
									else if(SetTbl->AttrNum == (ATTRDATAMAX-1))
										{
											PrevTbl = SetTbl;
											if((SetTbl = malloc(sizeof(ATTRTBL))) != NULL)
												{
													SetTbl->Attr[0].AttrPos = ChAttrTop;
													SetTbl->Attr[0].AttrLen = ChAttrBtm - ChAttrTop;
													SetTbl->Attr[0].AttrData = ChkAttr;
													SetTbl->AttrNum = 1;
													SetTbl->Next = NULL;
													PrevTbl->Next = SetTbl;
												}
										}
									else
										{
											SetTbl->Attr[SetTbl->AttrNum].AttrPos = ChAttrTop;
											SetTbl->Attr[SetTbl->AttrNum].AttrLen = ChAttrBtm - ChAttrTop;
											SetTbl->Attr[SetTbl->AttrNum].AttrData = ChkAttr;
											SetTbl->AttrNum += 1;
										}
								}
							else
								{
									/* obNXy[XőO̕폜 */
									Put = Prev;
									Get++;
									if(((Btm-Get) >= 2) && (IsSjis(*Get) == YES))
										*Put++ = *Get++;
									*Put++ = *Get++;
								}
						}
					//			else if( IsURL( ){
					//			}
					else
						{
							Prev = Put;
							if(((Btm-Get) >= 2) && (IsSjis(*Get) == YES))
								*Put++ = *Get++;
							*Put++ = *Get++;
						}
				}

			Tbl->TextSize = Put - Tbl->TextData;
		} else if( HighlightURL ){
			// {́łƂȂƃ_
			// łCg@͂Ȃ낤ĂƂŕuI
			SetTbl = NULL;
			Get = Tbl->TextData;
			Put = Get;
			Prev = NULL;

			while(Get < Btm){
				int iLen=0;
				if( IsURL(Get, 1024, &iLen)	){ // 1024͓KD{͉s܂ł̕D
					if(iLen>0)
						{
							/* A_[C^e[uɃZbg */
							if(SetTbl == NULL){
								if((SetTbl = malloc(sizeof(ATTRTBL))) != NULL){
									SetTbl->Attr[0].AttrPos = Get;//ChAttrTop;
									SetTbl->Attr[0].AttrLen = iLen;//ChAttrBtm - ChAttrTop;
									SetTbl->Attr[0].AttrData = ATTR_BOLD|ATTR_UNDER;
									SetTbl->AttrNum = 1;
									SetTbl->Next = NULL;
									Tbl->AttrData = SetTbl;
								}
							}else if(SetTbl->AttrNum == (ATTRDATAMAX-1)){
								PrevTbl = SetTbl;
								if((SetTbl = malloc(sizeof(ATTRTBL))) != NULL)
									{
										SetTbl->Attr[0].AttrPos = Get;//ChAttrTop;
										SetTbl->Attr[0].AttrLen = iLen;//ChAttrBtm - ChAttrTop;
										SetTbl->Attr[0].AttrData = ATTR_BOLD|ATTR_UNDER;
										SetTbl->AttrNum = 1;
										SetTbl->Next = NULL;
										PrevTbl->Next = SetTbl;
									}
							}else{
								SetTbl->Attr[SetTbl->AttrNum].AttrPos = Get;//ChAttrTop;
								SetTbl->Attr[SetTbl->AttrNum].AttrLen = iLen;//ChAttrBtm - ChAttrTop;
								SetTbl->Attr[SetTbl->AttrNum].AttrData = ATTR_BOLD|ATTR_UNDER;
								SetTbl->AttrNum += 1;
							}
						}
					Get+=iLen;
				} else Get++;
			}
		}
	return;
}


/*----- Agr[ge[u폜 ------------------------------------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *
 *	Return Value
 *		Ȃ
 *----------------------------------------------------------------------------*/

static void RemoveAttributeTable(FILEMANTBL *Tbl)
{
	ATTRTBL *Pos;
	ATTRTBL *Next;

	Pos = Tbl->AttrData;
	while(Pos != NULL)
		{
			Next = Pos->Next;
			free(Pos);
			Pos = Next;
		}
	Tbl->AttrData = NULL;
	return;
}


/*----- w̕ʒuɃAgr[gĂ邩ǂԂ --------------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *		int *Len : ʒuȍ~ɃAgr[gĂ邩Ԃ[N
 *		int *Attr : Agr[gԂ[N
 *
 *	Return Value
 *		int ʒuȍ~ɃAgr[gĂ邩
 *			0=Agr[g͂ĂȂ
 *----------------------------------------------------------------------------*/

int AskCurPosAttr(FILEMANTBL *Tbl, char *Text, int *Len, int *Attr)
{
	ATTRTBL *Pos;
	int Ret;
	int i;

	Ret = 0;
	Pos = Tbl->AttrData;
	while(Pos != NULL){
		if(Text > Pos->Attr[Pos->AttrNum-1].AttrPos)
			{
				if(Text <= (Pos->Attr[Pos->AttrNum-1].AttrPos + Pos->Attr[Pos->AttrNum-1].AttrLen))
					{
						Ret = Pos->Attr[Pos->AttrNum-1].AttrLen - (Text - Pos->Attr[Pos->AttrNum-1].AttrPos);
						*Len = Ret;
						*Attr = Pos->Attr[Pos->AttrNum-1].AttrData;
						break;
					}
				else
					Pos = Pos->Next;
			}
		else
			break;
	}

	if((Ret == 0) && (Pos != NULL))
		{
			for(i = 0; i < Pos->AttrNum; i++)
				{
					if((Text >= Pos->Attr[i].AttrPos) &&
					   (Text < (Pos->Attr[i].AttrPos + Pos->Attr[i].AttrLen)))
						{
							Ret = Pos->Attr[i].AttrLen - (Text - Pos->Attr[i].AttrPos);
							*Len = Ret;
							*Attr = Pos->Attr[i].AttrData;
							break;
						}
				}
		}
	/*
	  if( Ret==0 ){
	  int cur = 0;
	  while( 
	  if( IsURL( Text, len, &iLen ) ){
	  }
	  _RPT0( _CRT_WARN, "no attributes\n" );
	  }
	*/
	return(Ret);
}


/*----- ݂̕ʒuȍ~ōŏɃAgr[gĂ͈͂Ԃ --------
 *
 *	Parameter
 *		FILEMANTBL *Tbl : t@CǗf[^
 *		char *Text : ʒu
 *		int *Len : Agr[g̒Ԃ[N
 *		int *Attr : Agr[gԂ[N
 *
 *	Return Value
 *		char *Agr[gJnʒu
 *			NULL=Ȃ
 *----------------------------------------------------------------------------*/

char *GetNextAttrPos(FILEMANTBL *Tbl, char *Text, int *Len, int *Attr)
{
	ATTRTBL *Pos;
	char *Ret;
	int i;

	Ret = NULL;
	*Len = 0;
	*Attr = 0;
	Pos = Tbl->AttrData;
	while(Pos != NULL)
		{
			if(Text <= Pos->Attr[Pos->AttrNum-1].AttrPos)
				break;
			Pos = Pos->Next;
		}

	if(Pos != NULL)
		{
			for(i = 0; i < Pos->AttrNum; i++)
				{
					if(Text <= Pos->Attr[i].AttrPos)
						{
							Ret = Pos->Attr[i].AttrPos;
							*Len = Pos->Attr[i].AttrLen;
							*Attr = Pos->Attr[i].AttrData;
							break;
						}
				}
		}
	return(Ret);
}

// by yhatley
// t@Cǂݍނ
static void ReadToBuffer(FILEMANTBL *CurFile, int TopLine, int Kanji, int KeepSet)
{
    char Buf[MAX_PATH+11];
    CODECONVINFO cInfo;
    int TmpLen;

    if(CurFile != NULL){
		if(CurFile->TextSize > 0){
			//DispFileInfo(CurFile->Fname);
			ExitAllEditor(NO);
			CheckEOLcode(CurFile);

			CurFile->Kanji = CheckKanjiCode(CurFile->TextData, CurFile->TextSize);
			DispKanjiCode(CurFile->Kanji);
			// KȂ̂ŗvC
			if(CurFile->Kanji != CODE_SJIS){
				InitCodeConvInfo(&cInfo);
				cInfo.Str = CurFile->TextData;
				cInfo.StrLen = CurFile->TextSize;
				cInfo.Buf = CurFile->TextData;
				cInfo.BufSize = CurFile->TextSize + BUFFER_MARGIN;
				if(CurFile->Kanji == CODE_JIS) ConvJIStoSJIS(&cInfo);
				else if(CurFile->Kanji == CODE_UTF8) ConvUTF8toSJIS(&cInfo);
				else if(CurFile->Kanji == CODE_UNICODE) ConvUnicodetoSJIS(&cInfo);
				else ConvEUCtoSJIS(&cInfo);
				TmpLen = cInfo.OutLen;

				cInfo.Buf = CurFile->TextData + cInfo.OutLen;
				cInfo.BufSize = CurFile->TextSize - cInfo.OutLen;
				FlushRestData(&cInfo);

				CurFile->TextSize = TmpLen + cInfo.OutLen;
			}
			MakeAttributeTable(CurFile);
		}
    }

	// ̂ւł by yhatley
	//    if(KeepSet == NO)
	//	SetCurExtNum();
	//    LineNum = AskCurExtSet()->LineNumDisp;
    SetFontSize();
    SetCellSize();
    MakeLineTopTbl(CurFile);
    /* E[Ő܂ԂResizeViewWindow()MakeLineTopTbl()s */
	/*
	  if(AskFileExtSet(GetFileExtSetNum(CurFile))->FoldRight == NO)
	  MakeLineTopTbl(CurFile);
	  CalcLineNumWinWidth();
	  ResizeNumWindow();
	  ResizeViewWindow();
	*/
}

void OpenFileOnBuffer(FILEMANTBL *FileTbl, char *Fname)
{
    FILE *Strm;
    long Size;
    int Tmp;

    strcpy(FileTbl->Fname, "");
    FileTbl->ReadFrom = READFROM_NONE;
    FileTbl->Kanji = CODE_AUTO;
    FileTbl->TextData = NULL;
    FileTbl->TextSize = 0;
    FileTbl->TextLines = 0;
    FileTbl->LineData = NULL;
    FileTbl->AttrData = NULL;
    FileTbl->DispTopLine = 0;
    FileTbl->DispTopColumn = 0;
    FileTbl->FindStrLen = 0;
    strcpy(FileTbl->FindStr, "");
    FileTbl->FoundTbl = NULL;
    FileTbl->RgnSelecting = NO;
    FileTbl->RgnStartPos = NULL;
    FileTbl->RgnEndPos = NULL;
    FileTbl->Next = NULL;


    GetLinkTarget(GetMainHwnd(), Fname);
    GetLongFileName(Fname);

    if((Strm = fopen(Fname, "rt")) != NULL){
		fseek(Strm, 0, SEEK_END);
		Size = ftell(Strm);
		fseek(Strm, 0, SEEK_SET);

		strcpy(FileTbl->Fname, Fname);
		if((FileTbl->TextData = malloc(Size + BUFFER_MARGIN)) != NULL){
			FileTbl->TextSize = fread(FileTbl->TextData, 1, Size, Strm);
			FileTbl->ReadFrom = READFROM_FILE;
		}
		fclose(Strm);

		ReadToBuffer(FileTbl, 0, CODE_AUTO, YES);
    }

    return;
}
