/*=============================================================================
*							Xe[^XEChE
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <windowsx.h>
#include <commctrl.h>

#include "common.h"
#include "resource.h"

/*===== [Jȃ[N =====*/

static int SbarColWidth[4] = { 60, 150, 240, -1 };
static HWND hWndSbar = NULL;


/*----- Xe[^XEChE쐬 --------------------------------------------
*
*	Parameter
*		HWND hWnd : eEChẼEChEnh
*
*	Return Value
*		int Xe[^X
*			SUCCESS/FAIL
*----------------------------------------------------------------------------*/

int MakeStatusWindow(HWND hWnd)
{
	int Sts;

	Sts = FAIL;
	hWndSbar = CreateWindowEx(0,
			STATUSCLASSNAME, NULL,
			WS_CHILD | WS_CLIPSIBLINGS | SBARS_SIZEGRIP,
			0, 0, 0, 0,
			hWnd, (HMENU)1500, GetProgInst(), NULL);

	if(hWndSbar != NULL)
	{
		SendMessage(hWndSbar, SB_SETPARTS, sizeof(SbarColWidth)/sizeof(int), (LPARAM)SbarColWidth);
		ShowWindow(hWndSbar, SW_SHOW);
		Sts = SUCCESS;
	}
	return(Sts);
}


/*----- Xe[^XEChẼEChEnhԂ ------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		HWND EChEnh
*----------------------------------------------------------------------------*/

HWND GetStatusWinHwnd(void)
{
	return(hWndSbar);
}


/*----- Xe[^XEChE̍Ԃ --------------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		int 
*----------------------------------------------------------------------------*/

int GetStatusWinHeight(void)
{
	RECT Rect;

	Rect.bottom = 0;
	if(hWndSbar != NULL)
		GetClientRect(hWndSbar, &Rect);

	return(Rect.bottom);
}


/*----- Xe[^XEChẼTCYύX̏ --------------------------------
*
*	Parameter
*		Ȃ
*
*	Return Value
*		Ȃ
*
*	Note
*		CEChEc[o[^Xe[^Xo[r[EChȄ
*		TCYύX邱
*----------------------------------------------------------------------------*/

void ResizeStatusWin(void)
{
	RECT Rect;

	if(hWndSbar != NULL)
	{
		GetClientRect(GetMainHwnd(), &Rect);
		SendMessage(hWndSbar, WM_SIZE, SIZE_RESTORED, MAKELPARAM(Rect.right, Rect.bottom));
	}
	return;
}


/*----- R[h̎ނ\ ------------------------------------------------
*
*	Parameter
*		int Kanji : R[h (CODE_xxx)
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DispKanjiCode(int Kanji)
{
	if(Kanji == CODE_JIS)
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"JIS");
	else if(Kanji == CODE_EUC)
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"EUC");
	else if(Kanji == CODE_UTF8)
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"UTF8");
	else if(Kanji == CODE_UTF7)
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"UTF7");
	else if(Kanji == CODE_UNICODE)
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"Unicode");
	else
		SendMessage(hWndSbar, SB_SETTEXT, 0 | 0, (LPARAM)"SJIS");

	SetKanjiCodeMenu(Kanji);

	return;
}


/*----- sԍ\ ----------------------------------------------------------
*
*	Parameter
*		int Pos : \ʒu
*		int Num : sԍ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DispCurrentLineNum(int Pos, int Num)
{
	char Buf[40];
	FILEMANTBL *CurFile;

	strcpy(Buf, "");
	if((CurFile = AskCurFileTbl()) != NULL)
	{
		if(AskCurExtSet()->LineNumType == LINENUM_WP)
			Num = Num + 1;
		else
			Num = GetLogicalLineNum(CurFile, Num) + 1;

		if(Num <= 0)
			sprintf(Buf, "-----");
		else
			sprintf(Buf, "%ds", Num);
	}
	SendMessage(hWndSbar, SB_SETTEXT, Pos | 0, (LPARAM)Buf);

	return;
}


/*----- t@C\ ----------------------------------------------------
*
*	Parameter
*		char *Fname : t@C
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void DispFileInfo(char *Fname)
{
	char Buf[MAX_PATH+33];
	HANDLE hFind;
	WIN32_FIND_DATA FindBuf;
	SYSTEMTIME sTime;
	FILETIME fTime;

	strcpy(Buf, "");
	if(Fname != NULL)
	{
		if((hFind = FindFirstFile(Fname, &FindBuf)) != INVALID_HANDLE_VALUE)
		{
			FileTimeToLocalFileTime(&FindBuf.ftLastWriteTime, &fTime);
			FileTimeToSystemTime(&fTime, &sTime);
			sprintf(Buf, "%-15s   %04d/%02d/%02d %2d:%02d   %d", 
				FindBuf.cFileName, sTime.wYear, sTime.wMonth, sTime.wDay, sTime.wHour, sTime.wMinute, FindBuf.nFileSizeLow);
			FindClose(hFind);
		}
	}
	SendMessage(hWndSbar, SB_SETTEXT, 3 | 0, (LPARAM)Buf);

	return;
}



